//N+C
#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int MAX_N = 4e3 + 10, MAX_M = 200010;

vector<int> g[MAX_N], tme[MAX_N];

int visited[MAX_N], t[MAX_N];
int cnt = 0, n, m, l;

int dist[MAX_N];

ll dijkstra() {
	deque<int> dq;
	dq.push_back(1);
	for(int i = 1; i <= n; i ++) {
		dist[i] = m;
		t[i] = 0;
	}
	dist[1] = 0;
	t[1] = 1;
	//cout << "Starting " << endl;
	while(!dq.empty()) {
		int curr = dq.front(); dq.pop_front();
		t[curr] = 2;
		//cout << curr << " " << dist[curr] << endl;
		for(int i = 0; i < g[curr].size(); i ++) {
			if(tme[curr][i] < l) {continue;}
			if(dist[g[curr][i]] > max(dist[curr], tme[curr][i])) {
				dist[g[curr][i]] = max(dist[curr], tme[curr][i]);
				if(t[g[curr][i]] == 2) {
					dq.push_front(g[curr][i]);
				} else if(t[g[curr][i]] == 0) {
					dq.push_back(g[curr][i]);
				}
				t[g[curr][i]] = 1;
			} 
		}
	}
	int ans = 0;
	for(int i = 1; i <= n; i ++) {
		//cout << dist[i] << " ";
		ans = max(ans, dist[i]);
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> n >> m;
	for(int i = 0; i < m; i ++) {
		int a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
		tme[a].push_back(i);
		tme[b].push_back(i);
	} 
	ll ans = 0;
	for(l = 0; l < m; l ++) {
		ans += m - dijkstra();
	}
	cout << ans;
	return 0;
}
