//N+C
#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int MAX_N = 5e4 + 10, MAX_M = 200010;
int par[MAX_N], sz[MAX_N], comps;

int find(int x) {
	if(par[x] == x) {return x;}
	return par[x] = find(par[x]);
}

void unite(int x, int y) {
	x = find(x); y = find(y);
	if(x == y) {return;}
	comps --;
	if(sz[x] > sz[y]) {
		sz[x] += sz[y];
		par[y] = x;
	} else {
		sz[y] += sz[x];
		par[x] = y;
	}
}

int n, m;
void reset() {
	for(int i = 1; i <= n; i ++) {
		par[i] = i;
		sz[i] = 1;
	}
	comps = n;
}

int a[MAX_M], b[MAX_M];

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> n >> m;
	for(int i = 0; i < m; i ++) {
		cin >> a[i] >> b[i];
	} 
	int j;
	ll ans = 0;
	for(int i = 0; i < m; i ++) {
		reset();
		//cout << "Starting " << i << endl;
		for(j = i; j < m; j ++) {
			unite(a[j], b[j]);
			//cout << j << " " << a[j] << " " << b[j] << " " << comps << endl;
			if(comps == 1) {break;}
		}
		ans += (ll)(m - j);
	}
	cout << ans;
	return 0;
}
