//N+C
#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int MAX_N = 2e3 + 10, MAX_M = 200010;

vector<int> g[MAX_N], tme[MAX_N];

int sused[MAX_N][MAX_N];
int visited[MAX_N];
int cnt = 0;
int l = 0, r = 0, n, m;

bool connected() {
	if(r - l + 1 < n - 1) {return false;}
	queue<int> q;
	q.push(1);
	int re = 1;
	cnt ++;
	visited[1] = cnt;
	while(!q.empty()) {
		int curr = q.front(); q.pop();
		for(int i = 1; i <= n; i ++) {
			if(visited[i] == cnt || sused[curr][i] == 0) {continue;}
			visited[i] = cnt;
			q.push(i);
			re ++;
		}
	}
	//cout << l << " " << r << " " << re << endl;
	return re == n;
}

int a[MAX_N], b[MAX_N];

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> n >> m;
	for(int i = 0; i < m; i ++) {
		cin >> a[i] >> b[i];
		g[a[i]].push_back(b[i]);
		g[b[i]].push_back(a[i]);
		tme[a[i]].push_back(i);
		tme[b[i]].push_back(i);
	} 
	ll ans = 0;
	l = 0; r = 0;
	sused[a[0]][b[0]] ++;
	sused[b[0]][a[0]] ++;
	while(true) {
		while(r < m && !connected()) {r ++; sused[a[r]][b[r]] ++; sused[b[r]][a[r]] ++; }
		if(r == m) {break;}
		while(connected()) {sused[a[l]][b[l]] --; sused[b[l]][a[l]] --; l ++; ans += m - r;}
	}
	cout << ans;
	return 0;
}
