#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=50002;
const ll MAXM=200002;
ll n,m,par[MAXN],sz[MAXN];
vector<pair<ll,ll> >g[MAXN];
vector<pair<ll,ll> >edges;
ll getRoot(ll u)
{
	if(u==par[u])return u;
	return par[u]=getRoot(par[u]);
}
void join(ll p,ll q)
{
	if(sz[p]>sz[q])
	{
		par[q]=p;
		sz[p]+=sz[q];
	}
	else
	{
		par[p]=q;
		sz[q]+=sz[p];
	}
}
bool vis[MAXN];
ll cnt=0;
void dfs(int u,int minr,int maxr)
{
	vis[u]=1;cnt++;
	for(int i=0;i<g[u].size();i++)
	{
		if(vis[g[u][i].first])continue;
		if(g[u][i].second>=minr&&g[u][i].second<=maxr)
		{
			dfs(g[u][i].first,minr,maxr);
		}
	}
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin>>n>>m;
	ll ans=0;
	for(int i=0;i<m;i++)
	{
		int x,y;
		cin>>x>>y;
		edges.push_back({x,y});
		g[x].push_back({y,i});
		g[y].push_back({x,i});
	}
	for(int i=1;i<=n;i++)
	{
		par[i]=i;
		sz[i]=1;
	}
	int l=0,r=-1;
	for(int i=0;i<m;i++)
	{
		memset(vis,0,sizeof(vis));
		cnt=0;
		dfs(1,0,i);
		//cout<<i<<" "<<cnt<<endl;
		if(cnt==n){r=i;break;}
	}
	if(r==-1)
	{
		cout<<"0\n";
		return 0;
	}
	ans+=m-r;
	for(;;)
	{
		l++;
		if(l==m)break;
		for(;;)
		{
			if(r==m)break;
			memset(vis,0,sizeof(vis));
			cnt=0;
			dfs(1,l,r);
			//cout<<l<<" "<<r<<" "<<cnt<<endl;
			if(cnt==n)
			{
				break;
			}
			r++;
		}
		ans+=m-r;
	}
	cout<<ans<<endl;
return 0;
}
