#include <iostream>
#include <vector>
#include <queue>
using namespace std;
#define endl '\n'
struct Vertex {
    int u, num;
};
vector <Vertex> v[50002];
queue <int> q;
bool used[50002];
int n, m;
int lef, rig;
void bfs(int start) {
    q.push(start);
    int x;
    while (!q.empty()) {
        x=q.front();
        q.pop();
        for (int i=0;i<v[x].size();i++) {
            if (!used[v[x][i].u] && v[x][i].num>=lef && v[x][i].num<=rig) {
                q.push(v[x][i].u);
                used[v[x][i].u]=true;
            }
        }
    }
}
bool connected() {
    for (int i=1;i<=n;i++) used[i]=false;
    bfs(1);
    for (int i=1;i<=n;i++) {
        if (!used[i]) return false;
    }
    return true;
}
int find_edges(int ind) {
    int l, r, mid;
    l=ind; r=m-1;
    lef=ind;
    while (l<=r) {
        mid=(l+r)/2;
        rig=mid;
        if (connected()) r=mid-1;
        else l=mid+1;
    }
    return l;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int a, b;
    cin >> n >> m;
    for (int i=0;i<m;i++) {
        cin >> a >> b;
        v[a].push_back({b,i});
        v[b].push_back({a,i});
    }
    for (int i=1;i<=n;i++) {

    }
    int ans=0;
    for (int i=0;i<m;i++) {
        b=find_edges(i);
        ans+=m-b;
    }
    cout << ans << endl;
    return 0;
}
/**
4 4
1 2
2 4
1 3
1 4
**/
