#include <iostream>
#include <set>
#include <utility>

const int MAXN = 1e5 + 10;

std::set<int> ho[MAXN], ve[MAXN];
std::pair<int, int> points[MAXN];

int answer[3];

int is_out(int x, int y)
{
	auto b = ho[y].begin();
	auto e = ho[y].end();
	e --;
	int ans = (x == *b) || (x == *e);

	b = ve[x].begin();
	e = ve[x].end();
	e --;
	ans += (y == *b) || (y == *e);

	return ans;
}

int main()
{
	std::cin.tie(NULL);
	std::cout.tie(NULL);
	std::ios_base::sync_with_stdio(false);

	int n, nn;
	std::cin >> n;
	nn = n;

	for(int i = 0; i < n; ++ i)
	{
		int a, b;
		std::cin >> a >> b;
		points[i] = {a, b};
		ho[b].insert(a);
		ve[a].insert(b);
	}

	int out = 0, rest = 0;

	for(int i = 0; i < n; ++ i)
	{
		int is = is_out(points[i].first, points[i].second);
		++ answer[is];
	}

	std::cout << answer[2] << ' ' << answer[0] << '\n';

	int q;
	std::cin >> q;

	while(q --)
	{
		int z, x, y;
		std::cin >> z >> x >> y;
		if(z == 1)
		{
			int c = -1, d = -1, e = -1, f = -1;
			if(!ho[y].empty())
			{
				ho[y].insert(x);
				if(ho[y].find(x) == -- ho[y].end())
				{
					c = *(-- ho[y].find(x));
				}else if(ho[y].find(x) == ho[y].begin())
				{
					d = *(++ ho[y].begin());
				}else
				{
					c = *(-- ho[y].find(x));
					d = *(++ ho[y].find(x));
				}
				ho[y].erase(x);
			}

			if(!ve[x].empty())
			{
				ve[x].insert(y);
				if(ve[x].find(y) == -- ve[x].end())
				{
					e = *(-- ve[x].find(y));
				}else if(ve[x].find(y) == ve[x].begin())
				{
					f = *(++ ve[x].begin());
				}else
				{
					e = *(-- ve[x].find(y));
					f = *(++ ve[x].find(y));
				}
				ve[x].erase(y);
			}

			//std::cout << c << ' ' << d << ' ' << e << ' ' << f << '\n';

			if(c != -1)
			{
				-- answer[is_out(c, y)];
			}
			if(d != -1)
			{
				-- answer[is_out(d, y)];
			}
			if(e != -1)
			{
				-- answer[is_out(x, e)];
			}
			if(f != -1)
			{
				-- answer[is_out(x, f)];
			}

			ho[y].insert(x);
			ve[x].insert(y);

			++ answer[is_out(x, y)];
			if(c != -1)
			{
				++ answer[is_out(c, y)];
			}
			if(d != -1)
			{
				++ answer[is_out(d, y)];
			}
			if(e != -1)
			{
				++ answer[is_out(x, e)];
			}
			if(f != -1)
			{
				++ answer[is_out(x, f)];
			}
		}else
		{
			int c = -1, d = -1, e = -1, f = -1;
			if(ho[y].size() != 1)
			{
				if(ho[y].find(x) == -- ho[y].end())
				{
					c = *(-- ho[y].find(x));
				}else if(ho[y].find(x) == ho[y].begin())
				{
					d = *(++ ho[y].begin());
				}else
				{
					c = *(-- ho[y].find(x));
					d = *(++ ho[y].find(x));
				}
			}

			if(ve[x].size() != 1)
			{
				if(ve[x].find(y) == -- ve[x].end())
				{
					e = *(-- ve[x].find(y));
				}else if(ve[x].find(y) == ve[x].begin())
				{
					f = *(++ ve[x].begin());
				}else
				{
					e = *(-- ve[x].find(y));
					f = *(++ ve[x].find(y));
				}
			}

			if(c != -1)
			{
				-- answer[is_out(c, y)];
			}
			if(d != -1)
			{
				-- answer[is_out(d, y)];
			}
			if(e != -1)
			{
				-- answer[is_out(x, e)];
			}
			if(f != -1)
			{
				-- answer[is_out(x, f)];
			}

			-- answer[is_out(x, y)];
			
			ho[y].erase(x);
			ve[x].erase(y);
			
			if(c != -1)
			{
				++ answer[is_out(c, y)];
			}
			if(d != -1)
			{
				++ answer[is_out(d, y)];
			}
			if(e != -1)
			{
				++ answer[is_out(x, e)];
			}
			if(f != -1)
			{
				++ answer[is_out(x, f)];
			}
		}
		std::cout << answer[2] << ' ' << answer[0] << '\n';
	}

	//std::cout << is_out(2, 2) << '\n';

	return 0;
}