#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int N;
vector< pair<int, int> > xx, yy;
map< pair<int, int>, bool> xxx, yyy;

void f()
{
    xxx[make_pair(xx[0].first, xx[0].second)] = true;
    xxx[make_pair(xx[N - 1].first, xx[N - 1].second)] = true;

    for (int i = 1; i < N - 1; ++ i)
    {
        if (xx[i - 1].first == xx[i].first and xx[i].first == xx[i + 1].first) xxx[make_pair(xx[i].first, xx[i].second)] = false;
        else xxx[make_pair(xx[i].first, xx[i].second)] = true;
    }

    int ex = 0, in = 0;

    yyy[make_pair(yy[0].first, yy[0].second)] = true;
    yyy[make_pair(yy[N - 1].first, yy[N - 1].second)] = true;

    if (yyy[make_pair(yy[0].first, yy[0].second)] == true and xxx[make_pair(yy[0].second, yy[0].first)] == true) ex++;
    if (yyy[make_pair(yy[0].first, yy[0].second)] == false and xxx[make_pair(yy[0].second, yy[0].first)] == false) in++;

    if (yyy[make_pair(yy[N - 1].first, yy[N - 1].second)] == true and xxx[make_pair(yy[N - 1].second, yy[N - 1].first)] == true) ex++;
    if (yyy[make_pair(yy[N - 1].first, yy[N - 1].second)] == false and xxx[make_pair(yy[N - 1].second, yy[N - 1].first)] == false) in++;

    for (int i = 1; i < N - 1; ++ i)
    {
        if (yy[i - 1].first == yy[i].first and yy[i].first == yy[i + 1].first) yyy[make_pair(yy[i].first, yy[i].second)] = false;
        else yyy[make_pair(yy[i].first, yy[i].second)] = true;

        if (yyy[make_pair(yy[i].first, yy[i].second)] == true and xxx[make_pair(yy[i].second, yy[i].first)] == true) ex++;
        if (yyy[make_pair(yy[i].first, yy[i].second)] == false and xxx[make_pair(yy[i].second, yy[i].first)] == false) in++;
    }

    cout << ex << " " << in << endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> N;

    int x, y, p;
    for (int i = 0; i < N; ++ i)
    {
        cin >> x >> y;
        p = lower_bound(xx.begin(), xx.end(), make_pair(x, y)) - xx.begin();
        xx.insert(xx.begin() + p, make_pair(x, y));
        p = lower_bound(yy.begin(), yy.end(), make_pair(y, x)) - yy.begin();
        yy.insert(yy.begin() + p, make_pair(y, x));
    }

    f();

    int Q;
    cin >> Q;

    int type;
    for (int i = 0; i < Q; ++ i)
    {
        cin >> type >> x >> y;

        if (type == 1)
        {
            p = lower_bound(xx.begin(), xx.end(), make_pair(x, y)) - xx.begin();
            xx.insert(xx.begin() + p, make_pair(x, y));
            p = lower_bound(yy.begin(), yy.end(), make_pair(y, x)) - yy.begin();
            yy.insert(yy.begin() + p, make_pair(y, x));
            N++;
        }
        else
        {
            p = lower_bound(xx.begin(), xx.end(), make_pair(x, y)) - xx.begin();
            xx.erase(xx.begin() + p);
            p = lower_bound(yy.begin(), yy.end(), make_pair(y, x)) - yy.begin();
            yy.erase(yy.begin() + p);
            N--;
        }

        f();
    }

    return 0;
}
