#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

bool used[MAXN + 5];
vector<int> G[MAXN + 5];

bool DFS(int u, int turn)
{
    used[u] = true;
    bool t;
    if (turn == 1) t = true;
    else t = false;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (!used[G[u][i]])
        {
            if (turn == 1) t = (t & DFS(G[u][i], (turn + 1) % 2));
            else t = (t | DFS(G[u][i], (turn + 1) % 2));
        }
        if (turn == 1 and t == false) break;
        if (turn == 0 and t == true) break;
    }
    used[u] = false;
    return t;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int N, M;
    cin >> N >> M;

    for (int i = 0; i < M; ++ i)
    {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 1; i <= N; ++ i)
        cout << DFS(i, 1);
    cout << endl;

    return 0;
}
