#include <iostream>
#include <cstring>
#include <utility>
#include <cstdio>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

bool used[MAXN + 5];
vector<int> G[MAXN + 5];

bool DFS(int u, int turn)
{
    used[u] = true;
    bool t;
    if (turn == 1) t = true;
    else t = false;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (!used[G[u][i]])
        {
            if (turn == 1) t = (t & DFS(G[u][i], (turn + 1) % 2));
            else t = (t | DFS(G[u][i], (turn + 1) % 2));
        }
        if (turn == 1 and t == false) break;
        if (turn == 0 and t == true) break;
    }
    return t;
}

int main()
{
    int N, M;
    scanf("%d%d", &N, &M);

    for (int i = 0; i < M; ++ i)
    {
        int u, v;
        scanf("%d%d", &u, &v);
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 1; i <= N; ++ i)
    {
        memset(used, false, sizeof(used));
        printf("%d", DFS(i, 1));
    }
    printf("\n");

    return 0;
}
