
///perfectly balanced binary tree

#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#define NODES 100000
using namespace std;
vector <int> graph[NODES];
queue <int> q;
bool cnt[NODES], win[NODES], used[NODES];
int main()
{
    int n, m, a, b, curr, cntBr=0, qFront;
    cin>>n>>m;
    for (int i=0; i<m; i++){
        cin>>a>>b;
        a--;
        b--;
        cnt[a]=!cnt[a];
        cnt[b]=!cnt[b];

        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    for (int i=0; i<n; i++){
        if (cnt[i]) cntBr++;
    }
    if (cntBr==2){
        if (n%2==0){
            for (int i=0; i<n; i++) cout<<"0";
        }
        else {
            for (int i=0; i<n; i++){
                if (cnt[i]){
                    curr=i;
                    //cout<<curr<<endl;
                    break;
                }
            }
            for (int i=0; i<n; i++){
                used[curr]=true;
                if (i%2==0) win[curr]=true;
                for (int j=0; j<graph[curr].size(); j++){
                    if (!used[graph[curr][j]]){
                        curr=graph[curr][j];
                        //cout<<curr<<endl;
                        break;
                    }
                }
            }
        }
    }
    else {
        for (int i=0; i<n; i++){
            if (!cnt[i]){
                curr=i;
                break;
            }
        }
        if ((int)(log2(n+1))%2==0) win[curr]=false;
        else win[curr]=true;
        q.push(curr);
        while (q.size()!=0){
            qFront=q.front();
            used[qFront]=true;
            for (int i=0; i<graph[qFront].size(); i++){
                if (!used[graph[qFront][i]]){
                    q.push(graph[qFront][i]);
                    win[graph[qFront][i]]=!win[qFront];
                }
            }
            q.pop();
        }
    }
    for (int i=0; i<n; i++){
        if (win[i]) cout<<"1";
        else cout<<"0";
    }
    cout<<endl;

    return 0;
}
/**
7 6
2 7
7 6
6 1
1 4
4 3
3 5
------------
15 14
1 2
1 3
2 4
2 5
3 6
3 7
4 8
4 9
5 10
5 11
6 12
6 13
7 14
7 15
*/
