#include<iostream>
#include<vector>
#include<queue>
#include<utility>
#include<cstring>
#define endl "\n"

using namespace std;

struct ludo
{
    int ver, pos;
    ludo() { }
    ludo(int ver, int pos) :ver(ver), pos(pos) { }
};

const int N_max=200001;
vector<int> v[N_max];
bool used[N_max];
int n, m;
bool ans[N_max];

bool dfs(int i, int cnt)
{
    bool l, ans, lamp=0, in=0;
    if(cnt%2==1) ans=1;
    else ans=0;
    used[i]=1;
    for(int j=0; j<v[i].size(); ++j)
    {
        if(!used[v[i][j]])
        {
            in=1;
            l=dfs(v[i][j], cnt+1);
            if(cnt%2==1&&l==0) lamp=1;
            if(cnt%2==0&&l==1) lamp=1;
            //cout<<v[i][j]<<"="<<l<<endl;
        }
    }
    if(!in)
    {
        //cout<<i<<"="<<cnt%2<<endl;
        return cnt%2;
    }
    if(lamp)
    {
        if(cnt%2==1) return 0;
        else return 1;
    }
    else return ans;
}

void bfs(int s)
{
    ludo w;
    int nb;
    queue<ludo> q;
    q.push(ludo(s, 1));
    while(!q.empty())
    {
        w=q.front();
        q.pop();
        used[w.ver]=1;

        if((n-w.pos+1)%2==1&&w.pos%2==1) ans[w.ver]=1;
        else ans[w.ver]=0;

        for(int i=0; i<(int)v[w.ver].size(); ++i)
        {
            nb=v[w.ver][i];
            if(!used[nb]) q.push(ludo(nb, w.pos+1));
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int x, y, s;
    cin>>n>>m;
    for(int i=0; i<m; ++i)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for(int i=1; i<=n; ++i)
    {
        memset(used, 0, sizeof(used));
        cout<<dfs(i, 1);
    }
    //bfs(s);
    //for(int i=1; i<=n; ++i) cout<<ans[i];
    cout<<endl;
    return 0;
}
/*
5 4
1 2
1 3
2 4
3 5
*/
/*
11 10
4 2
2 5
2 1
1 3
4 6
6 8
8 7
8 9
7 10
10 11
*/
