#include<iostream>
#include<vector>
#include<queue>
#include<utility>
#include<cstring>
#define endl "\n"

using namespace std;

struct ludo
{
    int ver, pos;
    ludo() { }
    ludo(int ver, int pos) :ver(ver), pos(pos) { }
};

const int N_max=100001;
vector<int> v[N_max];
pair<int, int> p;
bool used[N_max];
int n, m;
bool ans[N_max];

void bfs(int s)
{
    bool l;
    ludo w;
    int nb;
    queue<ludo> q;
    q.push(ludo(s, 1));
    while(!q.empty())
    {
        w=q.front();
        q.pop();
        used[w.ver]=1;
        l=0;
        if((n-w.pos+1)%2==1&&w.pos%2==1) ans[w.ver]=1;
        else ans[w.ver]=0;
        //cout<<w.pos<<endl;
        for(int i=0; i<(int)v[w.ver].size(); ++i)
        {
            nb=v[w.ver][i];
            if(!used[nb]) l=1, q.push(ludo(nb, w.pos+1));
        }
        if(!l)
        {
            //cout<<s<<"="<<w.pos<<endl;
            if(p.first==0) p.first=w.pos;
            else p.second=w.pos;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int x, y, s;
    cin>>n>>m;
    for(int i=0; i<m; ++i)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for(int i=1; i<=n; ++i) if((int)v[i].size()==1)
    {
        s=i;
        break;
    }
    bfs(s);
    /*for(int i=1; i<=n; ++i)
    {
        p.first=0, p.second=0;
        memset(used, 0, sizeof(used));
        bfs(i);
        if(p.second==0) p.second=1;
        //cout<<p.first<<" "<<p.second<<endl;
        if(p.first%2==1&&p.second%2==1) cout<<1;
        else cout<<0;
    }*/
    for(int i=1; i<=n; ++i) cout<<ans[i];
    cout<<endl;
    return 0;
}
/*
5 4
1 2
1 3
2 4
3 5
*/
