#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <bitset>

using namespace std;

const int N = 1e5 + 7;

set < pair < int, int > > lin[N], col[N];///pair < y, id >
bitset < 3 * N > linup, lindn, colup, coldn;
int liber(0), blocat(0);
int num(0);///la fiecare ii dam un id
map < pair < int, int >, int > idassign;

void AddLine(int x, int y, int id) {
    auto after = lin[x].lower_bound({y, id});
    auto before = after;
    if (before != lin[x].begin()) {
        before--;
        if (!lindn[before->second]) {
            bool ok((!lindn[before->second] | !linup[before->second]) && (!colup[before->second] | !coldn[before->second]));///daca era free si acum nu mai e
            lindn[before->second] = 1;
            if (ok && (!((!lindn[before->second] | !linup[before->second]) && (!colup[before->second] | !coldn[before->second]))))
                --liber;
            blocat += (lindn[before->second] && linup[before->second] && colup[before->second] && coldn[before->second]);///daca a devenit blocat
        }
        linup[id] = 1;
    }
    if (after != lin[x].end()) {
        if (!linup[after->second]) {
            bool ok((!lindn[after->second] | !linup[after->second]) && (!colup[after->second] | !coldn[after->second]));
            linup[after->second] = 1;
            if (ok && (!((!lindn[after->second] | !linup[after->second]) && (!colup[after->second] | !coldn[after->second]))))
                --liber;
            blocat += (lindn[after->second] && linup[after->second] && colup[after->second] && coldn[after->second]);
        }
        lindn[id] = 1;
    }
    lin[x].insert({y, id});
}

void AddColumn(int x, int y, int id) {
    auto after = col[x].lower_bound({y, id});
    auto before = after;
    if (before != col[x].begin()) {
        before--;
        if (!coldn[before->second]) {
            bool ok((!lindn[before->second] | !linup[before->second]) && (!colup[before->second] | !coldn[before->second]));
            coldn[before->second] = 1;
            if (ok && (!((!lindn[before->second] | !linup[before->second]) && (!colup[before->second] | !coldn[before->second]))))
                --liber;
            blocat += (lindn[before->second] && linup[before->second] && colup[before->second] && coldn[before->second]);
        }
        colup[id] = 1;
    }
    if (after != col[x].end()) {
        if (!colup[after->second]) {
            bool ok((!lindn[after->second] | !linup[after->second]) && (!colup[after->second] | !coldn[after->second]));
            colup[after->second] = 1;
            if (ok && (!((!lindn[after->second] | !linup[after->second]) && (!colup[after->second] | !coldn[after->second]))))
                --liber;
            blocat += (lindn[after->second] && linup[after->second] && colup[after->second] && coldn[after->second]);
        }
        coldn[id] = 1;
    }
    col[x].insert({y, id});
}

void DelLine(int x, int y, int id) {
    lin[x].erase({y, id});
    auto after = lin[x].lower_bound({y, id});
    auto before = after;
    bool isbef(before != lin[x].begin());
    bool isaft(after != lin[x].end());
    if (isbef) {
        before--;
        if (!isaft) {
            bool ok(0);///daca nu era free si acum e
            ok = (!((!lindn[before->second] | !linup[before->second]) && (!colup[before->second] | !coldn[before->second])));
            blocat -= (lindn[before->second] && linup[before->second] && colup[before->second] && coldn[before->second]);///daca era blocat si acum evident nu mai e
            lindn[before->second] = 0;
            if (ok && ((!lindn[before->second] | !linup[before->second]) && (!colup[before->second] | !coldn[before->second])))
                ++liber;
        }
    }
    if (isaft) {
        if (!isbef) {
            bool ok(!((!lindn[after->second] | !linup[after->second]) && (!colup[after->second] | !coldn[after->second])));
            blocat -= (lindn[after->second] && linup[after->second] && colup[after->second] && coldn[after->second]);
            linup[after->second] = 0;
            if (ok && ((!lindn[after->second] | !linup[after->second]) && (!colup[after->second] | !coldn[after->second])))
                ++liber;
        }
    }
}

void DelColumn(int x, int y, int id) {
    col[x].erase({y, id});
    auto after = col[x].lower_bound({y, id});
    auto before = after;
    bool isbef(before != col[x].begin());
    bool isaft(after != col[x].end());
    if (isbef) {
        before--;
        if (!isaft) {
            bool ok(!((!lindn[before->second] | !linup[before->second]) && (!colup[before->second] | !coldn[before->second])));
            blocat -= (lindn[before->second] && linup[before->second] && colup[before->second] && coldn[before->second]);
            coldn[before->second] = 0;
            if (ok && ((!lindn[before->second] | !linup[before->second]) && (!colup[before->second] | !coldn[before->second])))
                ++liber;
        }
    }
    if (isaft) {
        if (!isbef) {
            bool ok(!((!lindn[after->second] | !linup[after->second]) && (!colup[after->second] | !coldn[after->second])));
            blocat -= (lindn[after->second] && linup[after->second] && colup[after->second] && coldn[after->second]);
            colup[after->second] = 0;
            if (ok && ((!lindn[after->second] | !linup[after->second]) && (!colup[after->second] | !coldn[after->second])))
                ++liber;
        }
    }
}

int main()
{
    int n, x, y, q, type;
    cin >> n;
    while (n--) {
        cin >> x >> y;
        idassign[{x, y}] = ++num;
        AddLine(x, y, num);
        AddColumn(y, x, num);
        ///vedem daca e blocat sau liber sau altceva
        blocat += (linup[num] & lindn[num] & colup[num] & coldn[num]);
        liber += (!linup[num] | !lindn[num]) & (!colup[num] | !coldn[num]);
//        fout << liber << ' ' << blocat << '\n';
    }
    cout << liber << ' ' << blocat << '\n';
    cin >> q;
    while (q--) {
        cin >> type >> x >> y;
        if (type - 1) {
            int is = idassign[{x, y}];
            blocat -= (linup[num] & lindn[num] & colup[num] & coldn[num]);
            liber -= (linup[num] | lindn[num]) & (colup[num] | coldn[num]);
            DelLine(x, y, is);
            DelColumn(y, x, is);
        }
        else {
            idassign[{x, y}] = ++num;
            AddLine(x, y, num);
            AddColumn(y, x, num);
            ///vedem daca e blocat sau liber sau altceva
            blocat += (linup[num] & lindn[num] & colup[num] & coldn[num]);
            liber += (linup[num] | lindn[num]) & (colup[num] | coldn[num]);
        }
        cout << liber << ' ' << blocat << '\n';
    }
    return 0;
}
