#include <iostream>
#include <fstream>
#include <set>

using namespace std;

set < pair < int, int > > s;

void compute() {
    int liber(0), blocat(0);
    for (auto i : s) {
        bool fup(0), fdn(0), sup(0), sdn(0);
        for (auto j : s) {
            if (i == j)
                continue;
            if (i.first == j.first) {
                fup |= (i.second < j.second);
                fdn |= (i.second > j.second);
            }
            if (i.second == j.second) {
                sup |= (i.first < j.first);
                sdn |= (i.first > j.first);
            }
        }
        if ((!fup | !fdn) & (!sup | !sdn))
            ++liber;
        if (fdn & fup & sup & sdn)
            ++blocat;
    }
    cout << liber << ' ' << blocat << '\n';
}

int main()
{
    int n, x, y, q, type;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        s.insert({x, y});
    }
    compute();
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> type >> x >> y;
        if (type - 1)
            s.erase({x, y});
        else
            s.insert({x, y});
        compute();
    }
    return 0;
}
