#include <bits/stdc++.h>
//#include <iostream>
//#include <fstream>
//#include <set>
//#include <map>
//#include <bitset>
//#include <random>

using namespace std;

mt19937 rnd((long long)(new char));

const int N = 1e5 + 7;

set < pair < int, int > > lin[N], col[N];///pair < y, id >
bool lindn[3 * N], linup[3 * N], coldn[3 * N], colup[3 * N];
int liber(0), blocat(0);
int num(0);///la fiecare ii dam un id
map < pair < int, int >, int > idassign;

namespace Brut {

    void Generate() {
        ofstream fout("input.txt");
        int n = 10;

        fout << n << '\n';

        set < pair < int, int > > puncte;

        for (int i = 0; i < 10; ++i) {
            int x = rnd() % 10 + 1, y = rnd() % 10 + 1;
            while (puncte.find({x, y}) != puncte.end())
                x = rnd() % 10 + 1, y = rnd() % 10 + 1;
            puncte.insert({x, y});
            fout << x << ' ' << y << '\n';
        }

        vector < pair < int, int > > v;

        for (auto i : puncte)
            v.push_back({i.first, i.second});
        random_shuffle(v.begin(), v.end());

        fout << n << '\n';

        for (auto i : v)
            fout << "2 " << i.first << ' ' << i.second << '\n';
    }

    set < pair < int, int > > s;

    void Solve()
    {
        ifstream fin("input.txt");
        ofstream fout("outputbrut.out");
        int n, x, y, q, type;
        fin >> n;
        for (int i = 0; i < n; ++i) {
            fin >> x >> y;
            s.insert({x, y});
        }
        int liber(0), blocat(0);
        for (auto i : s) {
            bool fup(0), fdn(0), sup(0), sdn(0);
            for (auto j : s) {
                if (i == j)
                    continue;
                if (i.first == j.first) {
                    fup |= (i.second < j.second);
                    fdn |= (i.second > j.second);
                }
                if (i.second == j.second) {
                    sup |= (i.first < j.first);
                    sdn |= (i.first > j.first);
                }
            }
            if ((!fup | !fdn) & (!sup | !sdn))
                ++liber;
            if (fdn & fup & sup & sdn)
                ++blocat;
        }
        fout << liber << ' ' << blocat << '\n';
        fin >> q;
        for (int i = 0; i < q; ++i) {
            fin >> type >> x >> y;
            if (type - 1)
                s.erase({x, y});
            else
                s.insert({x, y});
            int liber(0), blocat(0);
            for (auto i : s) {
                bool fup(0), fdn(0), sup(0), sdn(0);
                for (auto j : s) {
                    if (i == j)
                        continue;
                    if (i.first == j.first) {
                        fup |= (i.second < j.second);
                        fdn |= (i.second > j.second);
                    }
                    if (i.second == j.second) {
                        sup |= (i.first < j.first);
                        sdn |= (i.first > j.first);
                    }
                }
                if ((!fup | !fdn) & (!sup | !sdn))
                    ++liber;
                if (fdn & fup & sup & sdn)
                    ++blocat;
            }
            fout << liber << ' ' << blocat << '\n';
        }
        fout << endl;
        return;
    }

    bool Check() {
        ifstream finbun("outputbun.out");
        ifstream finbrut("outputbrut.out");

        int x1, y1, x2, y2;

        while (finbun >> x1) {
            finbun >> y1;
            finbrut >> x2;
            finbrut >> y2;
            if (x1 != x2 || y1 != y2)
                return 0;
        }
        return 1;
    }

}

void AddLine(int x, int y, int id) {
    auto after = lin[x].lower_bound({y, id});
    auto before = after;
    bool isbef(before != lin[x].begin()), isaft(after != lin[x].end());
    if (isbef) {
        if (!isaft) {
            before--;
            ///daca era free si acum nu mai e
            bool ok((!linup[before->second] | !lindn[before->second]) && (!coldn[before->second] | !colup[before->second]));
            linup[before->second] = 1;
            if (ok && (!((!linup[before->second] | !lindn[before->second]) && (!coldn[before->second] | !colup[before->second]))))
                --liber;
            ///daca a devenit blocat
            blocat += (linup[before->second] && lindn[before->second] && coldn[before->second] && colup[before->second]);
        }
        lindn[id] = 1;
    }
    if (isaft) {
        if (!isbef) {
            bool ok((!linup[after->second] | !lindn[after->second]) && (!coldn[after->second] | !colup[after->second]));
            lindn[after->second] = 1;
            if (ok && (!((!linup[after->second] | !lindn[after->second]) && (!coldn[after->second] | !colup[after->second]))))
                --liber;
            blocat += (linup[after->second] && lindn[after->second] && coldn[after->second] && colup[after->second]);
        }
        linup[id] = 1;
    }
    lin[x].insert({y, id});
}

void AddColumn(int x, int y, int id) {
    auto after = col[x].lower_bound({y, id});
    auto before = after;
    bool isbef(before != col[x].begin()), isaft(after != col[x].end());
    if (isbef) {
        if (!isaft) {
            before--;
            bool ok((!linup[before->second] | !lindn[before->second]) && (!coldn[before->second] | !colup[before->second]));
            colup[before->second] = 1;
            if (ok && (!((!linup[before->second] | !lindn[before->second]) && (!coldn[before->second] | !colup[before->second]))))
                --liber;
            blocat += (linup[before->second] && lindn[before->second] && coldn[before->second] && colup[before->second]);
        }
        coldn[id] = 1;
    }
    if (isaft) {
        if (!isbef) {
            bool ok((!linup[after->second] | !lindn[after->second]) && (!coldn[after->second] | !colup[after->second]));
            coldn[after->second] = 1;
            if (ok && (!((!linup[after->second] | !lindn[after->second]) && (!coldn[after->second] | !colup[after->second]))))
                --liber;
            blocat += (linup[after->second] && lindn[after->second] && coldn[after->second] && colup[after->second]);
        }
        colup[id] = 1;
    }
    col[x].insert({y, id});
}

void DelLine(int x, int y, int id) {
    lin[x].erase({y, id});
    auto after = lin[x].lower_bound({y, id});
    auto before = after;
    bool isbef(before != lin[x].begin());
    bool isaft(after != lin[x].end());
    if (isbef) {
        if (!isaft) {
            before--;
            ///daca nu era free si acum e
            bool ok(!((!linup[before->second] | !lindn[before->second]) && (!coldn[before->second] | !colup[before->second])));
            ///daca era blocat si acum evident nu mai e
            blocat -= (linup[before->second] && lindn[before->second] && coldn[before->second] && colup[before->second]);
            linup[before->second] = 0;
            if (ok && ((!linup[before->second] | !lindn[before->second]) && (!coldn[before->second] | !colup[before->second])))
                ++liber;
        }
    }
    if (isaft) {
        if (!isbef) {
            bool ok(!((!linup[after->second] | !lindn[after->second]) && (!coldn[after->second] | !colup[after->second])));
            blocat -= (linup[after->second] && lindn[after->second] && coldn[after->second] && colup[after->second]);
            lindn[after->second] = 0;
            if (ok && ((!linup[after->second] | !lindn[after->second]) && (!coldn[after->second] | !colup[after->second])))
                ++liber;
        }
    }
}

void DelColumn(int x, int y, int id) {
    col[x].erase({y, id});
    auto after = col[x].lower_bound({y, id});
    auto before = after;
    bool isbef(before != col[x].begin());
    bool isaft(after != col[x].end());
    if (isbef) {
        if (!isaft) {
            before--;
            bool ok(!((!linup[before->second] | !lindn[before->second]) && (!coldn[before->second] | !colup[before->second])));
            blocat -= (linup[before->second] && lindn[before->second] && coldn[before->second] && colup[before->second]);
            colup[before->second] = 0;
            if (ok && ((!linup[before->second] | !lindn[before->second]) && (!coldn[before->second] | !colup[before->second])))
                ++liber;
        }
    }
    if (isaft) {
        if (!isbef) {
            bool ok(!((!linup[after->second] | !lindn[after->second]) && (!coldn[after->second] | !colup[after->second])));
            blocat -= (linup[after->second] && lindn[after->second] && coldn[after->second] && colup[after->second]);
            coldn[after->second] = 0;
            if (ok && ((!linup[after->second] | !lindn[after->second]) && (!coldn[after->second] | !colup[after->second])))
                ++liber;
        }
    }
}

void Solve() {
    ifstream fin("input.txt");
    ofstream fout("outputbun.out");
    int n, x, y, q, type;
    cin >> n;
    while (n--) {
        cin >> x >> y;
        idassign[{x, y}] = ++num;
        AddLine(x, y, num);
        AddColumn(y, x, num);
        ///vedem daca e blocat sau liber sau altceva
        blocat += (lindn[num] & linup[num] & coldn[num] & colup[num]);
        liber += (!lindn[num] | !linup[num]) & (!coldn[num] | !colup[num]);
//        cout << liber << ' ' << blocat << '\n';
    }
    cout << liber << ' ' << blocat << '\n';
    cin >> q;
    while (q--) {
        cin >> type >> x >> y;
        if (type - 1) {
            int is = idassign[{x, y}];
            blocat -= (lindn[is] & linup[is] & coldn[is] & colup[is]);
            liber -= (!lindn[is] | !linup[is]) & (!coldn[is] | !colup[is]);
            DelLine(x, y, is);
            DelColumn(y, x, is);
        }
        else {
            idassign[{x, y}] = ++num;
            AddLine(x, y, num);
            AddColumn(y, x, num);
            ///vedem daca e blocat sau liber sau altceva
            blocat += (lindn[num] & linup[num] & coldn[num] & colup[num]);
            liber += (!lindn[num] | !linup[num]) & (!coldn[num] | !colup[num]);
        }
        cout << liber << ' ' << blocat << '\n';
    }
    cout << endl;
    return;
}

int main()
{
    while (0) {
        Brut::Generate();
        Solve();
        Brut::Solve();
        if (Brut::Check())
            cout << "AC ";
        else
            return 0;
    }
    Solve();
}
