#pragma GCC optimize("Ofast")
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

const int N = 5e5 + 7;

vector < bool > dp[N];
vector < bool > viz[N];///daca am trecut prim starea rspectiva din dp
vector < int > adia[N];
vector < int > unde[N];///unde te plasezi tu in aidacenta nodului  tau vecin

///dp[nod][i] = pt i != adia[nod].size() : cand esti in subarborele nod si ai tatal adia[nod][i]
///             pt i = adia[nod].size() : dinamica cand esti in subarborele nod si esti radacina

bool calc_dp(int nod, int i) {
    if (viz[nod][i])
        return dp[nod][i];
    viz[nod][i] = 1;
    for (int next = 0; next < adia[nod].size(); ++next) {
        if (next == i)
            continue;
        dp[nod][i] = (dp[nod][i] | (!calc_dp(adia[nod][next], unde[nod][next])));
    }
    return dp[nod][i];
}

int main()
{
    int n, m, a, b;
    cin >> n >> m;
    while (m--) {
        cin >> a >> b;
        unde[a].push_back(adia[b].size());
        unde[b].push_back(adia[a].size());
        adia[a].push_back(b);
        adia[b].push_back(a);
    }
    for (int i = 1; i <= n; ++i)
        dp[i].resize(adia[i].size() + 1), viz[i].resize(adia[i].size() + 1);
    for (int i = 1; i <= n; ++i)
        cout << !calc_dp(i, adia[i].size());
    return 0;
}
