#include <iostream>
#include <set>

using namespace std;

const int N = 50000 + 7;
const int M = 200000 + 7;
int n;
int m;
int x[M];
int y[M];

int t[N];

void rst()
{
    for (int i = 1; i <= n; i++)
    {
        t[i] = i;
    }
}

int get(int a)
{
    if (t[a] == a)
    {
        return a;
    }
    else
    {
        return t[a] = get(t[a]);
    }
}

void unite(int a, int b)
{
    a = get(a);
    b = get(b);
    t[a] = b;
}

bool conex(int i, int j)
{
    rst();
    for (int k = i; k <= j; k++)
    {
        unite(x[k], y[k]);
    }
    int cnt = 0;
    for (int k = 1; k <= n; k++)
    {
        cnt += (get(k) == k);
    }
    return (cnt == 1);
}

int get(int i, int l, int r)
{
    int ans = 0;
    while (l <= r)
    {
        int mid = (l + r) / 2;
        if (conex(i, mid))
        {
            ans = n - mid + 1;
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }
    return ans;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        cin >> x[i] >> y[i];
    }

    if (n <= 2000)
    {
        int ans = 0;
        for (int i = 1; i <= m; i++)
        {
            ans += get(i, i, m);
        }
        cout << ans << "\n";
    }


}
