#include <iostream>

using namespace std;

const int N = 50000 + 7;
const int M = 200000 + 7;

int dir[N];

int par(int a)
{
    if (dir[a] == a)
    {
        return a;
    }
    else
    {
        return dir[a] = par(dir[a]);
    }
}

bool unite(int a, int b)
{
    a = par(a);
    b = par(b);
    if (a != b)
    {
        dir[a] = b;
        return 1;
    }
    else
    {
        return 0;
    }
}

int n;
int m;
int x[M];
int y[M];

bool conex(int i, int j)
{
    int cnt = 0;
    for (int k = 1; k <= n; k++)
    {
        dir[k] = k;
    }
    for (int k = i; k <= j; k++)
    {
        cnt += unite(x[k], y[k]);
    }
    return (cnt == (n - 1));
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        cin >> x[i] >> y[i];
    }
    int ans = 0;
    for (int i = 1; i <= m; i++)
    {
        int l = i, r = m, adun = 0;
        while (l <= r)
        {
            int mid = (l + r) / 2;
            if (conex(i, mid))
            {
                adun = m - mid + 1;
                r = mid - 1;
            }
            else
            {
                l = mid + 1;
            }
        }
        ans += adun;
    }
    cout << ans << "\n";
}
