#include <iostream>
#include <queue>

using namespace std;

const int N = 2000 + 7;
const int M = 200000 + 7;

int n;
int m;
int x[M];
int y[M];
int f[N][N];
int ans = 0;
bool cnx;
bool u[N];

bool conex()
{
    for (int i = 1; i <= n; i++)
    {
        u[i] = 0;
    }
    queue<int> q;
    q.push(1);
    u[1] = 1;
    int cnt = 1;
    while (!q.empty())
    {
        int a = q.front();
        q.pop();
        for (int b = 1; b <= n; b++)
        {
            if (u[b] == 0 && f[a][b])
            {
                cnt++;
                q.push(b);
                u[b] = 1;
            }
        }
    }
    return (cnt == n);
}

void add(int i)
{
    int a = x[i];
    int b = y[i];
    if (f[a][b] == 0)
    {
        cnx = conex();
    }
    f[a][b]++;
    f[b][a]++;
}

void del(int i)
{
    int a = x[i];
    int b = y[i];
    if (f[a][b] == 1)
    {
        cnx = conex();
    }
    f[a][b]--;
    f[b][a]--;
}


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        cin >> x[i] >> y[i];
    }
    int ans = 0, last = 0;
    for (int i = 1; i <= m; i++)
    {
        while (last <= m && (cnx == 0))
        {
            last++;
            add(last);
        }
        if (last > m)
        {
            break;
        }
        del(i);
        ans += m + 1 - last;
    }
    cout << ans << "\n";
}
