#include <iostream>
#include <deque>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int) 2e5 + 7;
int n;
int m;
vector<int> g[N];
int dp[N];
int dp_down[N];
vector<int> path1, path2;
int par[N];

void b1(int a, int p)
{
    path1.push_back(a);
    for (auto &b : g[a])
    {
        if (b != p)
        {
            b1(b, a);
        }
    }
}

void b2(int a, int p)
{
    path2.push_back(a);
    reverse(g[a].begin(), g[a].end());
    for (auto &b : g[a])
    {
        if (b != p)
        {
            b2(b, a);
        }
    }
}

void dfs(int a, int p)
{
    par[a] = p;
    int vecs = (int) g[a].size() - (p != -1);
    if (vecs == 0)
    {
        dp_down[a] = 0;
        return;
    }
    dp_down[a] = 0;
    for (auto &b : g[a])
    {
        if (b != p)
        {
            dfs(b, a);
            if (dp_down[b] == 0)
            {
                dp_down[a] = 1;
            }
        }
    }
}

void make(vector<int> ord)
{
    for (auto &a : ord)
    {
        int p = par[a];
        if (dp[p] == 0)
        {
            dp[a] = 1;
        }
        bool cnb = 1;
        for (auto &b : g[p])
        {
            if (b != a)
            {
                if (dp_down[b] == 0)
                {
                    cnb = 0;
                    break;
                }
            }
        }
        if (cnb)
        {
            dp[a] = 1;
        }
    }
}

void solve()
{
    for (int i = 1; i <= n; i++)
    {
        dp[i] = dp_down[i];
    }
    make(path1);
    make(path2);
    make(path1);
    make(path2);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

 ///   freopen ("input", "r", stdin);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    b1(1, -1);
    b2(1, -1);
    dfs(1, -1);
    solve();
    /**for (auto &it : path1)
    {
        cout << it << " ";
    }
    cout << "\n";
    for (auto &it : path2)
    {
        cout << it << " ";
    }
    cout << "\n";


    return 0;

    for (int i = 1; i <= n; i++)
    {
        cout << i << " : " << dp_down[i] << "\n";
    }
    return 0;**/

    for (int i = 1; i <= n; i++)
    {
        cout << (dp[i] ^ 1);
    }
    cout << "\n";

    return 0;
}
