#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int) 5e5 + 7;
int n;
int m;
vector<int> g[N];
bool u[N];
vector<int> path;
int ans[N];

void rst_task1()
{
    path.clear();
    for (int i = 1; i <= n; i++)
    {
        u[i] = 0;
    }
}

void dfs_task1(int a)
{
    u[a] = 1;
    path.push_back(a);
    for (auto &b : g[a])
    {
        if (u[b] == 0)
        {
            dfs_task1(b);
        }
    }
}

int dp[N];
void dfs_task2(int a, int p)
{
    int vecs = (int) g[a].size() - (p != -1);
    if (vecs == 0)
    {
        dp[a] = 1;
        return;
    }
    dp[a] = 0;
    for (auto &b : g[a])
    {
        if (b != p && dp[b] == 0)
        {
            dfs_task2(b, a);
            dp[a] = 1;
            return;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

   // freopen ("input", "r", stdin);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int cnt_deg1 = 0;
    for (int i = 1; i <= n; i++)
    {
        cnt_deg1 += ((int) g[i].size() == 1);
    }
    if (cnt_deg1 == 2) /// lant, task 1
    {
        int root;
        for (int i = 1; i <= n; i++)
        {
            if ((int) g[i].size() == 1)
            {
                root = i;
            }
        }
        rst_task1();
        dfs_task1(root);
        for (int i = 1; i <= n; i++)
        {
            int a = path[i - 1];
            if (i == 1 || i == n)
            {
                if (n % 2 == 1)
                {
                    ans[a] = 1;
                }
                else
                {
                    ans[a] = 0;
                }
            }
            else
            {
                int l1 = i - 1;
                int l2 = n - i;
                if (l1 % 2 == 1 || l2 % 2 == 1)
                {
                    ans[a] = 0;
                }
                else
                {
                    ans[a] = 1;
                }
            }
        }
        for (int i = 1; i <= n; i++)
        {
            cout << ans[i];
        }
        cout << "\n";
        return 0;
    }
    /// task 2
        for (int i = 1; i <= n; i++)
        {
            dfs_task2(i, -1);
            bool good = 1;
            for (auto &j : g[i])
            {
                dfs_task2(j, i);
                if (dp[j] == 1)
                {
                    good = 0;
                    break;
                }
            }
            cout << good;
        }
        cout << "\n";
        return 0;
}
