#include <iostream>
#include <set>

using namespace std;

const int N = (int) 1e5 + 7;
int n;
int q;
set<pair<int, int>> all;
set<int> xx[N];
set<int> yy[N];

int mnx(int x)
{
    return *xx[x].begin();
}

int mxx(int x)
{
    auto it = xx[x].end();
    it--;
    return *it;
}

int mny(int y)
{
    return *yy[y].begin();
}

int mxy(int y)
{
    auto it = yy[y].end();
    it--;
    return *it;
}

void ins(int x, int y)
{
    all.insert({x, y});
    xx[x].insert(y);
    yy[y].insert(x);
}

void del(int x, int y)
{
    all.erase({x, y});
    xx[x].erase(y);
    yy[y].erase(x);
}

void print()
{
    int s1 = 0, s2 = 0;
    for (auto &it : all)
    {
        int x = it.first;
        int y = it.second;
        int cnt = (mnx(x) == y || mxx(x) == y) + (mny(y) == x || mxy(y) == x);
        if (cnt == 0)
        {
            s2++;
        }
        if (cnt == 2)
        {
            s1++;
        }
    }
    cout << s1 << " " << s2 << "\n";
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int x, y;
        cin >> x >> y;
        ins(x, y);
    }
    cin >> q;
    print();
    for (int i = 1; i <= q; i++)
    {
        int t, x, y;
        cin >> t >> x >> y;
        if (t == 1)
        {
            ins(x, y);
        }
        else
        {
            del(x, y);
        }
        print();
    }

}
