#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 5e5 + 5;
int n, m;

vector <int> G[NMAX];
bool viz[NMAX];
bool dp[NMAX];
int sol[NMAX];

void dfs1 (int node, int tata)
{
    viz[node] = 1;
    if (sol[tata] == 0) sol[node] = 1;
    else sol[node] = 0;

    for (int i = 0; i < G[node].size(); ++i)
    {
        int x = G[node][i];

        if (!viz[x]) dfs1(x, node);
    }
}

void dfs (int node, int tata)
{
    viz[node] = 1;
    int mergin = 0;

    for (int i = 0; i < G[node].size(); ++i)
    {
        int x = G[node][i];

        if (!viz[x])
        {
            dfs(x, node);
            mergin++;
        }
    }

    if (mergin == 0)
    {
        dp[node] = 0;
        return;
    }

    bool ok = false;

    for (int i = 0; i < G[node].size(); ++i)
    {
        int x = G[node][i];
        if (x == tata) continue;
        if (dp[x] == 0) ok = true;
    }

    dp[node] = ok;
}

void reset()
{
    for (int i = 1; i <= n; ++i)
        dp[i] = viz[i] = false;
}

bool Subtask1()
{
    for (int i = 1; i <= n; ++i)
    {
        if (G[i].size() > 2) return false;
    }

    return true;
}

bool Subtask2()
{
    int nr1 = 0;
    int nr2 = 0;
    int nr3 = 0;
    int put = 0;

    while ((1<<put) - 1 < n) put = put * 2;

    if ((1<<put) - 1 == n)
    {
        for (int i = 1; i <= n; ++i)
        {
            if (G[i].size() == 1) nr1++;
            else if (G[i].size() == 2) nr2++;
            else if (G[i].size() == 3) nr3++;
            else return false;
        }

        if (nr1 == (1<<(put-1)) && nr2 == 1) return true;
    }
    return false;
}
int main()
{
    cin >> n >> m;

    for (int i = 1; i <= m; ++i)
    {
        int x, y;
        cin >> x >> y;
        G[x].push_back(y);
        G[y].push_back(x);
    }

    if (Subtask1())
    {
        if (n % 2 == 0)
        {
            for (int i = 1; i <= n; ++i)
                cout << 0 << " ";
        }
        else
        {
            for (int i = 1; i <= n; ++i)
            {
                if (G[i].size() == 1)
                {
                    dfs1(i, 0);
                    break;
                }
            }

            for (int i = 1; i <= n; ++i)
                cout << sol[i];
        }
    }
    else if (Subtask2())
    {
        for (int i = 1; i <= n; ++i)
        {
            if (!viz[i]) {
                dfs(i, 0);
            }
            cout << (dp[i] == false ? 1 : 0);
        }
    }
    else
    {
        for (int i = 1; i <= n; ++i)
        {
            dfs(i, 0);
            cout << (dp[i] == false ? 1 : 0);
            reset();
        }
    }
    return 0;
}
