#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 500002;

int n, m;

vector <int> edges[N_MAX];

bool up[N_MAX], down1[N_MAX], down2[N_MAX];
int p[N_MAX];

bool visited[N_MAX];

void dfsDown (int node, int parent = -1)
{
    visited[node] = true;
    for(int u : edges[node])
        if(u != parent)
        {
            dfsDown(u, node);
            if(down1[u] == false)
            {
                down2[node] = down1[node];
                down1[node] = true;
                p[node] = u;
            }
        }
}

void dfsUp (int node, int parent = -1)
{
    if(parent != -1)
    {
        if(p[parent] == node)
            up[node] = !down2[parent];
        else
            up[node] = !down1[parent];
        up[node] |= !up[parent];
    }
    for(int u : edges[node])
        if(u != parent)
            dfsUp(u, node);
}

int main()
{
    cin >> n >> m;
    for(int i = 1; i <= m; i++)
    {
        int u, v;
        cin >> u >> v;
        edges[u].push_back(v);
        edges[v].push_back(u);
    }
    for(int i = 1; i <= n; i++)
        if(visited[i] == false)
        {
            dfsDown(1);
            dfsUp(1);
        }
    for(int i = 1; i <= n; i++)
        cout << !(up[i] | down1[i]);
    cout << "\n";
    return 0;
}
