#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 100002;
const int Q_MAX = 100002;
const int C_MAX = 100002;

int n, q;

set <int> sx[C_MAX], sy[C_MAX];

map <pair <int, int>, int> mp;

bitset <N_MAX + Q_MAX> infxl, infxr, infyl, infyr;

int cnt1, cnt2;

void addx (int x, int y, int index)
{
    sx[x].insert(y);
    set <int> :: iterator it = sx[x].find(y);
    if(it == sx[x].begin())
    {
        cnt1 += (!(infxr[index] || infxl[index]) && (infyl[index] || infyr[index]));
        cnt2 -= (!(infxr[index] || infxl[index]) && !(infyl[index] || infyr[index]));
        infxl[index] = true;
        set <int> :: iterator it1 = it;
        it1++;
        if(it1 != sx[x].end())
        {
            int index1 = mp[make_pair(x, *it1)];
            cnt1 -= (!infxr[index1] && infxl[index1] && (infyl[index1] || infyr[index1]));
            cnt2 += (!infxr[index1] && infxl[index1] && !(infyl[index1] || infyr[index1]));
            infxl[index1] = false;
        }
    }
    it++;
    if(it == sx[x].end())
    {
        it--;
        cnt1 += (!(infxr[index] || infxl[index]) && (infyl[index] || infyr[index]));
        cnt2 -= (!(infxr[index] || infxl[index]) && !(infyl[index] || infyr[index]));
        infxr[index] = true;
        set <int> :: iterator it1 = it;
        if(it1 != sx[x].begin())
        {
            it1--;
            int index1 = mp[make_pair(x, *it1)];
            cnt1 -= (infxr[index1] && !infxl[index1] && (infyl[index1] || infyr[index1]));
            cnt2 += (infxr[index1] && !infxl[index1] && !(infyl[index1] || infyr[index1]));
            infxr[index1] = false;
        }
    }
}

void addy (int x, int y, int index)
{
    sy[y].insert(x);
    set <int> :: iterator it = sy[y].find(x);
    if(it == sy[y].begin())
    {
        cnt1 += (!(infyr[index] || infyl[index]) && (infxl[index] || infxr[index]));
        cnt2 -= (!(infyr[index] || infyl[index]) && !(infxl[index] || infxr[index]));
        infyl[index] = true;
        set <int> :: iterator it1 = it;
        it1++;
        if(it1 != sy[y].end())
        {
            int index1 = mp[make_pair(*it1, y)];
            cnt1 -= (!infyr[index1] && infyl[index1] && (infxl[index1] || infxr[index1]));
            cnt2 += (!infyr[index1] && infyl[index1] && !(infxl[index1] || infxr[index1]));
            infyl[index1] = false;
        }
    }
    it++;
    if(it == sy[y].end())
    {
        it--;
        cnt1 += (!(infyr[index] || infyl[index]) && (infxl[index] || infxr[index]));
        cnt2 -= (!(infyr[index] || infyl[index]) && !(infxl[index] || infxr[index]));
        infyr[index] = true;
        set <int> :: iterator it1 = it;
        if(it1 != sy[y].begin())
        {
            it1--;
            int index1 = mp[make_pair(*it1, y)];
            cnt1 -= (infyr[index1] && !infyl[index1] && (infxl[index1] || infxr[index1]));
            cnt2 += (infyr[index1] && !infyl[index1] && !(infxl[index1] || infxr[index1]));
            infyr[index1] = false;
        }
    }
}

void erasex (int x, int y)
{
    set <int> :: iterator it = sx[x].find(y);
    if(it == sx[x].begin())
    {
        set <int> :: iterator it1;
        it1 = it;
        it1++;
        if(it1 != sx[x].end())
        {
            int index1 = mp[make_pair(x, *it1)];
            cnt1 += (!(infxr[index1] || infxl[index1]) && (infyl[index1] || infyr[index1]));
            cnt2 -= (!(infxr[index1] || infxl[index1]) && !(infyl[index1] || infyr[index1]));
            infxl[index1] = true;
        }
    }
    it++;
    if(it == sx[x].end())
    {
        it--;
        set <int> :: iterator it1;
        it1 = it;
        if(it1 != sx[x].begin())
        {
            it1--;
            int index1 = mp[make_pair(x, *it1)];
            cnt1 += (!(infxr[index1] || infxl[index1]) && (infyl[index1] || infyr[index1]));
            cnt2 -= (!(infxr[index1] || infxl[index1]) && !(infyl[index1] || infyr[index1]));
            infxr[index1] = true;
        }
    }
    sx[x].erase(y);
}

void erasey (int x, int y)
{
    set <int> :: iterator it = sy[y].find(x);
    if(it == sy[y].begin())
    {
        set <int> :: iterator it1;
        it1 = it;
        it1++;
        if(it1 != sy[y].end())
        {
            int index1 = mp[make_pair(*it1, y)];
            cnt1 += (!(infyr[index1] || infyl[index1]) && (infxl[index1] || infxr[index1]));
            cnt2 -= (!(infyr[index1] || infyl[index1]) && !(infxl[index1] || infxr[index1]));
            infyl[index1] = true;
        }
    }
    it++;
    if(it == sy[y].end())
    {
        it--;
        set <int> :: iterator it1;
        it1 = it;
        if(it1 != sy[y].begin())
        {
            it1--;
            int index1 = mp[make_pair(*it1, y)];
            cnt1 += (!(infyr[index1] || infyl[index1]) && (infxl[index1] || infxr[index1]));
            cnt2 -= (!(infyr[index1] || infyl[index1]) && !(infxl[index1] || infxr[index1]));
            infyr[index1] = true;
        }
    }
    sy[y].erase(x);
}

void add (int x, int y, int index)
{
    cnt2++;
    addx(x, y, index);
    addy(x, y, index);
    mp[make_pair(x, y)] = index;
}

void erase (int x, int y)
{
    int index = mp[make_pair(x, y)];
    cnt1 -= ((infxl[index] || infxr[index]) && (infyl[index] || infyr[index]));
    cnt2 -= (!(infxl[index] || infxr[index]) && !(infyl[index] || infyr[index]));
    erasex(x, y);
    erasey(x, y);
}

int k;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        int x, y;
        cin >> x >> y;
        add(x, y, ++k);
    }
    cout << cnt1 << " " << cnt2 << "\n";
    cin >> q;
    while(q--)
    {
        int op;
        int x, y;
        cin >> op >> x >> y;
        if(op == 1)
            add(x, y, ++k);
        else
            erase(x, y);
        cout << cnt1 << " " << cnt2 << "\n";
    }
    return 0;
}
