#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define pii pair<int, int>
#define pb push_back

using namespace std;

vector<pair<int*, int>> v;

namespace dsu {
    int *p, *s, cnt;
    void init(int n) {
    	p = new int[n];
    	s = new int[n];
    	cnt = n;
    	for (int i = 0; i < n; ++i) {
			s[i] = 1;
			p[i] = i;
    	}
    }
    int get(int i) {
		return (i == p[i] ? i : get(p[i]));
	}

	bool merge(int a, int b) {
		a = get(a);
		b = get(b);
		if (a == b)
			return 0;
		if (s[a] > s[b])
			swap(a, b);
		v.pb({&s[b], s[b]});
        s[b] += s[a];
        v.pb({&cnt, cnt});
        cnt--;
        v.pb({&p[a], p[a]});
        p[a] = b;
        return 0;
	}
}

namespace seg {
	vector<pii> *t;
	int ans = 0;

	void build(int v, int l, int r) {
		if (l == r) {
			t[v] = vector<pii>();
		} else {
			int tm = (l + r) / 2;
			build(2 * v, l, tm);
			build(2 * v + 1, tm + 1, r);
			t[v] = vector<pii>();
		}
	}

    void update(int v, int tl, int tr, int pos, const pii& x) {
		if (pos < tl || pos > tr)
			return;
		//cout << ' ' << v << ' ' << tl << ' ' << tr << endl;
		t[v].pb(x);
		if (tl == tr)
			return;
		int tm = (tl + tr) / 2;
		if (pos > tm) {
			update(2 * v + 1, tm + 1, tr, pos, x);
		} else {
			update(2 * v, tl, tm, pos, x);
		}
    }

    void lets(int v, int tl, int tr) {
    	cout << v << " " << tl << " " << tr << endl;
    	if (tl != tr) {
			int tm = (tl + tr) / 2;
			lets(2 * v, tl, tm);
			lets(2 * v + 1, tm + 1, tr);
    	}
    	int siz = ::v.size();
        for (auto &i : t[v]) {
            dsu::merge(i.f, i.s);
        }
        ans += (dsu::cnt == 1);
        while (::v.size() > siz) {
			*((::v).back().f) = ::v.back().s;
			::v.pop_back();
        }

    }
    /*int get(int v, int tl, int tr, int l, int r) {
		if (l > r)
			return 0;
		if (tl > r || tr < l)
			return 0;
		if (l <= tl && r >= tr) {
			return t[v];
		}
		int tm = (tl + tr) / 2;
		return get(2 * v, tl, tm, l, r) + get(2 * v + 1, tm + 1, tr, l, r);
    }*/

	void init(int n) {
		t = new vector<pii>[4 * n];
        build(1, 0, n - 1);
	}
}

struct edge {
	int a, b, w;
};

struct point {
	int x, y;
    point& operator+(const point& a) const {
        point z = {a.x + this->x, a.y + this->y};
        return z;
    }
    point& operator-(const point& a) const {
		point z = {this->x - a.x, this->y - a.y};
		return z;
    }
    int operator*(const point& a) const {
    	return this->x * a.x + this->y * a.y;
    }
    int vc(const point& a) const {
		return a.x * this->y - a.y * this->x;
    }
};

const int maxn = 5e5 + 50;
vector<int> r[maxn];
int dp[maxn];
int sum[maxn];
int ans[maxn];

void dfs(int v, int p = -1) {
    //int sum = 0;
    for (auto &u : r[v]) {
		if (u == p)
			continue;
		dfs(u, v);
		sum[v] += dp[u];
    }
    dp[v] = !sum[v];
}

void rek(int v, int p = -1) {
	ans[v] = dp[v];
	for (auto &u : r[v]) {
		if (u == p)
			continue;
		sum[v] -= dp[u];
		dp[v] = !sum[v];
		sum[u] += dp[v];
		dp[u] = !sum[u];
		rek(u, v);
		sum[u] -= dp[v];
		dp[u] = !sum[u];
		sum[v] += dp[u];
		dp[v] = !sum[v];
	}
}

signed main()
{
	#ifndef EVAL
	freopen("input.txt", "r", stdin);
	#endif // EVAL
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		r[a].pb(b);
		r[b].pb(a);
	}
	dfs(0);
	rek(0);
	// TODO TREE FOREST
	for (int i = 0; i < n; ++i)
		cout << ans[i];
	cout << endl;

    return 0;
}
