#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define pii std::pair<int, int>
#define pb push_back
#define int ll
//using namespace std

const int maxn = 2e5 + 50;
std::set<pii> sy[maxn], sx[maxn];
int up[maxn], down[maxn], right[maxn], left[maxn];
int type[maxn];
int cnt = 0;
int border = 0, inside = 0;

inline void update(int i, bool deb = 0) {
	if ((up[i] > cnt || down[i] > cnt) && (right[i] > cnt || left[i] > cnt)) {
		if (type[i] == 1)
			return;
		if (type[i] == 2)
			inside--;
		type[i] = 1;
        border++;
    } else if((up[i] <= cnt && down[i] <= cnt) && (right[i] <= cnt && left[i] <= cnt)) {
		if (type[i] == 1)
			border--;
		if (type[i] == 2)
			return;
		//std::cout << up[i] << std::endl;
		type[i] = 2;
		inside++;
	} else {
		if (type[i] == 1)
			border--;
		if (type[i] == 2)
			inside--;
		type[i] = 0;
	}
}

void del(int x, int y, int i) {
	cnt = i;
	if (type[i] == 2) {
		type[i] = 0;
		inside--;
	} else if(type[i] == 1) {
		type[i] = 0;
		border--;
	}
	sx[y].erase({x, i});
	sy[x].erase({y, i});
	down[up[i]] = down[i];
	up[down[i]] = up[i];
    right[left[i]] = right[i];
    left[right[i]] = left[i];
    update(down[i]);
    update(right[i]);
    update(left[i]);
    update(up[i]);
}

void add(int x, int y, int i) {
	cnt = i + 1;
    auto it = sx[y].upper_bound({x, 0});
    auto it2 = sy[x].upper_bound({y, 0});
	if (it != sx[y].end()) {
        right[i] = it->s;
        left[it->s] = i;
        update(it->s);
	}
	if (it2 != sy[x].end()) {
		up[i] = it2->s;
		down[it2->s] = i;
        update(it2->s);
	}
	if (it != sx[y].begin()) {
		it--;
		left[i] = it->s;
		right[it->s] = i;
        update(it->s);
	}
    if (it2 != sy[x].begin()) {
		it2--;
		down[i] = it2->s;
		up[it2->s] = i;
        update(it2->s);
    }
    update(i, 1);
	sx[y].insert({x, i});
	sy[x].insert({y, i});
}
using namespace std;

signed main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	#ifndef EVAL
	freopen("input.txt", "r", stdin);
	#endif // EVAL
	int n;
	std::cin >> n;
	for (int i = 0; i < maxn; ++i) {
        ::left[i] = ::right[i] = ::up[i] = ::down[i] = maxn - 1;
	}
	for (int i = 0; i < n; ++i) {
		int a, b;
		std::cin >> a >> b;
		add(a, b, cnt);
	//	std::cout << border << ' ' << inside << std::endl;
	}/*
	for (int i = 0; i < cnt; ++i)
		if (type[i] == 2) {
			std::cout << i << ' ' << up[i] << endl;
		}
	for (int i = 0; i < 5; ++i) {
		if (sy[i].size()) {
			std::cout << i << std::endl;
			for (auto &j : sy[i])
				std::cout << j.s << ' ';
			std::cout << std::endl;
		}
	}*/
	std::cout << border << ' ' << inside << std::endl;
	int q;
	std::cin >> q;
	while (q--) {
		int t, a, b;
		std::cin >> t >> a >> b;
		if (t == 1)
			add(a, b, cnt);
		if (t == 2)
			del(a, b, cnt);
		std::cout << border << ' ' << inside << std::endl;
	}
    return 0;
}
