#include <bits/stdc++.h>
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define pb push_back
#define fst first
#define snd second
typedef long long ll;
typedef long double ld;
using namespace std;

const int MAXN = 200;

vector<int> par;
vector<int> sz;
vector<int> used;
int g[MAXN][MAXN];
int n, m;

int get(int a){
    if (par[a] == a) return a;
    return par[a] = get(par[a]);
}

int union_set(int a, int b){
    a = get(a);
    b = get(b);
    if (a == b)
        return 0;
    if (sz[a] > sz[b])
        swap(a, b);
    par[a] = b;
    sz[b] += sz[a];
    return 1;
}

int col = 0;

int kolvo = 0;

void dfs(int v){
    used[v] = col;
    kolvo++;
    if (kolvo == n)
        return;
    for (int i = 0; i < MAXN; i++){
        if (g[v][i] && used[i] != col){
            dfs(i);
        }
        if (kolvo == n)
            return;
    }
}

bool check(){
    col++;
    kolvo = 0;
    dfs(0);
    return (kolvo == n);
}

signed main() {
    ios;
    cin >> n >> m;
    sz.resize(n);
    par.resize(n);
    vector<pair<int, int>> seg (m);
    used.resize(n);
    for (int i = 0; i < m; i++){
        cin >> seg[i].fst >> seg[i].snd;
        seg[i].fst--;
        seg[i].snd--;
    }
    ll ans = 0;
    ll ans2 = 0;
    if (n > 200){
        for (int i = 0; i < m; i++){
            int now = n;
            for (int j = 0; j < n; j++){
                par[j] = j;
                sz[j] = 1;
            }
            int j = i;
            while(now != 1 && j < m){
                now -= union_set(seg[j].fst, seg[j].snd);
                if (now != 1)
                    j++;
            }
            if (now == 1){
                ans += (m - j);
            }
        }
        cout << ans << endl;
    }else{
        int l = 0;
        int r = 0;
        bool bl = 0;
        while(l != m){
            int ll = r - 1;
            int rr = n * n + 2;
            while(rr > ll + 1){
                int mid = (rr + ll) / 2;
                for (int i = l; i <= min(l + mid, m - 1); i++){
                    g[seg[i].fst][seg[i].snd]++;
                    g[seg[i].snd][seg[i].fst]++;
                }
                if (check()){
                    rr = mid;
                }else{
                    ll = mid;
                }
                for (int i = l; i <= min(l + mid, m - 1); i++){
                    g[seg[i].fst][seg[i].snd]--;
                    g[seg[i].snd][seg[i].fst]--;
                }
            }
            r = rr;
            if (rr != n * n + 2){
                ans2 += m - (l + rr);
            }
            l++;
        }
        cout << ans2 << endl;
    }
}
