#include <bits/stdc++.h>
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define pb push_back
#define fst first
#define snd second
typedef long long ll;
typedef long double ld;
using namespace std;

const int MAXN = 200;

vector<int> par;
vector<int> sz;
int n, m;

int get(int a){
    if (par[a] == a) return a;
    return par[a] = get(par[a]);
}

int union_set(int a, int b){
    a = get(a);
    b = get(b);
    if (a == b)
        return 0;
    if (sz[a] > sz[b])
        swap(a, b);
    par[a] = b;
    sz[b] += sz[a];
    return 1;
}

signed main() {
    ios;
    cin >> n >> m;
    sz.resize(n);
    par.resize(n);
    vector<pair<int, int>> seg (m);
    for (int i = 0; i < m; i++){
        cin >> seg[i].fst >> seg[i].snd;
        seg[i].fst--;
        seg[i].snd--;
    }
    ll ans = 0;
    int l = 0;
    int r = 0;
    while(l != m){
        int ll = -1;
        int rr = m + 10;
        while(rr > ll + 1){
            int mid = (rr + ll) / 2;
            int now = n;
            for (int j = 0; j < n; j++){
                par[j] = j;
                sz[j] = 1;
            }
            for (int i = l; i <= min(m - 1, l + mid); i++){
                now -= union_set(seg[i].fst, seg[i].snd);
            }
            if (now == 1){
                rr = mid;
            }else{
                ll = mid;
            }
        }
        r = rr;
        if (rr != m + 10){
            ans += m - (l + rr);
        }
        l++;
    }
    cout << ans << endl;
}
