#include <bits/stdc++.h>
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define pb push_back
#define fst first
#define snd second
typedef long long ll;
typedef long double ld;
using namespace std;

vector<int> par;
vector<int> sz;

int get(int a){
    if (par[a] == a) return a;
    return par[a] = get(par[a]);
}

int union_set(int a, int b){
    a = get(a);
    b = get(b);
    if (a == b)
        return 0;
    if (sz[a] > sz[b])
        swap(a, b);
    par[a] = b;
    sz[b] += sz[a];
    return 1;
}

signed main() {
    ios;
    int n, m;
    cin >> n >> m;
    sz.resize(n);
    par.resize(n);
    vector<pair<int, int>> seg (m);
    for (int i = 0; i < m; i++){
        cin >> seg[i].fst >> seg[i].snd;
        seg[i].fst--;
        seg[i].snd--;
    }
    ll ans = 0;
    for (int i = 0; i < m; i++){
        int now = n;
        for (int j = 0; j < n; j++){
            par[j] = j;
            sz[j] = 1;
        }
        int j = i;
        while(now != 1 && j < m){
            now -= union_set(seg[j].fst, seg[j].snd);
            if (now != 1)
                j++;
        }
        if (now == 1){
            ans += (m - j);
        }
    }
    cout << ans << endl;
}
