#include <iostream>
#include <time.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <cassert>

#define ll long long
#define all(x) x.begin(), x.end()
#define ld long double


using namespace std;

const int maxn = 2000, maxm = 5000;

int p[maxn];


int cnt = 0;
void init(int n) {
    cnt = n;
    for(int i = 0; i < n; ++i) {
        p[i] = i;
    }
}

int get(int i) {
    return p[i] == i ? i : p[i] = get(p[i]);
}

void join(int a, int b) {
    a = get(a);
    b = get(b);
    if(a != b){
        p[a] = b;
        cnt--;
    }
}

struct edge {
    int a, b;
};


vector<edge> e;


int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        e.push_back({v, u});
    }
    int ans = 0;
    for(int l = 0; l < m; ++l) {
        init(n);
        int r;
        for(r = l; r < m && cnt != 1; ++r) {
            auto [a, b] = e[r];
            join(a, b);
        }
        if(cnt == 1)
            ans += m - r + 1;
//        cerr << "r: " << r << endl;
    }
    cout << ans;
    return 0;
}
