#include <iostream>
#include <time.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <cassert>

#define ll long long
#define all(x) x.begin(), x.end()
#define ld long double


using namespace std;

const int maxn = 1e4;

vector<int> graph[maxn];
int ans[maxn];
int n;

void dfs(int v, int depth) {
    if(depth % 2 == 0 || (n - depth) % 2 == 0){
        ans[v] = 0;
    }else{
        ans[v] = 1;
    }
    for(auto u: graph[v]){
        if(ans[u] == -1)
            dfs(u, depth + 1);
    }
}


int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int  m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    for(int i = 0; i < n;++i){
        if(graph[i].size() == 1){
            dfs(i, 0);
            break;
        }
    }

    for(int i = 0; i < n;++i){
        cout << ans[i] << " " ;
    }
    return 0;
}
