#include<bits/stdc++.h>

#define pb push_back
#define ld long double

using namespace std;

const int M = 200010, N = 200 + 10;
int par[M][N];
bool used[M][N];

int find_set(int v, int now){
    if (par[now][v] == v){
        return v;
    }
    else{
        return par[now][v] = find_set(par[now][v], now);
    }
}

void union_set(int a, int b, int now ){
    b = find_set(b, now);
    a = find_set(a, now);
    par[now][b] = a;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int,int>> v;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        v.pb({a, b});
    }
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n + 1; j++){
            par[i][j] = j;
        }
    }
    long long ans = 0;
    for (int i = 0; i < m; i++){
        int cnt = 0, cnt1 = 0;
        for (int j = i; j < m; j++){
            int a = v[j].first, b = v[j].second;
            if (a == b) continue;
            if ((!used[i][a]) && (!used[i][b])){
                used[i][a] = 1;
                used[i][b] = 1;
                cnt++;
                cnt1 += 2;
                union_set(a, b, i);
            }
            else if (!used[i][a] || !used[i][b]){
                used[i][a] = 1;
                used[i][b] = 1;
                cnt1++;
                union_set(a, b, i);
            }
            else if (find_set(a, i) != find_set(b, i)){
                cnt--;
                union_set(a, b, i);
            }
            if (cnt == 1 && cnt1 == n){
                ans += m - j;
                break;
            }
        }
    }
    cout << ans;
    return 0;
}
