#include<iostream>
#include<vector>
#include<deque>
#include<iomanip>
#include<string>
#include<numeric>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
using namespace std;

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define ll long long
#define ld long double
#define P pair<int, int>

const int N = 3e3 + 1;

int n, m;
vector<int> g[N];
bool dp[N];

void dfs(int v, int p) {
    dp[v] = 0;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
            dp[v] |= !dp[u];
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].pb(u);
        g[u].pb(v);
    }
    for (int i = 0; i < n; i++) {
        dfs(i, -1);
        cout << !dp[i];
    }
    return 0;
}
