#include<iostream>
#include<vector>
#include<deque>
#include<iomanip>
#include<string>
#include<numeric>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
using namespace std;

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define ll long long
#define ld long double
#define P pair<int, int>

const int N = 3e3 + 1;

int n, m;
vector<int> g[N];
bool dp[N];

void dfs(int v, int p) {
    dp[v] = 0;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
            dp[v] |= !dp[u];
        }
    }
}
vector<int> ord;

void dfs_ord(int v, int p) {
    ord.pb(v);
    for (auto u : g[v]) {
        if (u != p) {
            dfs_ord(u, v);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].pb(u);
        g[u].pb(v);
    }
    bool has3 = false;
    int cnt1 = 0;
    for (int i = 0; i < n; i++) {
        has3 |= sz(g[i]) >= 3;
        if (sz(g[i]) == 1) cnt1++;
    }
    if (!has3 && cnt1 == 2) {
        int some = -1;
        for (int i = 0; i < n; i++) {
            if (sz(g[i]) == 1) {
                some = i;
                break;
            }
        }
        dfs_ord(some, -1);
        vector<bool> ans(n);
        for (int i = 0; i < n; i++) {
            int before = i, after = n - i - 1;
            if ((before & 1) || (after & 1)) {
                ans[ord[i]] = 1;
            } else {
                ans[ord[i]] = 0;
            }
        }
        for (auto el : ans) {
            cout << !el;
        }
        return 0;
    }
    for (int i = 0; i < n; i++) {
        dfs(i, -1);
        cout << !dp[i];
    }
    return 0;
}
