#include<iostream>
#include<vector>
#include<deque>
#include<iomanip>
#include<string>
#include<numeric>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
using namespace std;

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define ll long long
#define ld long double
#define P pair<int, int>

const int N = 5e5 + 5;

int n, m;
vector<int> g[N];
bool us[N], dpd[N], dpu[N];
int h[N];

void dfsd(int v) {
    dpd[v] = 0;
    us[v] = 1;
    for (auto u : g[v]) {
        if (!us[u]) {
            h[u] = h[v] + 1;
            dfsd(u);
            dpd[v] |= !dpd[u];
        }
    }
}

void dfsu(int v, int p) {
    for (auto u : g[v]) {
        if (u != p) {
            dpu[u] = !dpu[v];
            dfsu(u, v);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].pb(u);
        g[u].pb(v);
    }
    for (int i = 0; i < n; i++) {
        if (!us[i]) {
            h[i] = 0;
            dfsd(i);
            int cntw = 0;
            for (auto j : g[i]) {
                if (dpd[j]) cntw++;
            }
            for (auto j : g[i]) {
                cntw -= dpd[j];
                if (cntw == sz(g[i]) - 1) {
                    dpu[j] = 1;
                } else {
                    dpu[j] = 0;
                }
                cntw += dpd[j];
            }
        }
    }
    for (int i = 0; i < n; i++) {
        bool t = dpd[i] || dpu[i];
        cout << !t;
    }
    return 0;
}
