#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> g, dp2, ch;
vector<int> dp1, parr, ind, used;
vector<int> roots;

void dfs(int v, int p = -1) {
	used[v] = 1;
	parr[v] = p;
	int ans = 0;
	for (int i = 0; i < (int) g[v].size(); i++) {
		if (g[v][i] != p) {
			ind[g[v][i]] = ch[v].size();
			ch[v].push_back(g[v][i]);
			dfs(g[v][i], v);
			if (dp1[g[v][i]] == 0) {
				ans = 1;
			}
		}
	}
	dp1[v] = ans;
}

void dfs2(int v) {
	if (parr[v] != -1 && dp2[parr[v]][ind[v]] == 0) {
		for (int i = 0; i < (int) ch[v].size(); i++) {
			dp2[v][i] = 1;
		}
	} else {
		vector<int> arr;
		for (int u : ch[v]) {
			arr.push_back(1 - dp1[u]);
		}
		for (int u : ch[v]) {
			arr.push_back(1 - dp1[u]);
		}
		arr.push_back(0);
		int cur_sum = 0;
		for (int i = 1; i < (int) ch[v].size(); i++) {
			cur_sum += arr[i];
		}
		for (int i = 0; i < (int) ch[v].size(); i++) {
			if (cur_sum == 0) {
				dp2[v][i] = 0;
			} else {
				dp2[v][i] = 1;
			}
			cur_sum -= arr[i + 1];
			cur_sum += arr[i + ch[v].size()];
		}
	}
	for (int u : ch[v]) {
		dfs2(u);
	}
}


int main() {
	int n;
	cin >> n;
	int m;
	cin >> m;
	g.resize(n);
	dp2.resize(n);
	ch.resize(n);
	dp1.resize(n);
	parr.resize(n);
	ind.resize(n);
	used.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			roots.push_back(i);
			dfs(i);
		}
	}
	for (int i = 0; i < n; i++) {
		dp2[i].resize(ch[i].size());
	}
	for (int u : roots) {
		dfs2(u);
	}
	for (int i = 0; i < n; i++) {
		if (g[i].empty()) {
			cout << '1';
		} else {
			int ans = dp1[i];
			if (parr[i] != -1 && dp2[parr[i]][ind[i]] == 0) {
				ans = 1;
			}
			cout << 1 - ans;
		}
	}
	cout << endl;
}
