#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,mmx,avx2,abm,popcnt")
#include <bits/stdc++.h>
using namespace std;

const int MAXSZ = 480 * 1024 * 1024;
char memo[MAXSZ];
int cur_pt = 0;

void* operator new(size_t sz) {
	void *ans = memo + cur_pt;
	cur_pt+= sz;
	return ans;
}

void operator delete(void *n) {

}

void operator delete(void *n, size_t sz) {

}

const int MAXN = 5e5 + 228;

vector<int> g[MAXN], dp2[MAXN], ch[MAXN];
int dp1[MAXN], parr[MAXN], ind[MAXN], used[MAXN];
vector<int> roots;

void dfs(int v, int p = -1) {
	used[v] = 1;
	parr[v] = p;
	int ans = 0;
	for (int i = 0; i < (int) g[v].size(); i++) {
		if (g[v][i] != p) {
			ind[g[v][i]] = ch[v].size();
			ch[v].push_back(g[v][i]);
			dfs(g[v][i], v);
			if (dp1[g[v][i]] == 0) {
				ans = 1;
			}
		}
	}
	dp1[v] = ans;
}

void dfs2(int v) {
	if (parr[v] != -1 && dp2[parr[v]][ind[v]] == 0) {
		for (int i = 0; i < (int) ch[v].size(); i++) {
			dp2[v][i] = 1;
		}
	} else {
		int cur_sum = 0;
		for (int i = 1; i < (int) ch[v].size(); i++) {
			cur_sum += 1 - dp1[ch[v][i]];
		}
		for (int i = 0; i < (int) ch[v].size(); i++) {
			if (cur_sum == 0) {
				dp2[v][i] = 0;
			} else {
				dp2[v][i] = 1;
			}
			cur_sum -= (1 - dp1[ch[v][(i + 1) % ch[v].size()]]);
			cur_sum += (1 - dp1[ch[v][i]]);
		}
	}
	for (int u : ch[v]) {
		dfs2(u);
	}
}

pair<int, int> edges[MAXN];
int cntt[MAXN];


int main() {
	int n;
	int m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; i++) {
		int a, b;
		scanf("%d %d", &a, &b);
		a--;
		b--;
		edges[i] = {a, b};
		cntt[a]++;
		cntt[b]++;
	}
	for (int i = 0; i < n; i++) {
		g[i].reserve(cntt[i]);
		if (cntt[i] != 0) 
			ch[i].reserve(cntt[i] - 1);
	}
	for (int i = 0; i < m; i++) {
		int a = edges[i].first;
		int b = edges[i].second;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			roots.push_back(i);
			dfs(i);
		}
	}
	for (int i = 0; i < n; i++) {
		dp2[i].resize(ch[i].size());
	}
	for (int u : roots) {
		dfs2(u);
	}
	for (int i = 0; i < n; i++) {
			int ans = dp1[i];
			if (parr[i] != -1 && dp2[parr[i]][ind[i]] == 0) {
				ans = 1;
			}
			printf("%d", 1 - ans);
	}
	printf("\n");
}
