#pragma GCC optimize("O3,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,mmx,avx2,abm,popcnt,tune=native")
#include <bits/stdc++.h>
using namespace std;

const int MAXSZ = 480 * 1024 * 1024;
char memo[MAXSZ];
int cur_pt = 0;

void* operator new(size_t sz) {
	void *ans = memo + cur_pt;
	cur_pt+= sz;
	return ans;
}

void operator delete(void *) {

}

void operator delete(void *, size_t) {

}

const int MAXN = 500000 + 228;

vector<int> g[MAXN], dp2[MAXN], ch[MAXN];
int dp1[MAXN], parr[MAXN], ind[MAXN];
int used[MAXN];

void dfs(int v, int p = -1) {
	used[v] = 1;
	parr[v] = p;
	int ans = 0;
	for (int i = 0; i < (int) g[v].size(); i++) {
		if (g[v][i] != p) {
			ind[g[v][i]] = ch[v].size();
			ch[v].push_back(g[v][i]);
			dfs(g[v][i], v);
			if (dp1[g[v][i]] == 0) {
				ans = 1;
			}
		}
	}
	dp1[v] = ans;
}


/*void dfs2(int v) {
		if (parr[v] != -1 && dp2[parr[v]][ind[v]] == 0) {
			for (int i = 0; i < (int) ch[v].size(); i++) {
				dp2[v][i] = 1;
			}
		} else {
			int cur_sum = 0;
			for (int i = 1; i < (int) ch[v].size(); i++) {
				cur_sum += 1 - dp1[ch[v][i]];
			}
			for (int i = 0; i < (int) ch[v].size(); i++) {
				if (cur_sum == 0) {
					dp2[v][i] = 0;
				} else {
					dp2[v][i] = 1;
				}
				cur_sum -= (1 - dp1[ch[v][(i + 1) % ch[v].size()]]);
				cur_sum += (1 - dp1[ch[v][i]]);
			}
		}
		for (int u : ch[v]) {
			dfs2(u);
		}
}*/


int q[MAXN];

void dfs2(int vv) {
	q[0] = vv;
	int l = 0;
	int r = 1;
	while (l != r) {
		int v = q[l++];
		if (parr[v] != -1 && dp2[parr[v]][ind[v]] == 0) {
			int chsz = ch[v].size();
			for (int i = 0; i < chsz; i++) {
				dp2[v][i] = 1;
			}
		} else {
			int chsz = ch[v].size();
			int cur_sum = 0;
			for (int i = 1; i < chsz; i++) {
				cur_sum += 1 - dp1[ch[v][i]];
			}
			for (int i = 0; i < chsz; i++) {
				if (cur_sum == 0) {
					dp2[v][i] = 0;
				} else {
					dp2[v][i] = 1;
				}
				int j = i + 1;
				if (j == chsz)
					j = 0;
				cur_sum -= (1 - dp1[ch[v][j]]);
				cur_sum += (1 - dp1[ch[v][i]]);
			}
		}
		for (int u : ch[v]) {
			q[r++] = u;
		}
	}
}

int edges[2 * MAXN];
int cntt[MAXN];

int roots[MAXN];


int main() {
	int n;
	int m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; i++) {
		int a, b;
		scanf("%d %d", &a, &b);
		a--;
		b--;
		edges[2 * i] = a;
		edges[2 * i + 1] = b;
		cntt[a]++;
		cntt[b]++;
	}
	for (int i = 0; i < n; i++) {
		g[i].reserve(cntt[i]);
		if (cntt[i] != 0) 
			ch[i].reserve(cntt[i] - 1);
	}
	for (int i = 0; i < m; i++) {
		int a = edges[2 * i];
		int b = edges[2 * i + 1];
		g[a].push_back(b);
		g[b].push_back(a);
	}
	int sz = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			roots[sz++] = i;
			dfs(i);
		}
	}
	for (int i = 0; i < n; i++) {
		dp2[i].resize(ch[i].size());
	}
	for (int i = 0; i < sz; i++) {
		dfs2(roots[i]);
	}
	string anss(n, '0');
	for (int i = 0; i < n; i++) {
			int ans = dp1[i];
			if (parr[i] != -1 && dp2[parr[i]][ind[i]] == 0) {
				ans = 1;
			}
			anss[i] = 1 - ans + '0';
	}
	cout << anss;
}
