#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

vector<vector<int>> g, dp;

void dfs(int v, int p, int ind) {
	int ans = 0;
	for (int i = 0; i < (int) g[v].size(); i++) {
		if (g[v][i] == p) {
			continue;
		}
		if (dp[v][i] == -1) {
			dfs(g[v][i], v, i);
		}
		if (dp[v][i] == 0) {
			ans = 1;
		}
	}
	dp[p][ind] = ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	g.resize(n);
	dp.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
		dp[a].push_back(-1);
		dp[b].push_back(-1);
	}
	for (int i = 0; i < n; i++) {
		int ans = 0;
		for (int j = 0; j < (int) g[i].size(); j++) {
			dfs(g[i][j], i, j);
			if (dp[i][j] == 0) {
				ans = 1;
			}
		}
		if (g[i].empty()) {
			ans = 0;
		}
		cout << 1 - ans;
	}
	cout << endl;
}
