#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,mmx")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

const int MAXN = 5e5+179;

vector<int> g[MAXN], dp[MAXN];

void dfs(int v, int p, int ind) {
	int ans = 0;
	for (int i = 0; i < (int) g[v].size(); i++) {
		if (g[v][i] != p) {
		if (dp[v][i] == -1) {
			dfs(g[v][i], v, i);
		}
		if (dp[v][i] == 0) {
			ans = 1;
		}
		}
	}
	dp[p][ind] = ans;
}

int main() {
	int n, m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; i++) {
		int a, b;
		scanf("%d %d", &a, &b);
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
		dp[a].push_back(-1);
		dp[b].push_back(-1);
	}
	for (int i = 0; i < n; i++) {
		int ans = 0;
		for (int j = 0; j < (int) g[i].size(); j++) {
			dfs(g[i][j], i, j);
			if (dp[i][j] == 0) {
				ans = 1;
			}
		}
		printf("%d", 1 - ans);
	}
	printf("\n");
}
