#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e5;
int usedpx[MAXN], usedpy[MAXN];
int usedmx[MAXN], usedmy[MAXN];
int usedx[MAXN], usedy[MAXN];
set<pair<int, int>> spx[MAXN], spy[MAXN], smx[MAXN], smy[MAXN];
int cnt1 = 0, cnt2 = 0;

void add(int x, int y, int i) {
    usedpx[i] = 1;
    usedmx[i] = 1;
    usedpy[i] = 1;
    usedmy[i] = 1;
    auto it = spx[y].upper_bound({x, i});
    if (it != spx[y].end()) {
        usedmx[it->second] = 0;
        int f = usedx[it->second];
        usedx[it->second] = usedpx[it->second];
        if (f && usedy[it->second] && !usedx[it->second]) {
            cnt1--;
        }
        if (f && !usedy[it->second] && !usedx[it->second]) {
            cnt2++;
        }
        usedpx[i] = 0;
    }
    it = smx[y].upper_bound({-x, i});
    if (it != smx[y].end()) {
        usedpx[it->second] = 0;
        int f = usedx[it->second];
        usedx[it->second] = usedmx[it->second];
        if (f && usedy[it->second] && !usedx[it->second]) {
            cnt1--;
        }
        if (f && !usedy[it->second] && !usedx[it->second]) {
            cnt2++;
        }
        usedmx[i] = 0;
    }
    it = spy[x].upper_bound({y, i});
    if (it != spy[x].end()) {
        usedmy[it->second] = 0;
        int f = usedy[it->second];
        usedy[it->second] = usedpy[it->second];
        if (f && usedx[it->second] && !usedy[it->second]) {
            cnt1--;
        }
        if (f && !usedx[it->second] && !usedy[it->second]) {
            cnt2++;
        }
        usedpy[i] = 0;
    }
    it = smy[x].upper_bound({-y, i});
    if (it != smy[x].end()) {
        usedpy[it->second] = 0;
        int f = usedy[it->second];
        usedy[it->second] = usedmy[it->second];
        if (f && usedx[it->second] && !usedy[it->second]) {
            cnt1--;
        }
        if (f && !usedx[it->second] && !usedy[it->second]) {
            cnt2++;
        }
        usedmy[i] = 0;
    }
    usedx[i] = (usedmx[i] | usedpx[i]);
    usedy[i] = (usedmy[i] | usedpy[i]);
    if (usedx[i] && usedy[i]) {
        cnt1++;
    }
    if (!usedx[i] && !usedy[i]) {
        cnt2++;
    }
    spx[y].insert({x, i});
    smx[y].insert({-x, i});
    spy[x].insert({y, i});
    smy[x].insert({-y, i});
}

void del(int x, int y, int i) {
    if (usedx[i] && usedy[i]) {
        cnt1--;
    }
    if (!usedx[i] && !usedy[i]) {
        cnt2--;
    }
    auto it = spx[y].upper_bound({x, i});
    auto jt = smx[y].upper_bound({-x, i});
    if (it == spx[y].end() && jt != smx[y].end()) {
        int f = usedx[jt->second];
        usedpx[jt->second] = 1;
        usedx[jt->second] = 1;
        if (!f && !usedy[jt->second]) {
            cnt2--;
        }
        if (!f && usedy[jt->second]) {
            cnt1++;
        }
    }
    if (it != spx[y].end() && jt == smx[y].end()) {
        int f = usedx[it->second];
        usedmx[it->second] = 1;
        usedx[it->second] = 1;
        if (!f && !usedy[it->second]) {
            cnt2--;
        }
        if (!f && usedy[it->second]) {
            cnt1++;
        }
    }
    it = spy[x].upper_bound({y, i});
    jt = smy[x].upper_bound({-y, i});
    if (it == spy[x].end() && jt != smy[x].end()) {
        int f = usedy[jt->second];
        usedpy[jt->second] = 1;
        usedy[jt->second] = 1;
        if (!f && !usedx[jt->second]) {
            cnt2--;
        }
        if (!f && usedx[jt->second]) {
            cnt1++;
        }
    }
    if (it != spy[x].end() && jt == smy[x].end()) {
        int f = usedy[it->second];
        usedmy[it->second] = 1;
        usedy[it->second] = 1;
        if (!f && !usedx[it->second]) {
            cnt2--;
        }
        if (!f && usedx[it->second]) {
            cnt1++;
        }
    }
    smx[y].erase({-x, i});
    spx[y].erase({x, i});
    smy[x].erase({-y, i});
    spy[x].erase({y, i});
}

main() {
    int n;
    cin >> n;
    int cur = 0;
    map<pair<int, int>, int> ind;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        add(x, y, cur);
        ind[{x, y}] = cur;
        cur++;
    }
    cout << cnt1 << " " << cnt2 << endl;
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int x, y;
            cin >> x >> y;
            add(x, y, cur);
            ind[{x, y}] = cur;
            cur++;
        } else {
            int x, y;
            cin >> x >> y;
            del(x, y, ind[{x, y}]);
        }
        cout << cnt1 << " " << cnt2 << endl;
    }
    return 0;
}
