#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> g;
vector<int> dp1;
vector<vector<int>> dp2;
vector<int> p;
vector<int> ind;

void dfs1(int v) {
    dp1[v] = 0;
    int cur = 0;
    for (auto u : g[v]) {
        if (u != p[v]) {
            p[u] = v;
            ind[u] = cur;
            cur++;
            dfs1(u);
            if (dp1[u] == 0) {
                dp1[v] = 1;
            }
        }
    }
}

void dfs2(int v) {
    dp2[v].resize((int)g[v].size() - 1, 0);
    int cnt = 0;
    if (v != 0) {
        if (dp2[p[v]][ind[v]] == 0) {
            cnt++;
        }
    }
    for (auto u : g[v]) {
        if (u != p[v]) {
            if (dp1[u] == 0) {
                cnt++;
            }
        }
    }
    for (auto u : g[v]) {
        if (u != p[v]) {
            if (cnt == 0) {
                dp2[v][ind[u]] = 0;
            } else if (cnt == 1 && dp1[u] == 0) {
                dp2[v][ind[u]] = 0;
            } else {
                dp2[v][ind[u]] = 1;
            }
        }
    }
    for (auto u : g[v]) {
        if (u != p[v]) {
            dfs2(u);
        }
    }
}

main() {
    int n, m;
    cin >> n >> m;
    g.resize(n, vector<int>());
    dp1.resize(n, 0);
    dp2.resize(n, vector<int>());
    p.resize(n, 0);
    ind.resize(n, 0);
    assert(m == n - 1);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (n == 1) {
        cout << "0";
        return 0;
    }
    p[0] = -1;
    dfs1(0);
    dfs2(0);
    for (int i = 0; i < n; ++i) {
        int res = 1;
        for (auto u : g[i]) {
            if (u != p[i]) {
                if (dp1[u] == 0) {
                    res = 0;
                }
            }
        }
        if (i != 0) {
            if (dp2[p[i]][ind[i]] == 0) {
                res = 0;
            }
        }
        cout << res;
    }
    return 0;
}
