#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e5;
vector<int> g[MAXN];
int dp1[MAXN];
vector<int> dp2[MAXN];
int p[MAXN];
int used[MAXN];
int ind[MAXN];
int con[MAXN];

void dfs1(int v) {
    dp1[v] = 0;
    used[v] = 1;
    int cur = 0;
    con[v] = 0;
    for (auto u : g[v]) {
        if (u != p[v]) {
            p[u] = v;
            ind[u] = cur;
            cur++;
            dfs1(u);
            if (dp1[u] == 0) {
                con[v]++;
                dp1[v] = 1;
            }
        }
    }
}

void dfs2(int v) {
    dp2[v].resize((int)g[v].size(), 0);
    int cnt = con[v];
    if (p[v] != -1) {
        if (dp2[p[v]][ind[v]] == 0) {
            cnt++;
        }
    }
    for (auto u : g[v]) {
        if (u != p[v]) {
            if (cnt == 0) {
                dp2[v][ind[u]] = 0;
            } else if (cnt == 1 && dp1[u] == 0) {
                dp2[v][ind[u]] = 0;
            } else {
                dp2[v][ind[u]] = 1;
            }
            dfs2(u);
        }
    }
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (n == 1) {
        cout << "1";
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            p[i] = -1;
            dfs1(i);
            dfs2(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        int res = 1;
        for (auto u : g[i]) {
            if (u != p[i]) {
                if (dp1[u] == 0) {
                    res = 0;
                }
            }
        }
        if (p[i] != -1) {
            if (dp2[p[i]][ind[i]] == 0) {
                res = 0;
            }
        }
        cout << res;
    }
    return 0;
}
