#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e5;
int p[MAXN], sz[MAXN];
pair<int, int> ed[MAXN];

int cnt;

int get(int v) {
    if (v == p[v]) {
        return v;
    }
    p[v] = get(p[v]);
    return p[v];
}

void join(int u, int v) {
    u = get(u); v = get(v);
    if (u == v) {
        return;
    }
    if (sz[u] < sz[v]) {
        swap(u, v);
    }
    cnt--;
    p[v] = u;
    sz[u] += sz[v];
}

main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> ed[i].first >> ed[i].second;
        ed[i].first--; ed[i].second--;
    }
    int64_t ans = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            p[j] = j;
            sz[j] = 1;
        }
        cnt = n;
        for (int j = i; j < m; ++j) {
            join(ed[j].first, ed[j].second);
            if (cnt == 1) {
                ans += m - j;
                break;
            }
            if (j == m - 1) {
                cout << ans;
                return 0;
            }
        }
    }
    cout << ans;
    return 0;
}
