#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define int ll
//define double ld
#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;
/*
using namespace __gnu_pbds;
using supset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
*/
using ll = long long;
using ld = long double;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;
using pii = pair <int, int>;
/*
const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete(void*) {}
*/
template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
struct DSU
{
    int n;
    vector <int> p;
    DSU() {}
    DSU(int _n)
    {
        n = _n;
        p.resize(n, -1);
    }
    int get(int u)
    {
        return p[u] < 0 ? u : p[u] = get(p[u]);
    }
    void unit(int u, int v)
    {
        u = get(u), v = get(v);
        if (u == v)
            return;
        if (-p[u] < -p[v])
            swap(u, v);
        p[u] += p [v];
        p[v] = u;
    }
};
signed main()
{
    Start();
    int n, m;
    cin >> n >> m;
    int ans = 0;
    vector <pii> edges;
    for (int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v, --u, --v;
        edges.pb(u, v);
    }
    for (int i = 0; i < m; ++i)
    {
        int j = i, cur = n;
        DSU tle(n);
        while (j < m)
        {
            int u = edges[j].first, v = edges[j].second;
            if (tle.get(u) == tle.get(v))
            {
                ++j;
                continue;
            }
            --cur;
            tle.unit(u, v);
            if (cur == 1)
                break;
            ++j;
        }
        ans += m - j;
    }
    cout << ans;
    return 0;
}
