#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
//#define int ll
//define double ld
#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;
/*
using namespace __gnu_pbds;
using supset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
*/
using ll = long long;
using ld = long double;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;
using pii = pair <int, int>;

const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete(void*) {}

template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

bool check(set <int>::iterator it, set <int> &f)
{
    return it == f.begin() || (++it) == f.end();
}

signed main()
{
    Start();
    int n;
    cin >> n;
    vector <pii> a(n);
    cin >> a;
    #define x first
    #define y second
    const int MAXX = 1e5 + 5;
    vector <set <int>> fx(MAXX), fy(MAXX);
    for (int i = 0; i < n; ++i)
    {
        fx[a[i].x].emplace(a[i].y);
        fy[a[i].y].emplace(a[i].x);
    }
    set <pii> extrem, inter;
    for (int i = 0; i < n; ++i)
    {
        if (check(fx[a[i].x].find(a[i].y), fx[a[i].x]) && check(fy[a[i].y].find(a[i].x), fy[a[i].y]))
            extrem.emplace(a[i]);
        else if (!check(fx[a[i].x].find(a[i].y), fx[a[i].x]) && !check(fy[a[i].y].find(a[i].x), fy[a[i].y]))
            inter.emplace(a[i]);
    }
    cout << extrem.size() << " " << inter.size() << endl;
    auto update = [&] (pii cur) -> void
    {
        extrem.erase(cur);
        inter.erase(cur);
        if (check(fx[cur.x].find(cur.y), fx[cur.x]) && check(fy[cur.y].find(cur.x), fy[cur.y]))
            extrem.emplace(cur);
        if (!check(fx[cur.x].find(cur.y), fx[cur.x]) && !check(fy[cur.y].find(cur.x), fy[cur.y]))
            inter.emplace(cur);
    };
    int q;
    cin >> q;
    vector <pii> toupd;
    for (int _ = 0; _ < q; ++_)
    {
        int type, xn, yn;
        cin >> type >> xn >> yn;
        if (type == 1)
        {
            toupd.pb(xn, yn);
            fx[xn].emplace(yn);
            fy[yn].emplace(xn);
            auto itx = fx[xn].find(yn);
            auto cur = itx;
            ++itx;
            if (itx != fx[xn].end() && cur == fx[xn].begin())
            {
                toupd.pb(xn, *itx);
            }
            --itx;
            if (itx != fx[xn].begin() && (++cur) == fx[xn].end())
            {
                --itx;
                toupd.pb(xn, *itx);
                ++itx;
            }
            auto ity = fy[yn].find(xn);
            cur = ity;
            ++ity;
            if (ity != fy[yn].end() && cur == fy[yn].begin())
            {
                toupd.pb(*ity, yn);
            }
            --ity;
            if (ity != fy[yn].begin() && (++cur) == fy[yn].end())
            {
                --ity;
                toupd.pb(*ity, yn);
                ++ity;
            }
        }
        else
        {
            extrem.erase(mp(xn, yn));
            inter.erase(mp(xn, yn));
            auto itx = fx[xn].find(yn);
            auto cur = itx;
            ++itx;
            if (itx != fx[xn].end() && cur == fx[xn].begin())
            {
                toupd.pb(xn, *itx);
            }
            --itx;
            if (itx != fx[xn].begin() && (++cur) == fx[xn].end())
            {
                --itx;
                toupd.pb(xn, *itx);
                ++itx;
            }
            auto ity = fy[yn].find(xn);
            cur = ity;
            ++ity;
            if (ity != fy[yn].end() && cur == fy[yn].begin())
            {
                toupd.pb(*ity, yn);
            }
            --ity;
            if (ity != fy[yn].begin() && (++cur) == fy[yn].end())
            {
                --ity;
                toupd.pb(*ity, yn);
                ++ity;
            }
            fx[xn].erase(yn);
            fy[yn].erase(xn);
        }
        for (auto &i : toupd)
            update(i);
        cout << extrem.size() << " " << inter.size() << endl;
        toupd = {};
    }
    return 0;
}
