#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math,unroll-all-loops")
#pragma GCC optimize("O3")
#pragma GCC target("tune=native,sse,sse2,popcnt")

#include <iostream>
#include <cmath>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <utility>
#include <tuple>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define int long long

int n, m;
vector< multiset<int> > adj;
vector<bool> used;

void dfs(int u) {
    used[u] = true;
    for(int v: adj[u]) {
        if(!used[v]) {
            dfs(v);
        }
    }
}

signed main() {
    cin >> n >> m;
    adj.resize(n);

    vector< pair<int, int> > edges(m);
    for(int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges[i] = make_pair(u, v);
    }

    int r = 0;
    int ans = 0;
    for(int l = 0; l < m; l++) {
        while(r <= m) {
            used.clear();
            used.resize(n);
            dfs(0);
            bool ok = true;
            for(int i = 0; i < n; i++) {
                ok = ok && used[i];
            }
            if(ok) {
                break;
            }
            if(r != m) {
                adj[edges[r].first].insert(edges[r].second);
                adj[edges[r].second].insert(edges[r].first);
            }
            r++;
        }
        ans += m - r + 1;
        adj[edges[l].first].erase(adj[edges[l].first].find(edges[l].second));
        adj[edges[l].second].erase(adj[edges[l].second].find(edges[l].first));
    }

    cout << ans;
    return 0;
}

// 4 4 1 2 2 4 1 3 1 4
