#include<bits/stdc++.h>

using namespace std;

int kol = 0;
int n, m;
vector<int> p1(0), p2(0);
vector<int> r1(0), r2(0);
vector<pair<int, int> > sp(0);
int ind = 0;

int color(int &x, bool fl) {
    if (fl) {
        if (p1[x] != x) {
            return color(p1[x], fl);
        }
    }
    else {
        if (p2[x] != x) {
            return color(p2[x], fl);
        }
    }
    return x;
}

bool unite(int a, int b, bool fl) {
    if (fl) {
        a = color(a, fl);
        b = color(b, fl);
        if (a == b) {
            return false;
        }
        if (r1[a] < r1[b]) {
            swap(a, b);
        }
        r1[a] += r1[b];
        p1[b] = a;
        return (r1[a] == n);
    }
    else {
        a = color(a, fl);
        b = color(b, fl);
        if (a == b) {
            return false;
        }
        if (r2[a] < r2[b]) {
            swap(a, b);
        }
        r2[a] += r2[b];
        p2[b] = a;
        return (r2[a] == n);
    }
}

void poisk_right(int &ind) {
    if (ind == m) {
        return;
    }
    if (unite(sp[ind].first, sp[ind].second, true)) {
        return;
    }
    poisk_right(++ind);
}

void poisk_left(int &ind) {
    if (ind == -1) {
        return;
    }
    if (unite(sp[ind].first, sp[ind].second, false)) {
        return;
    }
    poisk_left(--ind);
}

void solve() {
    cin >> n >> m;
    p1.resize(n);
    p2.resize(n);
    r1.resize(n);
    r2.resize(n);
    int u, v;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;
        --u;
        --v;
        sp.push_back({u, v});
    }
    long long ans = 0;
    long long ch1;
    long long ch2;
    int tmp;
    while (ind != m) {
        for (int i = 0; i < n; ++i) {
            p1[i] = i;
            p2[i] = i;
            r1[i] = 1;
            r2[i] = 1;
        }
        tmp = ind;
        poisk_right(ind);
        if (ind == m) {
            break;
        }
        ch1 = m - ind;
        poisk_left(ind);
        ch2 = ind - tmp + 1;
        ans += ch1 * ch2;
        ++ind;
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();
}

