#include<bits/stdc++.h>

using namespace std;

int n, m;
vector<int> p1(0), p2(0);
vector<int> r1(0), r2(0);
vector<pair<int, int> > sp(0);
int ch_a, ch_b;

int color(int &x, bool fl) {
    if (fl) {
        if (p1[x] != x) {
            return color(p1[x], fl);
        }
    }
    else {
        if (p2[x] != x) {
            return color(p2[x], fl);
        }
    }
    return x;
}

bool unite(int &a, int &b, bool fl) {
    if (fl) {
        ch_a = color(a, fl);
        ch_b = color(b, fl);
        if (ch_a == ch_b) {
            return false;
        }
        if (r1[ch_a] < r1[ch_b]) {
            swap(ch_a, ch_b);
        }
        r1[ch_a] += r1[ch_b];
        p1[ch_b] = ch_a;
        return (r1[ch_a] == n);
    }
    else {
        ch_a = color(a, fl);
        ch_b = color(b, fl);
        if (ch_a == b) {
            return false;
        }
        if (r2[ch_a] < r2[ch_b]) {
            swap(ch_a, ch_b);
        }
        r2[ch_a] += r2[ch_b];
        p2[ch_b] = ch_a;
        return (r2[ch_a] == n);
    }
}

int poisk_right(int ind) {
    if (ind == m) {
        return -1;
    }
    if (unite(sp[ind].first, sp[ind].second, true)) {
        return ind;
    }
    return poisk_right(ind + 1);
}

int poisk_left(int ind) {
    if (ind == -1) {
        return -1;
    }
    if (unite(sp[ind].first, sp[ind].second, false)) {
        return ind;
    }
    return poisk_left(ind - 1);
}

void solve() {
    cin >> n >> m;
    p1.resize(n);
    p2.resize(n);
    r1.resize(n);
    r2.resize(n);
    int u, v;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;
        --u;
        --v;
        sp.push_back({u, v});
    }
    int ind = 0;
    long long ans = 0;
    long long ch1 = 0;
    long long ch2 = 0;
    int tmp = 0;
    while (ind != m) {
        //cout << "! " << ind << endl;
        for (int i = 0; i < n; ++i) {
            p1[i] = i;
            p2[i] = i;
            r1[i] = 1;
            r2[i] = 1;
        }
        //cout << ind << " - ";
        ch1 = 0;
        ch2 = 0;
        tmp = ind;
        ind = poisk_right(ind);
        //cout << "CHECK! " << ind << endl;
        if (ind == -1) {
            break;
        }
        //cout << ind << endl;
        ch1 = m - ind;
        ind = poisk_left(ind);
        //cout << ind << " - " << tmp << endl;
        ch2 = ind - tmp + 1;
        ans += ch1 * ch2;
        ++ind;
        //cout << "* " << ans << endl;
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();
}

