#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define X first
#define Y second
#define pb push_back
#define sz(a) a.size()
//#define int long long
typedef long long ll;

using namespace std;
using namespace __gnu_pbds;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

vector <int> g[500010];

int step[500010];

void dfs(int v, int pr, int x) {
    step[v] = x;
    for (auto i : g[v]) {
        if (pr != i) {
            dfs(i, v, x + 1);
        }
    }
}

int rec(int v, int pr = -1) {
    if (step[v] % 2 == 0) {
        int k = 2;
        for (auto i : g[v]) {
            if (pr != i) {
                k = min(k, rec(i, v));
            }
        }
        return k;
    } else {
        int k = 1;
        for (auto i : g[v]) {
            if (pr != i) {
                k = max(k, rec(i, v));
            }
        }
        return k;
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int a, b;
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < n; i++) {
        dfs(i, -1, 0);
        cout << rec(i) - 1;
    }
    cout << endl;
    return 0;
}
