#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define X first
#define Y second
#define pb push_back
#define sz(a) a.size()
//#define int long long
typedef long long ll;

using namespace std;
using namespace __gnu_pbds;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

vector <int> g[500010];

int step[500010];
int used[500010];
int ans[500010];
int dp[500010];
int dp2[500010];

void dfs(int v, int pr, int x) {
    used[v] = 1;
    step[v] = x;
    for (auto i : g[v]) {
        if (pr != i) {
            dfs(i, v, x + 1);
        }
    }
}

void rec(int v, int pr = -1) {
    if (step[v] % 2 == 0) {
        dp[v] = 2;
        for (auto u : g[v]) {
            if (u != pr) {
                rec(u, v);
                dp[v] = min(dp[v], dp[u]);
            }
        }
    } else {
        dp[v] = 1;
        for (auto u : g[v]) {
            if (u != pr) {
                rec(u, v);
                dp[v] = max(dp[v], dp[u]);
            }
        }
    }
}

void rec2(int v, int pr = -1) {
    if (step[v] % 2 == 0) {
        dp2[v] = 1;
        for (auto u : g[v]) {
            if (u != pr) {
                rec2(u, v);
                dp2[v] = max(dp2[v], dp2[u]);
            }
        }
    } else {
        dp2[v] = 2;
        for (auto u : g[v]) {
            if (u != pr) {
                rec2(u, v);
                dp2[v] = min(dp2[v], dp2[u]);
            }
        }
    }
}

void ser(int v, int pr, int st, int xa, int xb) {
    if (st == 0) {
        ans[v] = min(dp[v], xa) - 1;
        for (auto u : g[v]) {
            if (u != pr) {
                int k2 = xa;
                int k = xb;
                for (auto su : g[v]) {
                    if (su != u) {
                        k = max(k, dp2[su]);
                    }
                }
                for (auto su : g[v]) {
                    if (su != u) {
                        k2 = min(k2, dp[su]);
                    }
                }
                ser(u, v, 1, k, k2);
            }
        }
    } else {
        ans[v] = min(dp2[v], xa) - 1;
        for (auto u : g[v]) {
            if (u != pr) {
                int k = xa;
                int k2 = xb;
                for (auto su : g[v]) {
                    if (su != u) {
                        k2 = max(k2, dp[su]);
                    }
                }
                for (auto su : g[v]) {
                    if (su != u) {
                        k = min(k, dp2[su]);
                    }
                }
                ser(u, v, 0, k2, k);
            }
        }
    }
}

set <int> kok;

int recs(int v, int pr = -1) {
    if (step[v] % 2 == 0) {
        int k = 2;
        for (auto i : g[v]) {
            if (pr != i) {
                k = min(k, recs(i, v));
            }
        }
        return k;
    } else {
        int k = 1;
        for (auto i : g[v]) {
            if (pr != i) {
                k = max(k, recs(i, v));
            }
        }
        return k;
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int a, b;
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < 20; i++) {
        kok.insert(1ll << i - 1);
    }
    if (kok.count(n) == 1) {
        for (int i = 0; i < n; i++) {
            if (used[i] == 0) {
                dfs(i, -1, 0);
                rec(i);
                rec2(i);
                ser(i, -1, 0, 2, 1);
            }
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i];
        }
    } else {
        for (int i = 0; i < n; i++) {
            dfs(i, -1, 0);
            cout << recs(i) - 1;
        }
        cout << endl;
    }
    return 0;
}
