#include <bits/stdc++.h>
using namespace std;

pair<int, int> edges[200005];
vector<int> g[50005];
bool visited[50005];

void dfs(int v){
    if(visited[v])
        return;
    visited[v] = true;
    for(auto x : g[v])
        dfs(x);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= m; ++i){
        cin >> edges[i].first >> edges[i].second;
    }

    int res = 0;
    for(int i = 1; i <= m; ++i){
        int x = edges[i].first;
        int y = edges[i].second;
        for(int j = min(x, m); j <= min(y, m - 1); ++j){
            g[edges[j].first].push_back(edges[j].second);
            g[edges[j].second].push_back(edges[j].first);
        }

        dfs(1);
        bool ok = true;
        for(int j = 1; j <= n; ++j){
            if(!visited[j])
                ok = false;
            visited[j] = false;
            g[j].clear();
        }

        if(ok){
            res++;
        }
    }

    cout << res << "\n";
    return 0;
}
