#include <bits/stdc++.h>
using namespace std;

vector<int> graph[500005];
int height[500005];
bool visited[500005];

void dfs(int v, int h){
    if(visited[v])
        return;
    visited[v] = true;
    height[v] = h;
    for(auto x : graph[v]){
        dfs(x, h + 1);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    int tstart = 0;
    for(int i = 1; i <= n; ++i){
        if(graph[i].size() == 1){
            tstart = i;
            break;
        }

    }
    dfs(tstart, 1);

    for(int i = 1; i <= n; ++i){
        int l = height[i] - 1;
        int r = n - height[i];
        if(l % 2 == 1 || r % 2 == 1){
            cout << "0";
        }else{
            cout << "1";
        }
    }
    cout << "\n";
    return 0;
}
