#include <bits/stdc++.h>
using namespace std;

vector<int> graph[500005];
bool dp[500005]; ///is this winning?
int height[500005];
bool visited[500005];

void dfs(int v, int p){
    if(visited[v])
        return;
    visited[v] = true;
    bool canWin = true;
    for(auto x : graph[v]){
        if(x == p)
            continue;
        dfs(x, v);
        canWin = canWin && (!dp[x]);
    }
    dp[v] = canWin;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int x, y;
        cin >> x>> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    for(int i = 1; i <= n; ++i){
        dfs(i, 0);
        if(dp[i])
            cout << 1;
        else
            cout << 0;
        for(int j = 1; j <= n; ++j)
            visited[j] = false;
    }

    cout << "\n";
    return 0;
}

/*
5 4
1 2
1 3
2 5
2 4

*/
