#include <bits/stdc++.h>
using namespace std;

pair<long long, long long> polong longs[200005];
pair<long long, long long> ogr[200005];

set<pair<long long, long long>> ver[100005];
set<pair<long long, long long>> hor[100005];

long long sz = -1;
long long cnIn = 0;
long long cnEx = 0;

void updPolong long(long long pos){
    if(ogr[pos].first <= 1 && ogr[pos].second <= 1){
        cnEx++;
    }else if(ogr[pos].first == 2 && ogr[pos].second == 2){
        cnIn++;
    }
}

void add(long long x, long long y){
    sz++;
    polong longs[sz] = {x, y};
    ver[x].insert({y, sz});
    hor[y].insert({x, sz});

    auto vEnd = ver[x].end();
    vEnd--;
    auto it = ver[x].find({y, sz});

    if(ver[x].size() == 1){
        ogr[it->second].second = 0;
    }else if(it == ver[x].begin()){
        auto itNext = it;
        itNext++;
        if(ogr[itNext->second].first <= 1 && ogr[itNext->second].second == 1){
            cnEx--;
        }
        ogr[itNext->second].second++;
        if(ogr[itNext->second].first == 2 && ogr[itNext->second].second == 2){
            cnIn++;
        }
        ogr[it->second].second = 1;

    }else if(it == vEnd){
        auto itPrev = it;
        itPrev--;
        if(ogr[itPrev->second].first <= 1 && ogr[itPrev->second].second == 1){
            cnEx--;
        }
        ogr[itPrev->second].second++;
        if(ogr[itPrev->second].first == 2 && ogr[itPrev->second].second == 2){
            cnIn++;
        }
        ogr[it->second].second = 1;
    }else{
        ogr[it->second].second = 2;
    }

    auto hEnd = hor[y].end();
    hEnd--;
    it = hor[y].find({x, sz});

    if(hor[y].size() == 1){
        ogr[it->second].first = 0;
    }else if(it == hor[y].begin()){
        auto itNext = it;
        itNext++;
        if(ogr[itNext->second].first == 1 && ogr[itNext->second].second <= 1){
            cnEx--;
        }
        ogr[itNext->second].first++;
        if(ogr[itNext->second].first == 2 && ogr[itNext->second].second == 2){
            cnIn++;
        }
        ogr[it->second].first = 1;

    }else if(it == hEnd){
        auto itPrev = it;
        itPrev--;
        if(ogr[itPrev->second].first == 1 && ogr[itPrev->second].second <= 1){
            cnEx--;
        }
        ogr[itPrev->second].first++;
        if(ogr[itPrev->second].first == 2 && ogr[itPrev->second].second == 2){
            cnIn++;
        }
        ogr[it->second].first = 1;

    }else{
        ogr[it->second].first = 2;
    }

    updPolong long(sz);
}

void remPolong long(long long pos){
    if(ogr[pos].first <= 1 && ogr[pos].second <= 1){
        cnEx--;
    }else if(ogr[pos].first == 2 && ogr[pos].second == 2){
        cnIn--;
    }
}

void rem(long long x, long long y){
    long long ind = 0;

    auto vEnd = ver[x].end();
    vEnd--;
    auto it = ver[x].upper_bound({y, 987654321});
    it--;

    ind = it->second;

    if(ver[x].size() == 1){

    }else if(it == ver[x].begin()){
        auto itNext = it;
        itNext++;

        if(ogr[itNext->second].first == 2 && ogr[itNext->second].second == 2){
            cnIn--;
        }
        ogr[itNext->second].second--;
        if(ogr[itNext->second].first <= 1 && ogr[itNext->second].second == 1){
            cnEx++;
        }

    }else if(it == vEnd){
        auto itPrev = it;
        itPrev--;
        if(ogr[itPrev->second].first == 2 && ogr[itPrev->second].second == 2){
            cnIn--;
        }
        ogr[itPrev->second].second--;
        if(ogr[itPrev->second].first <= 1 && ogr[itPrev->second].second == 1){
            cnEx++;
        }
    }

    auto hEnd = hor[y].end();
    hEnd--;
    it = hor[y].upper_bound({x, 987654321});
    it--;

    if(hor[y].size() == 1){
    }else if(it == hor[y].begin()){
        auto itNext = it;
        itNext++;
        if(ogr[itNext->second].first == 2 && ogr[itNext->second].second == 2){
            cnIn--;
        }
        ogr[itNext->second].first--;
        if(ogr[itNext->second].first == 1 && ogr[itNext->second].second <= 1){
            cnEx++;
        }

    }else if(it == hEnd){
        auto itPrev = it;
        itPrev--;
        if(ogr[itPrev->second].first == 2 && ogr[itPrev->second].second == 2){
            cnIn--;
        }
        ogr[itPrev->second].first--;
        if(ogr[itPrev->second].first == 1 && ogr[itPrev->second].second <= 1){
            cnEx++;
        }
    }

    remPolong long(ind);
    ver[x].erase(it);
    hor[y].erase(it);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    long long n;
    cin >> n;
    for(long long i = 0; i < n; ++i){
        cin >> polong longs[i].first >> polong longs[i].second;
        add(polong longs[i].first, polong longs[i].second);
        //cout << cnEx << " " << cnIn << "\n";
    }

    cout << cnEx << " " << cnIn << "\n";

    long long q;
    cin >> q;
    while(q--){
        long long t, x, y;
        cin >> t >> x >> y;
        if(t == 1){
            add(x, y);
        }else{
            rem(x, y);
        }

        cout << cnEx << " " << cnIn << "\n";
    }

    return 0;
}
