#include <bits/stdc++.h>
using namespace std;

pair<int, int> points[200005];
pair<int, int> ogr[200005];

set<pair<int, int>> ver[100005];
set<pair<int, int>> hor[100005];

int sz = -1;
int cnIn = 0;
int cnEx = 0;

void updPoint(int pos){
    if(ogr[pos].first <= 1 && ogr[pos].second <= 1){
        cnEx++;
    }else if(ogr[pos].first == 2 && ogr[pos].second == 2){
        cnIn++;
    }
}

void add(int x, int y){
    sz++;
    points[sz] = {x, y};
    ver[x].insert({y, sz});
    hor[y].insert({x, sz});

    auto vEnd = ver[x].end();
    vEnd--;
    auto it = ver[x].find({y, sz});

    if(ver[x].size() == 1){
        ogr[it->second].second = 0;
    }else if(it == ver[x].begin()){
        auto itNext = it;
        itNext++;
        if(ogr[itNext->second].first <= 1 && ogr[itNext->second].second == 1){
            cnEx--;
        }
        ogr[itNext->second].second++;
        if(ogr[itNext->second].first == 2 && ogr[itNext->second].second == 2){
            cnIn++;
        }
        ogr[it->second].second = 1;

    }else if(it == vEnd){
        auto itPrev = it;
        itPrev--;
        if(ogr[itPrev->second].first <= 1 && ogr[itPrev->second].second == 1){
            cnEx--;
        }
        ogr[itPrev->second].second++;
        if(ogr[itPrev->second].first == 2 && ogr[itPrev->second].second == 2){
            cnIn++;
        }
        ogr[it->second].second = 1;
    }else{
        ogr[it->second].second = 2;
    }

    auto hEnd = hor[y].end();
    hEnd--;
    it = hor[y].find({x, sz});

    if(hor[y].size() == 1){
        ogr[it->second].first = 0;
    }else if(it == hor[y].begin()){
        auto itNext = it;
        itNext++;
        if(ogr[itNext->second].first == 1 && ogr[itNext->second].second <= 1){
            cnEx--;
        }
        ogr[itNext->second].first++;
        if(ogr[itNext->second].first == 2 && ogr[itNext->second].second == 2){
            cnIn++;
        }
        ogr[it->second].first = 1;

    }else if(it == hEnd){
        auto itPrev = it;
        itPrev--;
        if(ogr[itPrev->second].first == 1 && ogr[itPrev->second].second <= 1){
            cnEx--;
        }
        ogr[itPrev->second].first++;
        if(ogr[itPrev->second].first == 2 && ogr[itPrev->second].second == 2){
            cnIn++;
        }
        ogr[it->second].first = 1;

    }else{
        ogr[it->second].first = 2;
    }

    updPoint(sz);
}

void remPoint(int pos){
    if(ogr[pos].first <= 1 && ogr[pos].second <= 1){
        cnEx--;
    }else if(ogr[pos].first == 2 && ogr[pos].second == 2){
        cnIn--;
    }
}

void rem(int x, int y){
    int ind = 0;

    auto vEnd = ver[x].end();
    vEnd--;
    auto it = ver[x].upper_bound({y, 987654321});
    it--;

    ind = it->second;

    if(ver[x].size() == 1){

    }else if(it == ver[x].begin()){
        auto itNext = it;
        itNext++;

        if(ogr[itNext->second].first == 2 && ogr[itNext->second].second == 2){
            cnIn--;
        }
        ogr[itNext->second].second--;
        if(ogr[itNext->second].first <= 1 && ogr[itNext->second].second == 1){
            cnEx++;
        }

    }else if(it == vEnd){
        auto itPrev = it;
        itPrev--;
        if(ogr[itPrev->second].first == 2 && ogr[itPrev->second].second == 2){
            cnIn--;
        }
        ogr[itPrev->second].second--;
        if(ogr[itPrev->second].first <= 1 && ogr[itPrev->second].second == 1){
            cnEx++;
        }
    }

    auto hEnd = hor[y].end();
    hEnd--;
    it = hor[y].upper_bound({x, 987654321});
    it--;

    if(hor[y].size() == 1){
    }else if(it == hor[y].begin()){
        auto itNext = it;
        itNext++;
        if(ogr[itNext->second].first == 2 && ogr[itNext->second].second == 2){
            cnIn--;
        }
        ogr[itNext->second].first--;
        if(ogr[itNext->second].first == 1 && ogr[itNext->second].second <= 1){
            cnEx++;
        }

    }else if(it == hEnd){
        auto itPrev = it;
        itPrev--;
        if(ogr[itPrev->second].first == 2 && ogr[itPrev->second].second == 2){
            cnIn--;
        }
        ogr[itPrev->second].first--;
        if(ogr[itPrev->second].first == 1 && ogr[itPrev->second].second <= 1){
            cnEx++;
        }
    }

    remPoint(ind);
    ver[x].erase({points[ind].second, ind});
    hor[y].erase({points[ind].first, ind});
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> points[i].first >> points[i].second;
        add(points[i].first, points[i].second);
        //cout << cnEx << " " << cnIn << "\n";
    }

    cout << cnEx << " " << cnIn << "\n";

    int q;
    cin >> q;
    while(q--){
        int t, x, y;
        cin >> t >> x >> y;
        if(t == 1){
            add(x, y);
        }else{
            rem(x, y);
        }

        cout << cnEx << " " << cnIn << "\n";
    }

    return 0;
}

/*
10
1 1
2 1
3 1
4 1
2 3
3 4
4 4
5 4
5 5
2 5
11
2 1 1
2 2 1
2 3 1
2 4 1
2 2 3
2 3 4
2 4 4
2 5 4
2 5 5
2 2 5
1 1 1
*/
