//#include <bits/stdc++.h>
//using namespace std;
//
//pair<int, int> edges[200005];
//vector<int> graph[50005];
//bool visited[50005];
//
//void dfs(int v, int p){
//    if(visited[v])
//        return;
//    visited[v] = true;
//
//    for(auto x : graph[v]){
//        if(x == p || x == v)
//            continue;
//        dfs(x, v);
//    }
//}
//
//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);cout.tie(0);
//
//    int n, m;
//    cin >> n >> m;
//    for(int i = 0; i < m; ++i){
//        cin >> edges[i].first >> edges[i].second;
//        edges[i].first--;
//        edges[i].second--;
//    }
//
//    int res = 0;
//    for(int z = 0; z < m; ++z){
//        int x = edges[z].first;
//        int y = edges[z].second;
//        if(x > y)
//            swap(x, y);
//        for(int i = x; i <= min(y, m); ++i){
//            int v1 = edges[i].first;
//            int v2 = edges[i].second;
//            graph[v1].push_back(v2);
//            graph[v2].push_back(v1);
//        }
//
//        dfs(0, -1);
//        bool ok = true;
//        for(int i = 0; i < n; ++i){
//            if(!visited[i])
//                ok = false;
//            visited[i] = false;
//            graph[i].clear();
//        }
//
//        if(ok){
//            res++;
//        }
//    }
//
//    cout << res << "\n";
//    return 0;
//}
//
///*
//2 5
//1 1
//1 2
//2 2
//1 1
//2 2
//
//4 5
//1 2
//2 3
//1 4
//1 3
//1 2
//*/

#include <bits/stdc++.h>
using namespace std;

//ako interval ne sadrzi jednu od artikulacionih grana, onda graf nije konnekted

pair<int, int> edges[200005];
vector<int> graph[50005];
bool visited[50005];

vector<int> g[50005];
int cnt = 0;

void dfs(int v){
    if(visited[v])
        return;
    visited[v] = true;
    cnt++;
    for(auto x : g[v])
        dfs(x);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= m; ++i){
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
        edges[i] = {x, y};
    }

    int res = 0;
    for(int i = 1; i <= m; ++i){
        int x = edges[i].first;
        int y = edges[i].second;
        for(int j = x; j <= min(y, m); ++j){
            g[edges[j].first].push_back(edges[j].second);
            g[edges[j].second].push_back(edges[j].first);
        }
        dfs(1);
        if(cnt == n)
            res++;
        if(cnt > n)
            while(1);

        for(int j = 1; j <= n; ++j){
            visited[j] = false;
            g[j].clear();
        }
        cnt = 0;
    }

    cout << res << "\n";
    return 0;
}

/*
10 11
1 9
7 8
7 10
6 7
2 4
2 3
3 5
1 2
7 9
1 6
2 5



*/
