#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <stack>
#include <set>
#include <queue>
#include <vector>

#define ll long long
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ss string
#define pb push_back

const int N = int(2e3) + 5, mod = int(1e9) + 7, INF = int(1e9);

using namespace std;

ll n, m, edge[N][N];

vector < int > g[N];

bool used[N];

ll c(int a){
    return m - a + 1;
}

void dfs(int v){
    used[v] = 1;
    for(auto e : g[v]){
        if(!used[e]){
            dfs(e);
        }
    }
}

int main(){
    speed;
    cin >> n >> m;
    int m1 = 0;
    for(int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        if(!edge[u][v]){
            edge[u][v] = edge[v][u] = 1;
            m1++;
            g[u].pb(v);
            g[v].pb(u);
        }
    }
    dfs(1);
    for(int i = 1; i <= n; i++){
        if(!used[i]){
            cout << 0;
            return 0;
        }
    }
    m = m1;
    ll ans = 0;
    for(int i = n - 1; i <= m; i++){
        ans += c(i);
    }
    cout << ans;
}
