#include <bits/stdc++.h>
#define pb push_back
#define F first
#define S second
//#define endl '\n'

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = INT_MAX / 2;
const ll INFL = LLONG_MAX / 2;

int N, Q;
int ext, ins;
int isExt[200007], isIns[200007];
int globalId;

struct point{
    int id, x, y;
    point(){};
    point(int _id, int _x, int _y){id = _id; x = _x; y = _y;}
    bool operator<(const point& b) const {
        if (x == b.x) return y < b.y;
        else return (x < b.x);
    }
    bool operator!=(const point& b) const {
        if (id != b.id && x != b.x && y != b.y) return 1;
    }
};

set<point> byX, byY;

int check_point(int x, int y, int id) {
    bool ver, hor = ver = 0;
    auto it = byX.lower_bound({id, x, y});
    if (it == byX.begin() || it == --(byX.end())) hor = 1;
    else {
        it--;
        if ((*it).x != x) hor = 1;
        else {
            it++; it++;
            if ((*it).x != x) hor = 1;
        }
    }
    it = byY.lower_bound({id, y, x});
    if (it == byY.begin() || it == --(byY.end())) ver = 1;
    else {
        it--;
        if ((*it).x != y) ver = 1;
        else {
            it++, it++;
            if ((*it).x != y) ver = 1;
        }
    }
    if (hor == 1 && hor == ver) return 1;
    else if (hor == 0 && hor == ver) return 0;
    else return 2;
}

void change(int t, int id) {
    if (!t) {
        if (isExt[id]) isExt[id] = 0, ext--;
        if (!isIns[id]) isIns[id] = 1, ins++;
    } else if (t == 1) {
        if (!isExt[id]) isExt[id] = 1, ext++;
        if (isIns[id]) isIns[id] = 0, ins--;
    } else {
        if (isExt[id]) isExt[id] = 0, ext--;
        if (isIns[id]) isIns[id] = 0, ins--;
    }
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cin >> N;
    vector<point> dots(N);
    for(int i = 0; i < N; i++) {
        int x, y;
        cin >> x >> y;
        byX.insert({i, x, y});
        byY.insert({i, y, x});
        dots[i] = {i, x, y};
    }
    for(int i = 0; i < N; i++) {
        int t = check_point(dots[i].x, dots[i].y, i);
        if (!t) isIns[dots[i].id] = 1, ins++;
        else if (t == 1) isExt[dots[i].id] = 1, ext++;
    }
    cout << ext << " " << ins << endl;
    cin >> Q;
    globalId = N;
    while(Q--) {
        int c, x, y;
        cin >> c >> x >> y;
        if (c == 1) {
            dots.push_back({globalId, x, y});
            byX.insert({globalId, x, y});
            byY.insert({globalId, y, x});
            point bh1, bh2, bv1, bv2 = bv1 = bh2 = bh1 = {-1, -1, -1};
            auto it = byX.lower_bound({globalId, x, y});
            if (it == byX.begin()) {
                it++;
                bh2 = (*it);
                int t = check_point(bh2.x, bh2.y, bh2.id);
                change(t, bh2.id);
            } else if (it == --(byX.end())) {
                it--;
                bh1 = (*it);
                int t = check_point(bh1.x, bh1.y, bh1.id);
                change(t, bh1.id);
            } else {
                it--;
                bh1 = (*it);
                int t = check_point(bh1.x, bh1.y, bh1.id);
                change(t, bh1.id);
                it++; it++;
                bh2 = (*it);
                t = check_point(bh2.x, bh2.y, bh2.id);
                change(t, bh2.id);
            }
            it = byY.lower_bound({globalId, y, x});
            if (it == byY.begin()) {
                it++;
                bv2 = (*it);
                point rv = {bv2.id, bv2.y, bv2.x};
                if (rv != bh1 && rv != bh2) {
                    int t = check_point(bv2.y, bv2.x, bv2.id);
                    change(t, bv2.id);
                }
            } else if (it == --(byY.end())) {
                it--;
                bv1 = (*it);
                point rv = {bv1.id, bv1.y, bv1.x};
                if (rv != bh1 && rv != bh2) {
                    int t = check_point(bv1.y, bv1.x, bv1.id);
                    change(t, bv1.id);
                }
            } else {
                it--;
                bv1 = (*it);
                point rv = {bv1.id, bv1.y, bv1.x};
                if (rv != bh1 && rv != bh2) {
                    int t = check_point(bv1.y, bv1.x, bv1.id);
                    change(t, bv1.id);
                }
                it++; it++;
                bv2 = (*it);
                rv = {bv2.id, bv2.y, bv2.x};
                if (rv != bh1 && rv != bh2) {
                    int t = check_point(bv2.y, bv2.x, bv2.id);
                    change(t, bv2.id);
                }
            }
            int t = check_point(x, y, globalId);
            change(t, globalId);
            globalId++;
        } else {
            point bh1, bh2, bv1, bv2 = bv1 = bh2 = bh1 = {-1, -1, -1};
            auto it = byX.lower_bound({globalId, x, y});
            int id = (*it).id;
            if (it == byX.begin()) {
                it++;
                bh2 = (*it);
            } else if (it == --(byX.end())) {
                it--;
                bh1 = (*it);
            } else {
                it--;
                bh1 = (*it);
                it++; it++;
                bh2 = (*it);
            }
            it = byY.lower_bound({globalId, y, x});
            if (it == byY.begin()) {
                it++;
                bv2 = (*it);
                point rv = {bv2.id, bv2.y, bv2.x};
                if (rv != bh1 && rv != bh2) {
                    bv2 = rv;
                }
            } else if (it == --(byY.end())) {
                it--;
                bv1 = (*it);
                point rv = {bv1.id, bv1.y, bv1.x};
                if (rv != bh1 && rv != bh2) {
                    bv1 = rv;
                }
            } else {
                it--;
                bv1 = (*it);
                point rv = {bv1.id, bv1.y, bv1.x};
                if (rv != bh1 && rv != bh2) {
                    bv1 = rv;
                }
                it++; it++;
                rv = {bv2.id, bv2.y, bv2.x};
                if (rv != bh1 && rv != bh2) {
                    bv2 = rv;
                }
            }
            byX.erase({globalId, x, y});
            byY.erase({globalId, y, x});
            int t;
            if (bh1.id != -1) {
                t = check_point(bh1.x, bh1.y, bh1.id);
                change(t, bh1.id);
            }
            if (bh2.id != -1) {
                t = check_point(bh2.x, bh2.y, bh2.id);
                change(t, bh2.id);
            }
            if (bv1.id != -1) {
                t = check_point(bv1.x, bv1.y, bv1.id);
                change(t, bv1.id);
            }
            if (bv2.id != -1) {
                t = check_point(bv2.x, bv2.y, bv2.id);
                change(t, bv2.id);
            }
            change(2, id);
        }
        cout << ext << " " << ins << endl;
    }
    return 0;
}
