//N+C
#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int MAX_N = 5e5 + 10;
vector<int> g[MAX_N];

int ans[MAX_N];
vector<int> trav;

void dfs(int curr, int p) {
	trav.push_back(curr);
	for(int i = 0; i < g[curr].size(); i ++) {
		if(g[curr][i] == p) {continue;}
		dfs(g[curr][i], curr);
	}
}

bool win(int x) {
	return !(x & 1);
}
int n, m;

bool used[MAX_N];

void play() {
	queue<int> q;
	for(int i = 1; i <= n; i ++) {
		if(g[i].size() == 1) {
			q.push(i);
			break;
		}
	}
	ans[q.front()] = 0;
	used[q.front()] = true;
	while(!q.empty()) {
		int curr = q.front(); q.pop();
		for(auto nxt : g[curr]) {
			if(used[nxt]) {continue;}
			used[nxt] = true;
			ans[nxt] = ans[curr] ^ 1;
			q.push(nxt);
		}
	}
	for(int i = 1; i <= n; i ++) {
		cout << !ans[i];
	}
}

int main() {
	//ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> n >> m;
	for(int i = 0; i < m; i ++) {
		int a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for(int i = 1; i <= n; i ++) {
		if(g[i].size() == 3) {
			play();
			return 0;
		}
	}
	for(int i = 1; i <= n; i ++) {
		if(g[i].size() == 1) {
			dfs(i, -1);
			break;
		}
	}
	for(int i = 0; i < trav.size(); i ++) {
		ans[trav[i]] = win(n - i	) | win(i + 1);
	}
	for(int i = 1; i <= n; i ++) {
		cout << !ans[i];
	}
	return 0;
}
