#include<iostream>
#include<vector>
using namespace std;

int n, m;
int u, v;

vector<int> sys[1048576];
vector<int> top;

int placeInOut[1048576];

bool used[1048576];

void dfs(int curr)
{
    used[curr] = true;

    for(int i = 0; i < sys[curr].size(); i++){
        if(!used[sys[curr][i]]){
            dfs(sys[curr][i]);
        }
    }

    placeInOut[curr] = top.size();
    top.push_back(curr);
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;

    for(int i = 0; i < m; i++){
        cin >> u >> v;
        u--;
        v--;
        sys[u].push_back(v);
        sys[v].push_back(u);
    }

	for(int i = 0; i < n; i++){
		if(!used[i]){dfs(i);}
	}

    for(int i = 0; i < n; i++){
        if(n%2 == 0){
            cout << 0;
            continue;
        }

        if(placeInOut[i]%2 == 1){
            cout << 1;
        }else{
            cout << 0;
        }

    }

return 0;
}
