#include <iostream>
#include <vector>
using namespace std;
struct Vertex {
    int u, num;
};
vector <Vertex> v[50002];
bool used[50002];
int n, m;
void dfs(int x, int l, int r) {
    used[x]=true;
    for (int i=0;i<v[x].size();i++) {
        if (!used[v[x][i].u] && v[x][i].num>=l && v[x][i].num<=r) dfs(v[x][i].u,l,r);
    }
}
bool connected(int l, int r) {
    for (int i=1;i<=n;i++) used[i]=false;
    dfs(1,l,r);
    for (int i=1;i<=n;i++) {
        if (!used[i]) return false;
    }
    return true;
}
int find_edges(int ind) {
    int l, r, mid;
    l=ind; r=m-1;
    while (l<=r) {
        mid=(l+r)/2;
        if (connected(ind,mid)) r=mid-1;
        else l=mid+1;
    }
    return l;
}
int main () {
    int a, b;
    cin >> n >> m;
    for (int i=0;i<m;i++) {
        cin >> a >> b;
        v[a].push_back({b,i});
        v[b].push_back({a,i});
    }
    int ans=0;
    for (int i=0;i<m;i++) {
        b=find_edges(i);
        ans+=m-b;
    }
    cout << ans << endl;
    return 0;
}
/**
4 4
1 2
2 4
1 3
1 4
**/
