#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int path[MAXN + 5];
bool win[MAXN + 5];
vector<int> G[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int N, M;
    cin >> N >> M;

    for (int i = 0; i < M; ++ i)
    {
        int u, v;
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 1; i <= N; ++ i)
    {
        if (G[i].size() == 1)
        {
            int k = 0;
            path[k++] = i;
            int j = G[i][0];
            do
            {
                path[k++] = j;
                if (G[j][0] == path[k - 2]) j = G[j][1];
                else j = G[j][0];
            }while (G[j].size() != 1);
            path[k++] = j;
            break;
        }
    }

    for (int i = 1; i <= N; ++ i)
    {
        if ((i - 1) % 2 == 0 and (N - i) % 2 == 0) win[path[i - 1]] = true;
    }

    for (int i = 1; i <= N; ++ i)
        cout << win[i];
    cout << endl;

    return 0;
}
