#include<bits/stdc++.h>
using namespace std;

struct reb
{
    int from;
    int to;
};
reb R[200000];

int n, m;
int allPC[50000];
int G[2000][2000];

bool visited[2000];

void ADDR(reb RR)
{
    G[RR.from][RR.to]=1;
    G[RR.to][RR.from]=1;
}

void REMOVER(reb RR)
{
    G[RR.from][RR.to]=0;
    G[RR.to][RR.from]=0;
}

int NumberNodes(int i, int j)
{
    for(int i = 0; i < n; i++)
        allPC[i] = 0;
    for(int k = i; k < j+1; k++)
    {
        allPC[R[k].from]=1;
        allPC[R[k].to]=1;
    }
    int sum = 0;
    for(int i = 0; i < n; i++)
        sum+=allPC[i];
    return sum;
}

void FillGs(int i, int j)
{
    int k;
    for(k = 0; k < n; k++)
        REMOVER(R[k]);

    for(k = i; k <= j; k++)
        ADDR(R[k]);
}

void Num(int k)
{
    if(visited[k])
        return;
    visited[k] = true;
    for(int i = 0; i < n; i++)
    {
        if(G[k][i]==1)
            Num(i);
    }
}

int VisitedNum()
{
    int a = 0;
    for(int i = 0; i < n; i++)
        if(visited[i])
        {
            a++;
            visited[i] = false;
        }
    return a;
}

bool IsConected(int i, int j)
{
    FillGs(i, j);
    Num(0);
    if(VisitedNum()==n)
        return true;
    else
        return false;
}

int main()
{
    int answ = 0;
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        cin >> R[i].from >> R[i].to;
        R[i].from--;
        R[i].to--;
    }

    for(int i = 0; i < m-1; i++)
    {
        for(int j = i+1; j < m; j++)
        {
            if(NumberNodes(i, j)<n)
                continue;
            if(IsConected(i, j))
            {
                answ += m-j;
                break;
            }
        }
    }
    cout << answ << endl;
    return 0;
}
