#include<bits/stdc++.h>
using namespace std;

struct Dot
{
    int x;
    int y;
};

Dot points[200000];
int S = 0;
int xmin[100000], xmax[100000], ymin[100000], ymax[100000];

int Check(int x, int y)
{
    if(x==-1||y==-1)
        return 2;
    int xBlocked = 0, yBlocked = 0;
    if(x<xmax[y])
        xBlocked++;
    if(x>xmin[y])
        xBlocked++;
    if(y<ymax[x])
        yBlocked++;
    if(y>ymin[x])
        yBlocked++;

    if(xBlocked==2&&yBlocked==2)
        return 0;
    if(xBlocked<2&&yBlocked<2)
        return 1;
    else return 2;
}

void AddPoint(int x, int y)
{
    points[S].x = x;
    points[S].y = y;
    S++;
}

dot RemovePoint(int x1, int y1)
{
    for(int i = 0; i < S; i++)
    {
        if(points[i].x==x1&&points[i].y==y1)
        {
            points[i].x= -1;
            points[i].y= -1;
            return points[i];
        }
    }
}

void Print()
{
    for(int i = 0; i < S; i++)
        cout << Check(points[i].x, points[i].y) << endl;
}

void Update(int N)
{
    for(int i = 0; i < 1000; i++)
    {
        xmin[i]=100001;
        xmax[i]=-1;
        ymin[i]=100001;
        ymax[i]=-1;
    }
    for(int i = 0; i < N; i++)
    {
        if(points[i].x==-1)
            continue;

        xmin[points[i].y] = min(xmin[points[i].y], points[i].x);
        xmax[points[i].y] = max(xmax[points[i].y], points[i].x);
        ymin[points[i].x] = min(ymin[points[i].x], points[i].y);
        ymax[points[i].x] = max(ymax[points[i].x], points[i].y);
    }
    //Print();
}

int main()
{
    int n;
    cin >> n;
    int a, b;
    for(int i = 0; i < n; i++)
    {
        cin >> a >> b;
        AddPoint(a-1, b-1);
    }
    int q;
    int c;
    cin >> q;
    int answ[100001][2];

    Update(S);
    for(int j = 0; j < S; j++)
    {
        if(Check(points[j].x, points[j].y) == 0)
            answ[0][1]++;
        else if(Check(points[j].x, points[j].y) == 1)
            answ[0][0]++;
    }
    cout << answ[0][0] << " " << answ[0][1] << endl;
    for(int i = 1; i <= q; i++)
    {
        answ[i][0] = answ[i][1] = 0;
        cin >> c >> a >> b;
        if(c==1)
        {
            AddPoint(a-1, b-1);
            xmin[points[S-1].y] = min(xmin[points[S-1].y], points[S-1].x);
            xmax[points[S-1].y] = max(xmax[points[S-1].y], points[S-1].x);
            ymin[points[S-1].x] = min(ymin[points[S-1].x], points[S-1].y);
            ymax[points[S-1].x] = max(ymax[points[S-1].x], points[S-1].y);
        }
        else
        {
            Dot d = RemovePoint(a-1, b-1);
            xmin[d.y] = min(xmin[d.y], d.x);
            xmax[d.y] = max(xmax[d.y], d.x);
            ymin[d.x] = min(ymin[d.x], d.y);
            ymax[d.x] = max(ymax[d.x], d.y);
        }
        for(int j = 0; j < S; j++)
        {
            if(Check(points[j].x, points[j].y) == 0)
                answ[i][1]++;
            else if(Check(points[j].x, points[j].y) == 1)
                answ[i][0]++;
        }
        cout << answ[i][0] << " " << answ[i][1] << endl;
    }

    return 0;
}
