#include<bits/stdc++.h>
using namespace std;

const int MAXN = 50000;
const int MAXM = 200000;

struct node{
	int v, w;
	node() {}
	node(int _v, int _w){
		v = _v;
		w = _w;
	}
};

struct edge{
	int u, v;
	edge() {}
	edge(int _u, int _v){
		u = _u;
		v = _v;
	}
};

bool used[MAXN];
int n, m, br;
vector<node> G[MAXN];
edge Edges[MAXM];
vector<pair<int, int>> ans;

void dfs(int v, int l, int r){
	if(br == n){
		bool met = 0;
		for(int i = 0; i < ans.size(); i ++){
			if(ans[i] == make_pair(l, r)){
				met = 1;
				break;
			}
		}
		if(met == 0){
			ans.push_back({l, r});
		}
	}
	if(used[v] == 1){
		return;
	}
	used[v] = 1; br ++;
	for(int i = 0; i < G[v].size(); i ++){
		if(l <= G[v][i].w && G[v][i].w <= r){
			dfs(G[v][i].v, l, r);
		}
	}
}

int main(){
	cin >> n >> m;
	for(int i = 1; i <= m; i ++){
		int u, v;
		cin >> u >> v;
		Edges[i] = edge(u, v);
		G[u].push_back(node(v, i));
		G[v].push_back(node(u, i));
	}
	for(int len = n - 1; len <= m; len ++){
		for(int i = 1; i <= m - len + 1; i ++){
			int j = i + len - 1;
			if(len == n - 1){
				memset(used, 0, sizeof(used));
				br = 0;
				dfs(Edges[i].u, i, j);
			}
			else{
				for(int i = 0; i < ans.size(); i ++){
					if(i <= ans[i].first && ans[i].second <= j){
						ans.push_back({i, j});
						break;
					}
				}
			}
		}
	}
	cout << ans.size() << endl;
}
/**
4 4
1 2
2 4
1 3
1 4
*/

