#include <iostream>
#include <vector>
#include <cstring>

using namespace std;

int n, m, x, y, lst;
bool ok;

vector <int> g[100005];
bool viz[100005], seen[100005];
int dist[100005];

void dfs(int nod, int t) {
  seen[nod] = 1;
  dist[nod] = dist[t] + 1;
  lst = nod;
  for(auto &vec : g[nod]) {
    if(!seen[vec])
      dfs(vec, nod);
  }
}

int main() {
  cin >> n >> m;
  for(; m; m--) {
    cin >> x >> y;
    g[x].push_back(y);
    g[y].push_back(x);
    viz[x] = viz[y] = 1;
  }
  dist[0] = -1;
  for(int i = 1; i <= n; i++) {
    if(viz[i]) {
      dfs(i, 0);
      break;
    }
  }
  for(int i = 1; i <= n; i++) {
    if(!viz[i])
      cout << 1;
    else {
      if(dist[i] % 2 == 0 && (dist[lst] - dist[i]) % 2 == 0)
        cout << 1;
      else
        cout << 0;
    }
  }
  return 0;
}
