#include <iostream>
#include <vector>
#include <cstring>

using namespace std;

int n, m, x, y, lst;
bool ok, bulaneala;

vector <int> g[200005];
bool viz[200005], seen[100005];
int dist[200005];

void dfs(int nod, int t) {
  seen[nod] = 1;
  dist[nod] = dist[t] + 1;
  lst = nod;
  for(auto &vec : g[nod]) {
    if(!seen[vec])
      dfs(vec, nod);
  }
}

int main() {
  cin >> n >> m;
  for(; m; m--) {
    cin >> x >> y;
    g[x].push_back(y);
    g[y].push_back(x);
    if(g[x].size() == 3 || g[y].size() == 3)
      bulaneala = 1;
    viz[x] = viz[y] = 1;
  }
  dist[0] = -1;
  if(bulaneala) {
    for(int i = 1; i <= n; i++) {
      if(g[i].size() == 2) {
        dfs(i, 0);
        break;
      }
    }
    for(int i = 1; i <= n; i++) {
      if(!viz[i])
        cout << 1;
      else {
        if(dist[lst] % 2 == dist[i] % 2)
          cout << 1;
        else
          cout << 0;
      }
    }
    return 0;
  }
  for(int i = 1; i <= n; i++) {
    if(viz[i]) {
      dfs(i, 0);
      break;
    }
  }
  for(int i = 1; i <= n; i++) {
    if(!viz[i])
      cout << 1;
    else {
      if(dist[i] % 2 == 0 && (dist[lst] - dist[i]) % 2 == 0)
        cout << 1;
      else
        cout << 0;
    }
  }
  return 0;
}
