#include <iostream>
#include <set>
#include <cassert>

using namespace std;

int n, q, a, b, t, x2, y2;

bool am[4][200005], ex[200005], in[200005]; // 0-st, 1-dr, 2-jos, 3-sus
int x[100005], y[100005];
set <pair <int, int>> X[100005], Y[100005];

bool isExtern(int i) {
  return ((!am[0][i] | !am[1][i]) & (!am[2][i] | !am[3][i]));
}

bool isIntern(int i) {
  return (am[0][i] & am[1][i] & am[2][i] & am[3][i]);
}

int main() {
  ios_base :: sync_with_stdio(false);
  cin.tie(0);
  cin >> n;
  for(int i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
    X[x[i]].insert({y[i], i});
    Y[y[i]].insert({x[i], i});
  }
  for(int i = 1; i <= n; i++) {
    auto it = X[x[i]].lower_bound({y[i], i});
    am[2][i] = (it != X[x[i]].begin());
    it++;
    am[3][i] = (it != X[x[i]].end());
    it = Y[y[i]].lower_bound({x[i], i});
    am[0][i] = (it != Y[y[i]].begin());
    it++;
    am[1][i] = (it != Y[y[i]].end());
  }
  for(int i = 1; i <= n; i++) {
    ex[i] = isExtern(i), in[i] = isIntern(i);
    a += ex[i];
    b += in[i];
  }
  cout << a << " " << b << "\n";
  cin >> q;
  for(; q; q--) {
    cin >> t >> x2 >> y2;
    if(t == 1) {
      int i;
      for(auto it : X[x2]) {
        i = it.second;
        if(in[i] & ex[i])
          continue;
        if(it.first < y2)
          am[3][i] = 1;
        else
          am[2][i] = 1;
        b += isIntern(i) - in[i];
        a += isExtern(i) - ex[i];
        in[i] = isIntern(i);
        ex[i] = isExtern(i);
      }
      for(auto it : Y[y2]) {
        i = it.second;
        if(in[i] & ex[i])
          continue;
        if(it.first < x2)
          am[1][i] = 1;
        else
          am[0][i] = 1;
        b += isIntern(i) - in[i];
        a += isExtern(i) - ex[i];
        in[i] = isIntern(i);
        ex[i] = isExtern(i);
      }
      n++;
      X[x2].insert({y2, n});
      Y[y2].insert({x2, n});
      i = n;
      auto it = X[x2].lower_bound({y2, i});
      am[2][i] = (it != X[x2].begin());
      it++;
      am[3][i] = (it != X[x2].end());
      it = Y[y2].lower_bound({x2, i});
      am[0][i] = (it != Y[y2].begin());
      it++;
      am[1][i] = (it != Y[y2].end());
      in[i] = isIntern(i);
      ex[i] = isExtern(i);
      a += ex[i], b += in[i];
      cout << a << " " << b << "\n";
    } else {
      int i;
      auto itX = X[x2].lower_bound({y2, 0}), itY = Y[y2].lower_bound({x2, 0});
      for(auto it : X[x2]) {
        i = it.second;
        if(in[i] & ex[i])
          continue;
        if(it.first < y2) {
          itX++;
          if(itX == X[x2].end()) {
            itX--, itX--;
            am[3][i] = !(itX->first ^ it.first);
            itX++, itX++;
          }
          itX--;
        } else if(it.first > y2 && itX == X[x2].begin()) {
          itX++;
          am[2][i] = !(itX->first ^ it.first);
          itX--;
        }
        b += isIntern(i) - in[i];
        a += isExtern(i) - ex[i];
        in[i] = isIntern(i);
        ex[i] = isExtern(i);
      }
      for(auto it : Y[y2]) {
        i = it.second;
        if(in[i] & ex[i])
          continue;
        if(it.first < x2) {
          itY++;
          if(itY == Y[y2].end()) {
            itY--, itY--;
            am[1][i] = !(itY->first ^ it.first);
            itY++, itY++;
          }
          itY--;
        } else if(it.first > x2 && itY == Y[y2].begin()) {
          itY++;
          am[0][i] = !(itY->first ^ it.first);
          itY--;
        }
        b += isIntern(i) - in[i];
        a += isExtern(i) - ex[i];
        in[i] = isIntern(i);
        ex[i] = isExtern(i);
      }
      i = itX->second;
      a -= ex[i], b -= in[i];
      in[i] = ex[i] = 1;
      X[x2].erase(itX);
      Y[y2].erase(itY);
      cout << a << " " << b << "\n";
    }
  }
  return 0;
}
