#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Edge {
  int x, y;
  bool operator < (const Edge &other) const {
    if(x == other.x)
      return (y <= other.y);
    return (x > other.x);
  }
} v[200005];

int n, m, cnt, ans;

bool viz[2005];
int sol[205][205];
int rg[2005], t[2005];

void join(int x, int y) {
  int tmp = x;
  while(tmp != t[tmp]) {
    int y = tmp;
    t[tmp] = x;
    tmp = y;
  }
  if(rg[x] > rg[y])
    t[y] = x, rg[x] += rg[y];
  else
    t[x] = y, rg[y] += rg[x];
}

int tata(int nod) {
  if(nod == t[nod])
    return nod;
  return tata(t[nod]);
}

int main() {
  cin >> n >> m;
  for(int i = 1; i <= m; i++) {
    cin >> v[i].x >> v[i].y;
    if(v[i].x > v[i].y)
      swap(v[i].x, v[i].y);
  }
  int lst = 1;
  for(int i = 1; i <= m; i++) {
    for(int j = 1; j <= n; j++)
      rg[j] = 1, t[j] = j;
    for(int j = i; j >= lst; j--) {
      if(tata(v[j].x) != tata(v[j].y))
        join(tata(v[j].x), tata(v[j].y));
      if(rg[tata(v[j].x)] == n) {
        ans += j;
        lst = j;
        break;
      }
    }
  }
  cout << ans;
  return 0;
}
