#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Edge {
  int x, y;
  bool operator < (const Edge &other) const {
    if(x == other.x)
      return (y <= other.y);
    return (x > other.x);
  }
} v[200005];

int n, m, cnt, ans;

bool viz[1005];
vector <int> gf[1005];

void dfs(int nod) {
  viz[nod] = 1;
  cnt++;
  for(auto &vec : gf[nod]) {
    if(!viz[vec])
      dfs(vec);
  }
}

int main() {
  cin >> n >> m;
  for(int i = 1; i <= m; i++) {
    cin >> v[i].x >> v[i].y;
    if(v[i].x > v[i].y)
      swap(v[i].x, v[i].y);
  }
  sort(v + 1, v + m + 1);
  for(int i = 1; i <= m; i++) {
    for(int j = 1; j <= i; j++) {
      if(v[j].y <= v[i].y) {
        gf[v[j].y].push_back(v[j].x);
        gf[v[j].x].push_back(v[j].y);
      }
    }
    cnt = 0;
    dfs(v[i].x);
    ans += (cnt == v[i].y - v[i].x + 1);
    for(int j = v[i].x; j <= v[i].y; j++)
      viz[j] = 0, gf[j].clear();
  }
  cout << ans;
  return 0;
}
