#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Edge {
  int x, y;
  bool operator < (const Edge &other) const {
    if(x == other.x)
      return (y <= other.y);
    return (x > other.x);
  }
} v[5005];

int n, m, cnt, ans;

bool viz[2005];
vector <int> gf[2005];

void dfs(int nod) {
  viz[nod] = 1;
  cnt++;
  for(auto &vec : gf[nod]) {
    if(!viz[vec])
      dfs(vec);
  }
}

bool conex(int l, int r) {
  for(int i = l; i <= r; i++) {
    gf[v[i].x].push_back(v[i].y);
    gf[v[i].y].push_back(v[i].x);
  }
  cnt = 0;
  dfs(1);
  for(int i = 1; i <= n; i++)
    viz[i] = 0, gf[i].clear();
  return (cnt == n);
}

int main() {
  cin >> n >> m;
  for(int i = 1; i <= m; i++) {
    cin >> v[i].x >> v[i].y;
    if(v[i].x > v[i].y)
      swap(v[i].x, v[i].y);
  }
  for(int i = 1; i <= m; i++) {
    int st = 1, dr = i, mid;
    while(st <= dr) {
      mid = (st + dr) >> 1;
      if(conex(mid, i))
        st = mid + 1;
      else
        dr = mid - 1;
    }
    ans += dr;
  }
  cout << ans;
  return 0;
}
