#include <fstream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
ifstream cin(".in");
ofstream cout(".out");
pair <int,int> muchii[200001];
long long cnt = 0,rez = 0,m,n,nr[50001],boss[50001];
void reset(){
    for(int i = 1;i <= n;i++)
    {
        nr[i] = 1;
        boss[i] = i;
    }
}
int root(int x){
    if(x == boss[x])
        return x;
    return boss[x] = root(boss[x]);
}
void unite(int x,int y){
    x = root(x);
    y = root(y);
    if(nr[x] > nr[y]){
        boss[y] = x;
        nr[x] += nr[y];
    }else{
        boss[x] = y;
        nr[y] += nr[x];
    }
}
int main()
{
    long long i;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(i = 1; i <= m; i++)
    {
        long long x,y;
        cin >> x >> y;
        muchii[i] = {x,y};
    }
    if(cnt > 1)
    {
        cout << 0;
        return 0;
    }
    else if(n == 2)
    {
        cout << 1;
        return 0;
    }
    for(i =1;i <= m;i++){
        reset();
        int j;
        for( j = i;j <= m;j++){
            unite(muchii[j].first,muchii[j].second);
            if(nr[root(muchii[j].first)] == n)
                break;
        }
        rez += m - j + 1;
    }
    cout << rez;
    return 0;
}
