#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

const int N = 2e5 + 2;

vector < char > dp[N];
vector < int > adia[N];
vector < int > unde[N];

char calc_dp(int nod, int i) {
    for (int next = 0; next < adia[nod].size(); ++next) {
        if (next == i)
            continue;
        if (dp[adia[nod][next]][unde[nod][next]] != 0)
            dp[nod][i] = (dp[nod][i] | !(dp[adia[nod][next]][unde[nod][next]] - 1));
        else
            dp[nod][i] = (dp[nod][i] | (!(calc_dp(adia[nod][next], unde[nod][next]) - 1)));
        if (dp[nod][i] == 1)
            break;
    }
    dp[nod][i]++;
    return dp[nod][i];
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, a, b;
    cin >> n >> m;
    while (m--) {
        cin >> a >> b;
        unde[a].push_back(adia[b].size());
        unde[b].push_back(adia[a].size());
        adia[a].push_back(b);
        adia[b].push_back(a);
    }
    for (int i = 1; i <= n; ++i)
        dp[i].resize(adia[i].size() + 1);
    for (int i = 1; i <= n; ++i)
        cout << !(calc_dp(i, adia[i].size()) - 1);
    return 0;
}
