#include <bits/stdc++.h>

using namespace std;

const int N = 50002;
const int M = 200002;
int n, m, cnt;
int p[N], Rank[N], nr[M];
pair<int, int>v[M];

int Find (int x) {
  if (p[x] == x)
    return x;
  else
    return p[x] = Find(p[x]);
}


void Union(int x, int y) {
  x = Find(x);
  y = Find(y);
  if (x != y) {
    if (Rank[y] < Rank[x]) {
      p[y] = x;
    }
    else if (Rank[y] > Rank[x]) {
      p[x] = y;
    }
    else if (Rank[y] == Rank[x]) {
      Rank[x]++;
      p[y] = x;
    }
    cnt--;
  }
}

int main()
{
  cin >> n >> m;
  for (int i = 1;i <= n; i++)
    Rank[i] = 1, p[i] = i;
  for (int i = 1; i <= m; i++) {
    cin >> v[i].first >> v[i].second;
  }
  if (m <= 5000) {
    int ans = 0;
    for (int i = 1; i <= m; i++) {
      for (int i = 1;i <= n; i++)
        Rank[i] = 1, p[i] = i;
      cnt = n;
      int poz = 0;
      for (int j = i; j >= 1; j--) {
        Union(v[j].first, v[j].second);
        if (cnt == 1) {
          poz = j;
          break;
        }
      }
      ans += poz;
    }
    cout << ans;
  }
  return 0;
}
