#include <bits/stdc++.h>

using namespace std;

const int N = 50002;
const int M = 200002;

int Rank[N], p[N];
pair<int, int>v[M];
int n, m, aib[M], cnt, aib1[M];
map<pair<int, int>, int>mp;
map<int, int>nod;

int Find (int x) {
  if (p[x] == x)
    return x;
  else
    return p[x] = Find(p[x]);
}


void Union(int x, int y) {
  x = Find(x);
  y = Find(y);
  if (x != y) {
    if (Rank[y] < Rank[x]) {
      p[y] = x;
    }
    else if (Rank[y] > Rank[x]) {
      p[x] = y;
    }
    else if (Rank[y] == Rank[x]) {
      Rank[x]++;
      p[y] = x;
    }
    cnt--;
  }
}


void update (int x, int val) {
  for (int i = x; i <= m; i += (i & -i)) {
    aib[i] += val;
  }
}
int query (int x) {
  int sum = 0;
  for (int i = x; i; i -= (i & -i))
    sum += aib[i];
  return sum;
}

void update1 (int x, int val) {
  for (int i = x; i <= m; i += (i & -i)) {
    aib1[i] += val;
  }
}
int query1 (int x) {
  int sum = 0;
  for (int i = x; i; i -= (i & -i))
    sum += aib1[i];
  return sum;
}

int main()
{
  cin >> n >> m;
  for (int i = 1; i <= m; i++) {
    cin >> v[i].first >> v[i].second;
    if (v[i].second < v[i].first)
      swap(v[i].first, v[i].second);
  }
  long long sol = 0;
  for (int i = 1; i <= m; i++) {
    if (mp[v[i]] != 0) {
      update(mp[v[i]], -1);
    }
    if (v[i].first != v[i].second) {
      if (nod[v[i].first])
        update1(nod[v[i].first], -1);
      if (nod[v[i].second])
        update1(nod[v[i].second], -1);
      update1(i, 2);
    }
    if (v[i].first != v[i].second) {
      mp[v[i]] = i;
      update(i, 1);
    }
    nod[v[i].first] = nod[v[i].second] = i;
    int st = 1, dr = i, ans = 0;
    int x = query(i);
    int y = query1 (i);
    while (st <= dr) {
      int mij = (st + dr) / 2;
      if (x - query(mij - 1) >= n - 1 && y - query1(mij - 1) == n) {
        st = mij + 1;
        ans = mij;
      }
      else
        dr = mij - 1;
    }
    sol += ans;
  }
  cout << sol;
  return 0;
}
