#include <iostream>
#include <set>

using namespace std;

const int N = (int) 1e5 + 7;
int n;
int q;
set<pair<int, int>> all;
set<pair<int, int>> pts[5];
set<int> xx[N];
set<int> yy[N];

int mnx(int x)
{
    return *xx[x].begin();
}

int mxx(int x)
{
    auto it = xx[x].end();
    it--;
    return *it;
}

int mny(int y)
{
    return *yy[y].begin();
}

int mxy(int y)
{
    auto it = yy[y].end();
    it--;
    return *it;
}

/// {
int mnx2(int x)
{
    auto it = xx[x].begin();
    it++;
    return *it;
}

int mxx2(int x)
{
    auto it = xx[x].end();
    it--;
    it--;
    return *it;
}

int mny2(int y)
{
    auto it = yy[y].begin();
    it++;
    return *it;
}

int mxy2(int y)
{
    auto it = yy[y].end();
    it--;
    it--;
    return *it;
}
/// }

int get(int x, int y)
{
    if (all.count({x, y}) == 0)
    {
        return 0;
    }
    int cnt = (mnx(x) == y || mxx(x) == y) + (mny(y) == x || mxy(y) == x);
    if (cnt == 0)
    {
        return 2;
    }
    if (cnt == 2)
    {
        return 1;
    }
    return 3;
}

struct KEK
{
    int x;
    int y;
    int a;
};

KEK kek[20];
int top;

void jojo(int x, int y)
{
    kek[++top] = {x, y, get(x, y)};
}

void addup(int x, int y)
{
    top = 0;
    jojo(x, y);
    if ((int) xx[x].size() >= 1)
    {
        jojo(x, mnx(x));
        jojo(x, mxx(x));
        if ((int) xx[x].size() >= 2)
        {
            jojo(x, mnx2(x));
            jojo(x, mxx2(x));
        }
    }
    if ((int) yy[y].size() >= 1)
    {
        jojo(mny(y), y);
        jojo(mxy(y), y);
        if ((int) yy[y].size() >= 2)
        {
            jojo(mny2(y), y);
            jojo(mxy2(y), y);
        }
    }
}

void scm()
{
    for (int i = 1; i <= top; i++)
    {
        int x = kek[i].x;
        int y = kek[i].y;
        int init = kek[i].a;
        int now = get(x, y);
        if (init != now)
        {
            pts[init].erase({x, y});
            pts[now].insert({x, y});
        }
    }
}

void ins(int x, int y)
{
    addup(x, y);
    all.insert({x, y});
    xx[x].insert(y);
    yy[y].insert(x);
    scm();
}

void del(int x, int y)
{
    addup(x, y);
    all.erase({x, y});
    xx[x].erase(y);
    yy[y].erase(x);
    scm();
}





void print()
{
    cout << (int) pts[1].size() << " " << (int) all.size() - (int) pts[1].size() - (int) pts[3].size() << "\n";
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int x, y;
        cin >> x >> y;
        ins(x, y);
    }
    cin >> q;
    print();
    for (int i = 1; i <= q; i++)
    {
        int t, x, y;
        cin >> t >> x >> y;
        if (t == 1)
        {
            ins(x, y);
        }
        else
        {
            del(x, y);
        }
        print();
    }

}
