#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 1e5 + 5;

struct punct
{
    int x, y;
};

punct a[NMAX];

int n, q;

deque <int> Lin[NMAX], Col[NMAX];

int MinLin[NMAX];
int MaxLin[NMAX];
int MinCol[NMAX];
int MaxCol[NMAX];

int nr_extern;
int nr_intern;

int x, y;

bool Punct_Extern(int x, int y)
{
    if ((y == Lin[x].front() || y == Lin[x].back()) && (x == Col[y].front() || x == Col[y].back())) return true;

    return false;
}

bool Punct_Intern (int x, int y)
{
    if (y > Lin[x].front() && y < Lin[x].back() && x > Col[y].front() && x < Col[y].back()) return true;

    return false;
}

void Initializare()
{
    for (int i = 1; i <= n; ++i)
    {
        nr_extern = nr_extern + Punct_Extern(a[i].x, a[i].y);
        nr_intern = nr_intern + Punct_Intern(a[i].x, a[i].y);
    }
}

int main()
{
    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> x >> y;
        a[i] = {x, y};
        Lin[x].push_back(y);
        Col[y].push_back(x);
    }

    for (int i = 0; i <= 100000; ++i)
    {
        if (!Lin[i].empty()) sort(Lin[i].begin(), Lin[i].end());
        if (!Col[i].empty()) sort(Col[i].begin(), Col[i].end());
    }
    Initializare();
    cout << nr_extern << " " << nr_intern << '\n';
    cin >> q;
    for (; q; --q)
    {
        int tip;
        cin >> tip >> x >> y;

        if (tip == 1)
        {
            if (!Lin[x].empty() && Lin[x].back() < y)
            {
                if (Punct_Extern(x, Lin[x].back()) == true && Lin[x].size() > 1) nr_extern--;
                if (Punct_Extern(x, Lin[x].back()) == false && Lin[x].size() > 1) nr_intern++;
            }
            else if (!Lin[x].empty() && Lin[x].front() > y)
            {
                if (Punct_Extern(x, Lin[x].front()) == true && Lin[x].size() > 1) nr_extern--;
                if (Punct_Extern(x, Lin[x].front()) == false && Lin[x].size() > 1) nr_intern++;
            }
            if (!Col[y].empty() && Col[y].back() < x)
            {
                if (Punct_Extern(Col[y].back(), y) == true && Col[y].size() > 1) nr_extern--;
                if (Punct_Extern(Col[y].back(), y) == false && Col[y].size() > 1) nr_intern++;
            }
            else if (!Col[y].empty() && Col[y].front() > x)
            {
                if (Punct_Extern(Col[y].front(), y) == true && Col[y].size() > 1) nr_extern--;
                if (Punct_Extern(Col[y].front(), y) == false && Col[y].size() > 1) nr_intern++;
            }

            int st = 0;
            int dr = Lin[x].size()-1;
            int poz = -1;
            while (st <= dr)
            {
                int mij = (st + dr) / 2;

                if (Lin[x][mij] < y)
                {
                    poz = mij;
                    st = mij + 1;
                }
                else dr = mij - 1;
            }
            poz++;
            Lin[x].push_back(y);
            for (int i = Lin[x].size()-1; i > poz; --i)
                Lin[x][i] = Lin[x][i-1];
            Lin[x][poz] = y;

            st = 0;
            dr = Col[y].size()-1;
            poz = -1;
            while (st <= dr)
            {
                int mij = (st + dr) / 2;

                if (Col[y][mij] < x)
                {
                    poz = mij;
                    st = mij + 1;
                }
                else dr = mij - 1;
            }
            poz++;
            Col[y].push_back(x);
            for (int i = Col[y].size()-1; i > poz; --i)
                Col[y][i] = Col[y][i-1];
            Col[y][poz] = x;

            if (Punct_Extern(x, y) == true) nr_extern++;
            if (Punct_Intern(x, y) == true) nr_intern++;
        }
        else
        {
            if (Punct_Extern(x, y) == true) nr_extern--;
            if (Punct_Intern(x, y) == true) nr_intern--;

            if (Lin[x].back() == y)
            {
                Lin[x].pop_back();
                if (Lin[x].size() > 1 && Punct_Extern(x, Lin[x].back()) == true) nr_extern++;
                if (Lin[x].size() > 1)
                {
                    int valy = Lin[x].back();
                    Lin[x].push_back(y);

                    if (Punct_Intern(x, valy) == true) nr_intern--;
                }
                else Lin[x].push_back(y);
            }
            else if (Lin[x].front() == y)
            {
                Lin[x].pop_front();
                if (Lin[x].size() > 1 && Punct_Extern(x, Lin[x].front()) == true) nr_extern++;
                if (Lin[x].size() > 1)
                {
                    int valy = Lin[x].front();
                    Lin[x].push_front(y);

                    if (Punct_Intern(x, valy) == true) nr_intern--;
                }
                else Lin[x].push_front(y);
            }

            if (Col[y].back() == x)
            {
                Col[y].pop_back();
                if (Col[y].size() > 1 && Punct_Extern(Col[y].back(), y) == true) nr_extern++;
                if (Col[y].size() > 1)
                {
                    int valx = Col[y].back();
                    Col[y].push_back(x);

                    if (Punct_Intern(valx, y) == true) nr_intern--;
                }
                else Col[y].push_back(y);
            }
            else if (Col[y].front() == x)
            {
                Col[y].pop_front();
                if (Col[y].size() > 1 && Punct_Extern(Col[y].front(), y) == true) nr_extern++;
                if (Col[y].size() > 1)
                {
                    int valx = Col[y].front();
                    Col[y].push_front(y);

                    if (Punct_Intern(valx, y) == true) nr_intern--;
                }
                else Col[y].push_front(y);
            }

            int st = 0;
            int dr = Lin[x].size() - 1;
            int poz = -1;
            while (st <= dr)
            {
                int mij = (st + dr) / 2;

                if (Lin[x][mij] == y)
                {
                    poz = mij;
                    break;
                }
                else if (Lin[x][mij] < y) st = mij + 1;
                else dr = mij - 1;
            }
            for (int i = poz; i < Lin[x].size()-1; ++i)
                Lin[x][i] = Lin[x][i+1];
            Lin[x].pop_back();

            st = 0;
            dr = Col[y].size() - 1;
            poz = -1;
            while (st <= dr)
            {
                int mij = (st + dr) / 2;

                if (Col[y][mij] == x)
                {
                    poz = mij;
                    break;
                }
                else if (Col[y][mij] < x) st = mij + 1;
                else dr = mij - 1;
            }
            for (int i = poz; i < Col[y].size()-1; ++i)
                Col[y][i] = Col[y][i+1];
            Col[y].pop_back();
        }

        cout << nr_extern << " " << nr_intern << '\n';
    }
    return 0;
}
