#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 5e4 + 5;
constexpr int MMAX = 2e5 + 5;

int n, m;

struct muchie
{
    int x, y;
};
muchie a[MMAX];
bool use[MMAX];
bool viz[NMAX];

vector <int> G[NMAX];

int sol;

void dfs (int node)
{
    viz[node] = 1;

    for (int i = 0; i < G[node].size(); ++i)
    {
        int ind = G[node][i];
        if (use[ind] == 0) continue;

        int to = a[ind].x;
        if (to == node) to = a[ind].y;

        if (!viz[to])
            dfs(to);
    }
}

bool conex()
{
    bool ok = true;

    for (int i = 1; i <= n; ++i)
        if (viz[i] == 0) ok = false;

    for (int i = 1; i <= n; ++i)
        viz[i] = 0;

    return ok;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; ++i)
    {
        int x, y;

        cin >> x >> y;

        a[i] = {x, y};

        G[x].push_back(i);
        G[y].push_back(i);
    }

    int dr = 0;

    for (int st = 1; st <= m; ++st)
    {
        use[st-1] = 0;

        if (dr > m) break;

        for (; dr <= m; ++dr)
        {
            use[dr] = 1;
            dfs(1);
            if (conex() == true)
            {
                sol = sol + m - dr + 1;
                break;
            }
        }
    }

    cout << sol << '\n';
    return 0;
}
