#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 5e4 + 5;
constexpr int MMAX = 2e5 + 5;

int n, m;

struct muchie
{
    int x, y;
};
muchie a[MMAX];
bool viz[NMAX];

vector <int> G[NMAX];

int globst, globdr;

int sol;

void dfs (int node)
{
    viz[node] = 1;

    for (int i = 0; i < G[node].size(); ++i)
    {
        int ind = G[node][i];

        if (globst > ind || globdr < ind) continue;

        int to = a[ind].x;
        if (to == node) to = a[ind].y;

        if (!viz[to])
            dfs(to);
    }
}

bool conex(int st, int dr)
{
    globst = st;
    globdr = dr;
    dfs(1);
    bool ok = true;

    for (int i = 1; i <= n; ++i)
        if (viz[i] == 0) ok = false;

    for (int i = 1; i <= n; ++i)
        viz[i] = 0;

    return ok;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; ++i)
    {
        int x, y;

        cin >> x >> y;

        a[i] = {x, y};

        G[x].push_back(i);
        G[y].push_back(i);
    }

    int dr = 1;

    for (int st = 1; st <= m; ++st)
    {
        int l = dr;
        int r = m;
        int ind = 0;

        while (l <= r)
        {
            int mij = (l + r) / 2;

            if (conex(st, mij) == true)
            {
                ind = mij;
                r = mij - 1;
            }
            else l = mij + 1;
        }

        if (ind == 0) break;

        dr = ind;
        sol = sol + m - dr + 1;
    }

    cout << sol << '\n';
    return 0;
}
