#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int N_MAX = 50002;
const int M_MAX = 200002;

int n, m;

struct Edge
{
    int u, v;
};

Edge edges[M_MAX];

ll ans;

int root[N_MAX];

int cnt;

int find_root (int node)
{
    if(root[node] == node)
        return node;
    return root[node] = find_root(root[node]);
}

void join (int u, int v)
{
    u = find_root(u);
    v = find_root(v);
    if(u != v)
    {
        root[u] = v;
        cnt--;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for(int i = 1; i <= m; i++)
        cin >> edges[i].u >> edges[i].v;
    int pos = m;
    for(int i = m; i >= 1; i--)
    {
        for(int j = 1; j <= n; j++)
            root[j] = j;
        cnt = n;
        for(int j = i; j <= pos; j++)
        {
            join(edges[j].u, edges[j].v);
            if(cnt == 1)
            {
                ans += m - j + 1;
                pos = j;
                break;
            }
        }
    }
    cout << ans << "\n";
    return 0;
}
