#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define pii std::pair<int, int>
#define pb push_back
#define int ll
using namespace std;



namespace dsu {
    int *p, *s, cnt;
    void init(int n) {
    	p = new int[n];
    	s = new int[n];
    	cnt = n;
    	for (int i = 0; i < n; ++i) {
			s[i] = 1;
			p[i] = i;
    	}
    }
    int get(int i) {
		return (i == p[i] ? i : p[i] = get(p[i]));
	}

	bool merge(int a, int b) {
		a = get(a);
		b = get(b);
		if (a == b)
			return 0;
		if (s[a] > s[b])
			swap(a, b);
		s[b] += s[a];
        cnt--;
        p[a] = b;
        return 0;
	}
}

signed main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	#ifndef EVAL
	freopen("input.txt", "r", stdin);
	#endif // EVAL
	int n, m;
	cin >> n >> m;
	vector<pii> v;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		v.pb({a, b});
	}
	int ans = 0;
	for (int i = 0; i < m; ++i) {
		dsu::init(n);
		for (int j = i; j < m; ++j) {
			dsu::merge(v[j].f, v[j].s);
			ans += (dsu::cnt == 1);
		}
	}
    cout << ans << endl;
    return 0;
}
