#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#pragma GCC optimize('fast-math')

#define f first
#define s second
#define pii pair<int, int>
#define pb push_back

using namespace std;

const int maxn = 5e5 + 50;
vector<int> r[maxn];
bool dp[maxn];
int sum[maxn];
bool ans[maxn];
bool used[maxn];

void dfs(int v, int p = -1) {
    //int sum = 0;
    used[v] = 1;
    for (auto &u : r[v]) {
		if (u == p)
			continue;
		dfs(u, v);
		sum[v] += dp[u];
    }
    dp[v] = !sum[v];
}

void rek(int v, int p = -1) {
	ans[v] = dp[v];
	for (auto &u : r[v]) {
		if (u == p)
			continue;
		dp[v] = !(sum[v] -= dp[u]);
		dp[u] = !(sum[u] += dp[v]);
		rek(u, v);
		dp[u] = !(sum[u] -= dp[v]);
		dp[v] = !(sum[v] += dp[u]);
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	#ifndef EVAL
	freopen("input.txt", "r", stdin);
	#endif // EVAL
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		r[a].pb(b);
		r[b].pb(a);
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
		dfs(i);
		rek(i);
		}

	}
	// TODO TREE FOREST
	for (int i = 0; i < n; ++i)
		cout << ans[i];
	cout << endl;

    return 0;
}
