#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define pii pair<int, int>
#define pb push_back
using namespace std;

const int maxn = 5e5 + 50;
vector<int> r[maxn];
bool dp[maxn];
int sum[maxn];
string ans;
bool used[maxn];

void dfs(const int& v, const int &p = -1) {
    //int sum = 0;
    used[v] = 1;
    for (auto &u : r[v]) {
		if (u == p)
			continue;
		dfs(u, v);
		sum[v] += dp[u];
    }
    dp[v] = !sum[v];
}

void rek(const int& v, const int &p = -1) {
	ans[v] = dp[v] + '0';
	for (auto &u : r[v]) {
		if (u == p)
			continue;
		dp[v] = !(sum[v] -= dp[u]);
		dp[u] = !(sum[u] += dp[v]);
		rek(u, v);
		dp[u] = !(sum[u] -= dp[v]);
		dp[v] = !(sum[v] += dp[u]);
	}
}

signed main()
{
	freopen("Ludo.in", "r", stdin);
	freopen("Ludo.out", "w", stdout);
	int n, m;
	scanf("%d %d", &n, &m);
	ans.resize(n, '0');
	for (int i = 0; i < m; ++i) {
		int a, b;
		scanf("%d %d", &a, &b);
		a--;
		b--;
		r[a].pb(b);
		r[b].pb(a);
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
			rek(i);
		}
	}
	// TODO TREE FOREST
	printf("%s", ans.c_str());

    return 0;
}
