#include <bits/stdc++.h>
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define pb push_back
#define fst first
#define snd second
typedef long long ll;
typedef long double ld;
using namespace std;

vector<int> par;
vector<int> sz;
vector<multiset<int>> g;
vector<int> used;
int n, m;

int get(int a){
    if (par[a] == a) return a;
    return par[a] = get(par[a]);
}

int union_set(int a, int b){
    a = get(a);
    b = get(b);
    if (a == b)
        return 0;
    if (sz[a] > sz[b])
        swap(a, b);
    par[a] = b;
    sz[b] += sz[a];
    return 1;
}

int col = 0;

int kolvo = 0;

void dfs(int v){
    used[v] = col;
    kolvo++;
    if (kolvo == n)
        return;
    for (auto u : g[v]){
        if (used[u] != col){
            dfs(u);
        }
        if (kolvo == n)
            return;
    }
}

bool check(){
    col++;
    kolvo = 0;
    dfs(0);
    return (kolvo == n);
}

signed main() {
    ios;
    cin >> n >> m;
    sz.resize(n);
    par.resize(n);
    vector<pair<int, int>> seg (m);
    g.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++){
        cin >> seg[i].fst >> seg[i].snd;
        seg[i].fst--;
        seg[i].snd--;
    }
    ll ans = 0;
    ll ans2 = 0;
    if (n >= 200){
        for (int i = 0; i < m; i++){
            int now = n;
            for (int j = 0; j < n; j++){
                par[j] = j;
                sz[j] = 1;
            }
            int j = i;
            while(now != 1 && j < m){
                now -= union_set(seg[j].fst, seg[j].snd);
                if (now != 1)
                    j++;
            }
            if (now == 1){
                ans += (m - j);
            }
        }
    }else{
        int l = 0;
        int r = 0;
        bool bl = 0;
        while(l != m){
            r = max(r, l);
            while(!bl && r < m){
                g[seg[r].fst].insert(seg[r].snd);
                g[seg[r].snd].insert(seg[r].fst);
                bl = check();
                if (!bl)
                    r++;
            }
            if (bl){
                ans2 += (m - r);
            }
            g[seg[l].fst].erase(g[seg[l].fst].lower_bound(seg[l].snd));
            g[seg[l].snd].erase(g[seg[l].snd].lower_bound(seg[l].fst));
            l++;
            bl = check();
        }
    }
    cout << ans2 << endl;
}
