#include <bits/stdc++.h>

using namespace std;

void solve();

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

struct point {
    int x, y;
    bool lg, rg, uv, dv;
    point (int xx, int yy) {
        x = xx;
        y = yy;
    }
    point () {
        lg = false, rg = false, uv = false, dv = false;
    }
    void seet (int xx, int yy) {
        x = xx;
        y = yy;
    }
};

int n, q, fans, sans, xx, yy;
map < pair < int, int >, point > ma;
point tp;
map < int, set < int > > g, v;

bool fa(point p) {
    return (p.lg == false || p.rg == false) && (p.uv == false || p.dv == false);
}

bool sa(point p) {
    return p.lg == true && p.rg == true && p.uv == true && p.dv == true;
}

void update(int x1, int y1, int x2, int y2) {
    point p = ma[{x1, y1}];
    if (fa(p)) {
        //cout << x1 << " " << y1 << " " << x2 << " " << y2 << " -fa" << endl;
        fans--;
    }
    if (sa(p)) {
        //cout << x1 << " " << y1 << " " << x2 << " " << y2 << " -sa" << endl;
        sans--;
    }
    if (x1 == x2) {
        if (y1 < y2) p.uv = true;
        else p.dv = true;
    } else if (y1 == y2) {
        if (x1 < x2) p.rg = true;
        else p.lg = true;
    }
    ma[{x1, y1}] = p;
    if (fa(p)) {
        //cout << p.rg << " " << p.lg << " " << x1 << " " << y1 << " " << x2 << " " << y2 << " +fa" << endl;
        fans++;
    }
    if (sa(p)) {
        //cout << x1 << " " << y1 << " " << x2 << " " << y2 << " +sa" << endl;
        sans++;
    }
}

void dupdate(int x1, int y1, int x2, int y2) {
    point p = ma[{x1, y1}];
    if (fa(p)) fans--;
    if (sa(p)) sans--;
    if (x1 == x2) {
        if (y1 < y2) p.uv = false;
        else p.dv = false;
    } else if (y1 == y2) {
        if (x1 < x2) p.rg = false;
        else p.lg = false;
    }
    if (fa(p)) fans++;
    if (sa(p)) sans++;
}

void add(int x, int y) {
    set < int > gor = g[y], ver = v[x];
    point np;
    auto itg = gor.lower_bound(x);
    if (itg != gor.end()) {
        //cout << "R" << endl;
        xx = (*itg);
        yy = y;
        update(xx, yy, x, y);
        np.rg = true;
    }
    if (itg != gor.begin()) {
        //cout << "L" << endl;
        itg--;
        xx = (*itg);
        yy = y;
        update(xx, yy, x, y);
        np.lg = true;
    }
    auto itv = ver.lower_bound(y);
    if (itv != ver.end()) {
        //cout << "U" << endl;
        yy = (*itv);
        xx = x;
        update(xx, yy, x, y);
        np.uv = true;
    }
    if (itv != ver.begin()) {
        //cout << "D" << endl;
        itv--;
        yy = (*itv);
        xx = x;
        update(xx, yy, x, y);
        np.dv = true;
    }
    if (fa(np)) fans++;
    if (sa(np)) sans++;
    ma[{x, y}] = np;
    g[y].insert(x);
    v[x].insert(y);
}

void del(int x, int y) {
    point np = ma[{x, y}];
    if (fa(np)) fans--;
    if (sa(np)) sans--;
    ma.erase({x, y});
    g[y].erase(x);
    v[x].erase(y);
    set < int > gor = g[y], ver = v[x];
    auto itg = gor.lower_bound(x);

    if (itg != gor.end() && itg == gor.begin()) {

        xx = (*itg);
        yy = y;
        dupdate(xx, yy, x, y);
    }
    if (itg != gor.begin() && itg == gor.end()) {
        itg--;
        xx = (*itg);
        yy = y;
        dupdate(xx, yy, x, y);
    }
    auto itv = ver.lower_bound(y);
    if (itv != ver.end() && itv == ver.begin()) {
        //cout << "U" << endl;
        yy = (*itv);
        xx = x;
        dupdate(xx, yy, x, y);
    }
    if (itv != ver.begin() && itv == --ver.end()) {
        itv--;
        yy = (*itv);
        xx = x;
        dupdate(xx, yy, x, y);
    }
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        int f, s;
        cin >> f >> s;
        add(f, s);
        //cout << fans << " " << sans << " ans" << endl;
    }
    //cout << endl;
    cout << fans << " " << sans << '\n';
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t, f, s;
        cin >> t >> f >> s;
        if (t == 1) {
            add(f, s);
        } else {
            del(f, s);
        }
        cout << fans << " " << sans << '\n';
    }
}

/*
5
1 0
1 1
1 2
0 1
2 1
5
2 1 0
2 1 1
2 1 2
2 0 1
2 2 1
*/

