#include<bits/stdc++.h>

#define pb push_back
#define ld long double

using namespace std;

const int N = 2010;
vector<int> par(N);
vector<bool> used(N);

int find_set(int v){
    if (par[v] == v){
        return v;
    }
    else{
        return par[v] = find_set(par[v]);
    }
}

void union_set(int a, int b){
    b = find_set(b);
    a = find_set(a);
    par[b] = a;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int,int>> v;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        v.pb({a, b});
    }
    int ans = 0;
    for (int i = 0; i < m; i++){
        int cnt = 0, cnt1 = 0;
        fill(used.begin(), used.end(), 0);
        for (int j = 1; j <= n; j++){
            par[j] = j;
        }
        for (int j = i; j < m; j++){
            int a = v[j].first, b = v[j].second;
            if ((!used[a]) && (!used[b])){
                used[a] = 1;
                used[b] = 1;
                cnt++;
                cnt1 += 2;
                union_set(a, b);
            }
            else if ((!used[a]) || (!used[b])){
                used[a] = 1;
                used[b] = 1;
                cnt1++;
                union_set(a, b);
            }
            else if (find_set(a) != find_set(b)){
                cnt--;
                union_set(a, b);
            }
            if (cnt == 1 && cnt1 == n){
                ans += m - j;
                break;
            }
        }
    }
    cout << ans;
    return 0;
}
