#include<iostream>
#include<vector>
#include<deque>
#include<iomanip>
#include<string>
#include<numeric>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
#include<bitset>
#include<cstdio>
#include<cstdlib>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define ll long long
#define ld long double
#define P pair<int, int>

const int N = 5e5;

int n, m;
vector<int> g[N];
bool us[N], dpd[N], dpu[N];

void dfsd(int v) {
    dpd[v] = 0;
    us[v] = 1;
    for (auto u : g[v]) {
        if (!us[u]) {
            dfsd(u);
            dpd[v] |= !dpd[u];
        }
    }
}

void dfsu(int v, int p) {
    int cntw = 0;
    for (auto u : g[v]) {
        if (u != p) cntw += dpd[u];
    }
    int s = sz(g[v]) - 2;
    for (auto u : g[v]) {
        if (u != p) {
            cntw -= dpd[u];
            dpu[u] = !dpu[v] && (cntw == s);
            dfsu(u, v);
            cntw += dpd[u];
        }
    }
}

bool rt[N];

inline int read() {
    int res = 0;
    char c = getchar();
    while (c < '0' || c > '9') c = getchar();
    while (c >= '0' && c <= '9') {
        res = res * 10 + c - '0';
        c = getchar();
    }
    return res;
}

int main() {
    n = read(), m = read();
    for (int i = 0; i < m; i++) {
        int v = read(), u = read();
        v--;
        u--;
        g[v].pb(u);
        g[u].pb(v);
    }
    for (int i = 0; i < n; i++) {
        if (!us[i]) {
            rt[i] = 1;
            dfsd(i);
            int cntw = 0;
            for (auto j : g[i]) {
                if (dpd[j]) cntw++;
            }
            int s = sz(g[i]) - 1;
            for (auto j : g[i]) {
                cntw -= dpd[j];
                dpu[j] = cntw == s;
                cntw += dpd[j];
                dfsu(j, i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        bool t = dpd[i];
        if (!rt[i]) t |= dpu[i];
        cout << !t;
    }
    return 0;
}
