#include<iostream>
#include<vector>
#include<deque>
#include<iomanip>
#include<string>
#include<numeric>
#include<algorithm>
#include<cmath>
using namespace std;

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define ll long long
#define ld long double

const int N = 5e5 + 5;

int p[N], sz[N], cnt;

int get(int v) {
    return p[v] == v ? v : p[v] = get(p[v]);
}

void un(int v, int u) {
    v = get(v);
    u = get(u);
    if (v != u) {
        if (sz[v] > sz[u]) {
            swap(v, u);
        }
        p[v] = u;
        sz[u] += sz[v];
        cnt--;
    }
}

void init(int n) {
    for (int i = 0; i < n; i++) {
        p[i] = i;
        sz[i] = 1;
    }
    cnt = n;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> v(m), u(m);
    for (int i = 0; i < m; i++) {
        cin >> v[i] >> u[i];
        v[i]--;
        u[i]--;
    }
    ll ans = 0;
    for (int i = 0; i < m; i++) {
        init(n);
        for (int j = i; j < m; j++) {
            un(v[j], u[j]);
            if (cnt == 1) {
                ans += m - j;
                break;
            }
        }
    }
    cout << ans;
    return 0;
}
