#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;
map<int, set<int>> xx, yy;
map<pair<int, int>, int> cnt;
#define endl '\n'

int ans1 = 0;
int ans2 = 0;

bool isExtr(int n) {
	return ((!((n & 1) & ((n >> 2) & 1))) & (!(((n >> 1) & 1) & ((n >> 3) & 1))));
}

bool isInner(int n) {
	return n == 15;
}



void add(int x, int y, int val) {
	int was = cnt[{x, y}];
	cnt[{x, y}] += val;
	int cur = cnt[{x, y}];
	if (isExtr(was)) {
		ans1--;
	}
	if (isInner(was)) {
		ans2--;
	}
	if (isExtr(cur)) {
		ans1++;
	}
	if (isInner(cur)) {
		ans2++;
	}
}

// URDL

void add(int x, int y) {
	if (xx[x].empty()) {
		add(x, y, 0);
	} else if (*xx[x].begin() > y) {
		add(x, y, 1);
		add(x, *xx[x].begin(), 4);
	} else if (*xx[x].rbegin() < y) {
		add(x, y, 4);
		add(x, *xx[x].rbegin(), 1);
	} else {
		add(x, y, 5);
	}
	xx[x].insert(y);

	if (yy[y].empty()) {
		add(x, y, 0);
	} else if (*yy[y].begin() > x) {
		add(x, y, 8);
		add(*yy[y].begin(), y, 2);
	} else if (*yy[y].rbegin() < x) {
		add(x, y, 2);
		add(*yy[y].rbegin(), y, 8);
	} else {
		add(x, y, 10);
	}
	yy[y].insert(x);
	ans1++;
}



void del(int x, int y) {
	xx[x].erase(y);
	yy[y].erase(x);
	if (xx[x].empty()) {
		add(x, y, 0);
	} else if (*xx[x].begin() > y) {
		add(x, y, -1);
		add(x, *xx[x].begin(), -4);
	} else if (*xx[x].rbegin() < y) {
		add(x, y, -4);
		add(x, *xx[x].rbegin(), -1);
	} else {
		add(x, y, -5);
	}

	if (yy[y].empty()) {
		add(x, y, 0);
	} else if (*yy[y].begin() > x) {
		add(x, y, -8);
		add(*yy[y].begin(), y, -2);
	} else if (*yy[y].rbegin() < x) {
		add(x, y, -2);
		add(*yy[y].rbegin(), y, -8);
	} else {
		add(x, y, -10);
	}
	ans1--;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		add(x, y);
	}
	cout << ans1 << " " << ans2 << endl;
	int q;
	cin >> q;
	while (q--) {
		int t, x, y;
		cin >> t >> x >> y;
		if (t == 1) {
			add(x, y);
		} else {
			del(x, y);
		}
		cout << ans1 << " " << ans2 << endl;
	}
}
