#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

const int MAXN = 50000 + 228;

int parent[MAXN];
int sz[MAXN];

int get(int v) {
	if (parent[v] == v)
		return v;
	return parent[v] = get(parent[v]);
}

int cnt;

void unite(int u, int v) {
	u = get(u);
	v = get(v);
	if (u == v)
		return;
	cnt--;
	if (sz[v] > sz[u]) {
		swap(u, v);
	}
	parent[v] = u;
	if (sz[v] == sz[u]) {
		sz[u]++;
	}
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<pair<int, int>> edges(m);
	for (int i = 0; i < m; i++) {
		cin >> edges[i].first >> edges[i].second;
		edges[i].first--;
		edges[i].second--;
	}
	int ans = 0;
	for (int l = 0; l < m; l++) {
		for (int i = 0; i < n; i++) {
			parent[i] = i;
		}
		cnt = n;
		int r;
		for (r = l; r <  m && cnt != 1; r++) {
			unite(edges[r].first, edges[r].second);
		}
		if (cnt == 1)
		ans += m - r + 1;
	}
	cout << ans << endl;
}
