#include <iostream>
#include<bits/stdc++.h>
using namespace std;
const int max_n = 5e5 + 1;
int n;
vector<bool> dp(max_n), dp1(max_n), used(max_n);
vector<int> gr[max_n];

void dfs1(int v, int p) {
    used[v] = 1;
    for(int i : gr[v]) {
        if (i != p)
        dfs1(i, v);
    }
    
    for(int to1 : gr[v]) {
        if (to1 == p) continue;
        bool bad = false;
        for(int to2 : gr[to1]) {
            if (to2 == v) continue;
            if (!dp[to2]) bad = true;
        }
        if (!bad) {
            dp[v] = true;
            break;
        }
    }
    
}

void dfs2(int v, int p, int p1, int p2) {
    used[v] = 2;
    bool bad = false;
    if (p != -1) {
    for(int i : gr[p]) {
        if (i == v) continue;
        if (i == p1) {
            bool good = false;
            if (dp1[i]) good = true;
            
            for(int to1 : gr[i]) {
                if (to1 == p2) continue;
                if (to1 == p) continue;
                bool cal = true;
                for(int to2 : gr[to1]) {
                    if (to2 == i) continue;
                    if (!dp[to2]) cal = false;
                }
                if (cal) good = true;
            }
            if (!good) bad = true;
        }else{
            if (!dp[i]) bad = true;
        }
        
        if (bad) break;
    } 
    
    }else bad = true;
    
    dp1[v] = !bad;
    
    for(int i : gr[v]) {
        if (i == p) continue;
        dfs2(i, v, p, p1);
    }
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int m;
    cin >> n >> m;
    if (m >= n) while(true);
    for(int i = 0;i < m;i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--; v2--;
        gr[v1].emplace_back(v2);
        gr[v2].emplace_back(v1);
    }
    
    for(int i = 0;i < n;i++) {
        if (used[i] == 0) dfs1(i, -1);
    }
    
    //for(int i = 0;i < n;i++) cout << dp[i];
    
    
    for(int i = 0;i < n;i++) {
        if (used[i] != 2) dfs2(i, -1, -1, -1);
    }
    
    //cout << '\n';
    //for(int i = 0;i < n;i++) cout << dp1[i];
    
    //cout << '\n';
    
    for(int i = 0;i < n;i++) cout << !(dp1[i] || dp[i]);
}
