#include <iostream>
#include<bits/stdc++.h>
#pragma O3
using namespace std;
const int max_n = 5e5 + 1;
const int inf = 1e9;
int n;
bool dp[max_n], dp1[max_n], used[max_n];
vector<int> gr[max_n];
bool child[max_n];
vector<bool> child1[max_n];
vector<bool> child2[max_n];

void dfs1(int v, int p) {
    used[v] = 1;
    for(int i : gr[v]) {
        if (i != p)
        dfs1(i, v);
    }
    
    for(int to1 : gr[v]) {
        if (to1 == p) continue;
        bool bad = false;
        for(int to2 : gr[to1]) {
            if (to2 == v) continue;
            if (!dp[to2]) bad = true;
        }
        if (!bad) {
            dp[v] = true;
            break;
        }
    }
    child[v] = true;
    for(int i : gr[v]) {
        if (i != p && !dp[i]) child[v] = false;
    }
    
    
    child1[v].resize(gr[v].size());
    child2[v].resize(gr[v].size());
    
    
    
    int id = -1;
    for(int u = 0;u < gr[v].size();u++) {
        int i = gr[v][u];
        if (i == p) continue;
        if (child[i]) {
            if (id == -1) id = u;
            else id = inf;
        }
    }
    
    for(int i = 0;i < gr[v].size();i++) {
        if (gr[v][i] == p) continue;
        if (id != i && id != -1) child1[v][i] = true;
        else child1[v][i] = false;
    }
    
    
    
    
    id = -1;
    for(int u = 0;u < gr[v].size();u++) {
        int i = gr[v][u];
        if (i == p || dp[i]) continue;
        if (id == -1) id = u;
        else id = inf; 
    }
    
    for(int i = 0;i < gr[v].size();i++) {
        if (gr[v][i] == p) continue;
        if (id != 1 && id != i) child2[v][i] = true;
        else child2[v][i] = false;
    }
    
}

void dfs2(int v, int p, int p1, int id, int id1) {
    used[v] = 0;
    bool bad = false;
    if (p != -1) {
    bad = child2[p][id];
    
    if (p1 != -1 && !dp1[p1] && !child1[p1][id1]) bad = true;
    }else bad = true;
    
    dp1[v] = !bad;
    
    for(int u = 0;u < gr[v].size();u++) {
        int i = gr[v][u];
        if (i == p) continue;
        dfs2(i, v, p, u, id);
    }
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int m;
    cin >> n >> m;
    if (m >= n) while(true);
    for(int i = 0;i < m;i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--; v2--;
        gr[v1].emplace_back(v2);
        gr[v2].emplace_back(v1);
    }
    
    for(int i = 0;i < n;i++) {
        if (used[i] == 0) dfs1(i, -1);
    }
    
    for(int i = 0;i < n;i++) {
        if (used[i] == 1) dfs2(i, -1, -1, -1, -1);
    }

    for(int i = 0;i < n;i++) cout << !(dp1[i] || dp[i]);
}
