#include <iostream>
#include<bits/stdc++.h>
//#pragma O3
using namespace std;
const int max_n = 2e3 + 1;


struct dsu {
    int parent[max_n];
    int cnt;
    
    dsu(int n) {
        cnt = n;
        for(int i = 0;i < n;i++) parent[i] = i;
    }
    
    int get(int v) {
        if (v == parent[v]) return v;
        return parent[v] = get(parent[v]);
    }
    
    void mer(int a, int b) {
        a = get(a);
        b = get(b);
        if (a != b) {
            parent[a] = b;
            cnt--;
        }
    }
};



int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    long long ans = 0;
    pair<int, int> edge[m];
    for(int i = 0;i < m;i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--; v2--;
        edge[i] = {v1, v2};
    }
    
    for(int l = 0;l < m;l++) {
        dsu a = dsu(n);
        int v = l;
        while(v != m && a.cnt != 1) {
            a.mer(edge[v].first, edge[v].second);
            v++;
        }
        ans += m - v;
        if (a.cnt == 1) ans++;
    }
    
    cout << ans;
}
