#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e5;
vector<int> g[MAXN];
int dp1[MAXN];
map<int, int> dp2[MAXN];
int p[MAXN];

void dfs1(int v) {
    dp1[v] = 0;
    for (auto u : g[v]) {
        if (u != p[v]) {
            p[u] = v;
            dfs1(u);
            if (dp1[u] == 0) {
                dp1[v] = 1;
            }
        }
    }
}

void dfs2(int v) {
    /// dp2[v].resize((int)g[v].size() - 1, 0);
    int cnt = 0;
    if (v != 0) {
        if (dp2[v][p[v]] == 0) {
            cnt++;
        }
    }
    for (auto u : g[v]) {
        if (u != p[v]) {
            if (dp1[u] == 0) {
                cnt++;
            }
        }
    }
    for (auto u : g[v]) {
        if (u != p[v]) {
            if (cnt == 0) {
                dp2[u][v] = 0;
            } else if (cnt == 1 && dp1[u] == 0) {
                dp2[u][v] = 0;
            } else {
                dp2[u][v] = 1;
            }
        }
    }
    for (auto u : g[v]) {
        if (u != p[v]) {
            dfs2(u);
        }
    }
}

main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (n == 1) {
        cout << "1";
        return 0;
    }
    p[0] = -1;
    dfs1(0);
    dfs2(0);
    for (int i = 0; i < n; ++i) {
        int res = 1;
        for (auto u : g[i]) {
            if (u != p[i]) {
                if (dp1[u] == 0) {
                    res = 0;
                }
            }
        }
        if (i != 0) {
            if (dp2[i][p[i]] == 0) {
                res = 0;
            }
        }
        cout << res;
    }
    return 0;
}
