#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
//#define int ll
//define double ld
#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;
/*
using namespace __gnu_pbds;
using supset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
*/
using ll = long long;
using ld = long double;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;
using pii = pair <int, int>;

const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete(void*) {}

template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
vector <vector <int>> g;
vector <int> cnt;
vector <int> grundy, pre, up, ans;
void dfs(int v, int p = -1)
{
    pre[v] = p;
    for (auto &to : g[v])
    {
        if (to == p)
            continue;
        dfs(to, v);
        if (!grundy[to])
            cnt[v]++;
    }
    if (cnt[v])
        grundy[v] = 1;
    else
        grundy[v] = 0;
}
void dfsans(int v, int p = -1)
{
    if (p == -1)
        up[v] = 0;
    for (auto &to : g[v])
    {
        if (to == p)
            continue;
        if (!grundy[to])
            cnt[v]--;
        if (p != -1 && !(up[v] ^ 1))
            cnt[v]++;
        int cur = (cnt[v] ? 1 : 0);
        up[to] = cur ^ 1;
        if (!cur)
            cnt[to]++;
        if (cnt[to])
            ans[to] = 1;
        else
            ans[to] = 0;
        ans[to] ^= 1;
        if (!cur)
            cnt[to]--;
        if (!grundy[to])
            cnt[v]++;
        if (p != -1 && !(up[v] ^ 1))
            cnt[v]--;
        dfsans(to, v);
    }
}
signed main()
{
    //Start();
    int n, m;
    scanf("%d %d", &n, &m);
    //cin >> n >> m;
    g.resize(n);
    cnt.resize(n);
    grundy.resize(n), pre.resize(n, -2);
    for (int i = 0; i < m; ++i)
    {
        int u, v;
        //cin >> u >> v, --u, --v;
        scanf("%d %d", &u, &v);
        --u, --v;
        g[u].pb(v);
        g[v].pb(u);
    }
    ans.resize(n), up.resize(n);
    for (int i = 0; i < n; ++i)
    {
        if (pre[i] == -2)
        {
            dfs(i);
            ans[i] = grundy[i] ^ 1;
            dfsans(i);
        }
    }
    for (auto i : ans)
        printf("%d", i);
    return 0;
}

