#include<bits/stdc++.h>
using namespace std;
struct Edge {
    int u, v, w;
    Edge(int u_=0, int v_=0, int w_=0) {
        u = u_;
        v = v_;
        w = w_;
    }
};

bool operator < (Edge a, Edge b) {
    return a.w < b.w;
}

vector<int> parent;

int get_pr(int v) {
    if (v == parent[v]) return v;
    return parent[v] = get_pr(parent[v]);
}

void merge1(int u, int v) {
    int a = get_pr(u), b = get_pr(v);
    parent[b] = a;
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<Edge> g;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g.push_back(Edge(a, b, i));
        g.push_back(Edge(b, a, i));
    }
    sort(g.begin(), g.end());
    long long ans = 0;
    for(int i = 0; i < m; i++) {
        parent.resize(n);
        for (int j = 0; j < n; ++j) parent[j] =j;
        bool d = false;
        int maxx = i;
        for (auto el: g) {
            if (d || el.w == i) {
                d = true;
                int a = get_pr(el.v), b = get_pr(el.u);
                if (a != b) {
                    merge1(el.u, el.v);
                    maxx = max(maxx, el.w);
                }
            }
        }
        bool k = true;
        for (int i = 0; i < n; i++) {
            if (get_pr(i) != get_pr(0)) k = false;
        }
        if (k)
            ans += m - maxx;
    }
    cout << ans;
}
