#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 5e5 + 5;

int n, m;
int h[N];
bool used[N], used_dfs[N], used_bfs[N], dp[N];
vector<int> g[N];

void dfs1(int v) {
  used[v] = true;
  for (int u : g[v]) {
    if (!used[u]) {
      h[u] = h[v] + 1;
      dfs1(u);
    }
  }
}

void solve1() {
  for (int v = 1; v <= n; ++v) {
    if (sz(g[v]) == 1) {
      dfs1(v);
      break;
    }
  }
  for (int v = 1; v <= n; ++v) {
    if (h[v] % 2 == 0 && (n - h[v]) % 2 == 1) {
      cout << 1;
    } else {
      cout << 0;
    }
  }
  cout << "\n";
}

void dfs(int v, int p) {
  used_dfs[v] = true;
  for (int u : g[v]) {
    if (u == p) continue;
    if (!used_dfs[u]) {
      dfs(u, v);
      dp[v] |= !dp[u];
    }
  }
}

void bfs(int s) {
  used_bfs[s] = true;
  queue<pii> Q;
  Q.push(mp(s, 0));
  while (!Q.empty()) {
    int v = Q.front().x, p = Q.front().y;
    Q.pop();
    fill(used_dfs + 1, used_dfs + n + 1, false);
    dfs(v, p);
    for (int u : g[v]) {
      if (u == p) continue;
      if (!used_bfs[u]) {
        dp[u] |= !dp[v];
        used_bfs[u] = true;
        Q.push(mp(u, v));
      }
    }
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  //freopen("output.txt", "r", stdin);
#endif // LOCAL
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  cin >> n >> m;
  for (int i = 1; i <= m; ++i) {
    int v, u;
    cin >> v >> u;
    g[v].pb(u);
    g[u].pb(v);
  }
  if (n == 1) {
    cout << "1\n";
    return 0;
  }
  int cnt1 = 0, cnt2 = 0, cnt3 = 0;
  for (int v = 1; v <= n; ++v) {
    if (sz(g[v]) == 1) ++cnt1;
    else if (sz(g[v]) == 2) ++cnt2;
    else if (sz(g[v]) == 3) ++cnt3;
  }
  if (cnt1 == 2 && cnt2 == n - 2) {
    solve1();
    return 0;
  }
  int s = 0, n1 = n;
  for (int bit = 0; bit <= 20 && n1; ++bit) {
    if ((n >> bit) & 1) {
      n1 -= (1 << bit);
      ++s;
    }
  }
  if (n1 == 0 && cnt1 == (1 << (s - 1)) && cnt2 == 1 && cnt3 == (n - (1 << (s - 1)) - 1)) {
    solve1();
    return 0;
  }
  for (int v = 1; v <= n; ++v) {
    if (!used_bfs[v]) {
      bfs(v);
    }
    /*fill(used_dfs + 1, used_dfs + n + 1, false);
    fill(dp + 1, dp + n + 1, false);
    dfs(v);*/
    cout << !dp[v];
  }
  cout << endl;

  return 0;
}
