#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 5e4 + 5, M = 2e5 + 5;

int n, m;
int p[N], sz[N];
pii edges[M];

int get(int v) {
  return (v == p[v] ? v : p[v] = get(p[v]));
}

bool unite(int v, int u) {
  v = get(v);
  u = get(u);
  if (v == u) return false;
  if (sz[v] < sz[u]) {
    p[v] = u;
    sz[u] += sz[v];
  } else {
    p[u] = v;
    sz[v] += sz[u];
  }
  return true;
}

signed main() {
#ifdef LOCAL
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "r", stdin);
#else
  freopen(TASK".in", "r", stdin);
  freopen(TASK".out", "w", stdout);
#endif // LOCAL
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  cin >> n >> m;
  for (int i = 1; i <= m; ++i) {
    cin >> edges[i].x >> edges[i].y;
  }
  ll ans = 0;
  for (int i = 1; i <= m; ++i) {
    for (int v = 1; v <= n; ++v) {
      p[v] = v;
      sz[v] = 1;
    }
    int cnt = n;
    for (int j = i; j <= m; ++j) {
      if (unite(edges[j].x, edges[j].y)) {
        cnt--;
      }
      if (cnt == 1) {
        ans += 1ll * (m - j + 1);
        break;
      }
    }
  }
  cout << ans << "\n";

  return 0;
}
