#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 1e5 + 5, C = 1e5 + 5;

int n, q;
pii a[N];
set<int> inx[C], iny[C];
int extrem = 0, intern = 0;

bool check_extrem(pii p) {
  return (p.y == *inx[p.x].begin() || p.y == *inx[p.x].rbegin()) &&
         (p.x == *iny[p.y].begin() || p.x == *iny[p.y].rbegin());
}

bool check_intern(pii p) {
  return (p.y != *inx[p.x].begin() && p.y != *inx[p.x].rbegin()) &&
         (p.x != *iny[p.y].begin() && p.x != *iny[p.y].rbegin());
}

void add_point(pii p) {
  inx[p.x].insert(p.y);
  iny[p.y].insert(p.x);
}

void delete_point(pii p) {
  inx[p.x].erase(p.y);
  iny[p.y].erase(p.x);
}

void get_answer() {
  extrem = 0;
  intern = 0;
  for (int x = 0; x < C; ++x) {
    for (auto y : inx[x]) {
      extrem += check_extrem(mp(x, y));
      intern += check_intern(mp(x, y));
    }
  }
  cout << extrem << " " << intern << "\n";
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  //freopen("output.txt", "r", stdin);
#endif // LOCAL
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  cin >> n;
  for (int i = 1; i <= n; ++i) {
    cin >> a[i].x >> a[i].y;
    add_point(a[i]);
  }
  get_answer();
  cin >> q;
  while (q--) {
    int t;
    pii p;
    cin >> t >> p.x >> p.y;
    if (t == 1) {
      add_point(p);
    } else {
      delete_point(p);
    }
    get_answer();
  }

  return 0;
}
