#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 1e5 + 5, C = 1e5 + 5;

int n, q;
pii a[N];
set<int> inx[C], iny[C];
int extrem = 0, intern = 0;

bool check_extrem(pii p) {
  return (p.y == *inx[p.x].begin() || p.y == *inx[p.x].rbegin()) &&
         (p.x == *iny[p.y].begin() || p.x == *iny[p.y].rbegin());
}

bool check_intern(pii p) {
  return (p.y != *inx[p.x].begin() && p.y != *inx[p.x].rbegin()) &&
         (p.x != *iny[p.y].begin() && p.x != *iny[p.y].rbegin());
}

bool is_up(pii p) {
  return p.y == *inx[p.x].rbegin();
}

bool is_down(pii p) {
  return p.y == *inx[p.x].begin();
}

bool is_left(pii p) {
  return p.x == *iny[p.y].begin();
}

bool is_right(pii p) {
  return p.x == *iny[p.y].rbegin();
}

void add_point(pii p) {
  /// extrems

  if (!inx[p.x].empty()) {
    auto it = inx[p.x].lower_bound(p.y);
    if (it != inx[p.x].begin()) {
      --it;
      extrem -= check_extrem(mp(p.x, *it));
      ++it;
    }
    if (it != inx[p.x].end()) {
      extrem -= check_extrem(mp(p.x, *it));
    }
  }
  if (!iny[p.y].empty()) {
    auto it = iny[p.y].lower_bound(p.x);
    if (it != iny[p.y].begin()) {
      --it;
      extrem -= check_extrem(mp(*it, p.y));
      ++it;
    }
    if (it != iny[p.y].end()) {
      extrem -= check_extrem(mp(*it, p.y));
    }
  }

  /// interns

  if (!inx[p.x].empty()) {
    auto it = inx[p.x].lower_bound(p.y);
    if (it != inx[p.x].begin()) {
      --it;
      intern -= check_intern(mp(p.x, *it));
      ++it;
    }
    if (it != inx[p.x].end()) {
      intern -= check_intern(mp(p.x, *it));
    }
  }
  if (!iny[p.y].empty()) {
    auto it = iny[p.y].lower_bound(p.x);
    if (it != iny[p.y].begin()) {
      --it;
      intern -= check_intern(mp(*it, p.y));
      ++it;
    }
    if (it != iny[p.y].end()) {
      intern -= check_intern(mp(*it, p.y));
    }
  }

  inx[p.x].insert(p.y);
  iny[p.y].insert(p.x);

  /// extrems

  extrem += check_extrem(p);
  if (!inx[p.x].empty()) {
    auto it = inx[p.x].lower_bound(p.y);
    if (it != inx[p.x].begin()) {
      --it;
      extrem += check_extrem(mp(p.x, *it));
      ++it;
    }
    ++it;
    if (it != inx[p.x].end()) {
      extrem += check_extrem(mp(p.x, *it));
    }
    --it;
  }
  if (!iny[p.y].empty()) {
    auto it = iny[p.y].lower_bound(p.x);
    if (it != iny[p.y].begin()) {
      --it;
      extrem += check_extrem(mp(*it, p.y));
      ++it;
    }
    ++it;
    if (it != iny[p.y].end()) {
      extrem += check_extrem(mp(*it, p.y));
    }
    --it;
  }

  /// interns

  intern += check_intern(p);
  if (!inx[p.x].empty()) {
    auto it = inx[p.x].lower_bound(p.y);
    if (it != inx[p.x].begin()) {
      --it;
      intern += check_intern(mp(p.x, *it));
      ++it;
    }
    ++it;
    if (it != inx[p.x].end()) {
      intern += check_intern(mp(p.x, *it));
    }
    --it;
  }
  if (!iny[p.y].empty()) {
    auto it = iny[p.y].lower_bound(p.x);
    if (it != iny[p.y].begin()) {
      --it;
      intern += check_intern(mp(*it, p.y));
      ++it;
    }
    ++it;
    if (it != iny[p.y].end()) {
      intern += check_intern(mp(*it, p.y));
    }
    --it;
  }
}

void delete_point(pii p) {
  /// extrems

  if (!inx[p.x].empty()) {
    auto it = inx[p.x].lower_bound(p.y);
    if (it != inx[p.x].begin()) {
      --it;
      extrem -= check_extrem(mp(p.x, *it));
      ++it;
    }
    ++it;
    if (it != inx[p.x].end()) {
      extrem -= check_extrem(mp(p.x, *it));
    }
    --it;
  }
  if (!iny[p.y].empty()) {
    auto it = iny[p.y].lower_bound(p.x);
    if (it != iny[p.y].begin()) {
      --it;
      extrem -= check_extrem(mp(*it, p.y));
      ++it;
    }
    ++it;
    if (it != iny[p.y].end()) {
      extrem -= check_extrem(mp(*it, p.y));
    }
    --it;
  }
  extrem -= check_extrem(p);

  /// interns

  if (!inx[p.x].empty()) {
    auto it = inx[p.x].lower_bound(p.y);
    if (it != inx[p.x].begin()) {
      --it;
      intern -= check_intern(mp(p.x, *it));
      ++it;
    }
    ++it;
    if (it != inx[p.x].end()) {
      intern -= check_intern(mp(p.x, *it));
    }
    --it;
  }
  if (!iny[p.y].empty()) {
    auto it = iny[p.y].lower_bound(p.x);
    if (it != iny[p.y].begin()) {
      --it;
      intern -= check_intern(mp(*it, p.y));
      ++it;
    }
    ++it;
    if (it != iny[p.y].end()) {
      intern -= check_intern(mp(*it, p.y));
    }
    --it;
  }
  intern -= check_intern(p);

  inx[p.x].erase(p.y);
  iny[p.y].erase(p.x);

  /// extrems

  if (!inx[p.x].empty()) {
    auto it = inx[p.x].lower_bound(p.y);
    if (it != inx[p.x].begin()) {
      --it;
      extrem += check_extrem(mp(p.x, *it));
      ++it;
    }
    if (it != inx[p.x].end()) {
      extrem += check_extrem(mp(p.x, *it));
    }
  }
  if (!iny[p.y].empty()) {
    auto it = iny[p.y].lower_bound(p.x);
    if (it != iny[p.y].begin()) {
      --it;
      extrem += check_extrem(mp(*it, p.y));
      ++it;
    }
    if (it != iny[p.y].end()) {
      extrem += check_extrem(mp(*it, p.y));
    }
  }

  /// interns

  if (!inx[p.x].empty()) {
    auto it = inx[p.x].lower_bound(p.y);
    if (it != inx[p.x].begin()) {
      --it;
      intern += check_intern(mp(p.x, *it));
      ++it;
    }
    if (it != inx[p.x].end()) {
      intern += check_intern(mp(p.x, *it));
    }
  }
  if (!iny[p.y].empty()) {
    auto it = iny[p.y].lower_bound(p.x);
    if (it != iny[p.y].begin()) {
      --it;
      intern += check_intern(mp(*it, p.y));
      ++it;
    }
    if (it != iny[p.y].end()) {
      intern += check_intern(mp(*it, p.y));
    }
  }
}

void get_answer() {
  cout << extrem << " " << intern << "\n";
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  //freopen("output.txt", "r", stdin);
#endif // LOCAL
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  cin >> n;
  for (int i = 1; i <= n; ++i) {
    cin >> a[i].x >> a[i].y;
    add_point(a[i]);
  }
  get_answer();
  cin >> q;
  while (q--) {
    int t;
    pii p;
    cin >> t >> p.x >> p.y;
    if (t == 1) {
      add_point(p);
    } else {
      delete_point(p);
    }
    get_answer();
  }

  return 0;
}
