#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define X first
#define Y second
#define pb push_back
#define sz(a) a.size()
#define int long long
//typedef long long ll;

using namespace std;
using namespace __gnu_pbds;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int pred[50010];
int sz[50010];
int pred2[50010];
int sz2[50010];

int get(int x) {
    if (x == pred[x])
        return x;
    return pred[x] = get(pred[x]);
}

void update(int x, int y) {
    x = get(x);
    y = get(y);
    if (x == y)
        return;
    if (sz[x] > sz[y]) {
        pred[y] = x;
        sz[x] += sz[y];
    } else {
        pred[x] = y;
        sz[y] += sz[x];
    }
}

int get2(int x) {
    if (x == pred2[x])
        return x;
    return pred2[x] = get2(pred2[x]);
}

void update2(int x, int y) {
    x = get2(x);
    y = get2(y);
    if (x == y)
        return;
    if (sz2[x] > sz2[y]) {
        pred2[y] = x;
        sz2[x] += sz2[y];
    } else {
        pred2[x] = y;
        sz2[y] += sz2[x];
    }
}

vector <pair <int, int>> v;

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, x, y;
    cin >> n >> m;
    for (int i = 0; i < n;++i) {
        pred[i] = i;
        pred2[i] = i;
        sz[i] = 1;
        sz2[i] = 1;
    }
    for (int i = 0; i < m; i++) {
        cin >> x >> y;
        x--;
        y--;
        v.push_back({x, y});
    }
    if (m < 100000) {
        int ans = 0;
        for (int i = 0; i < m;) {
            for (int j = 0; j < n; j++) {
                pred[j] = j;
                sz[j] = 1;
            }
            bool ff = false;
            int ind;
            for (int j = i; j < m; j++) {
                update(v[j].X, v[j].Y);
                if (sz[get(v[j].X)] == n) {
                    ff = true;
                    ind = j;
                    break;
                }
            }
            if (!ff)
                break;
            int l = i;
            for (int j = 0; j < n; j++) {
                pred2[j] = j;
                sz2[j] = 1;
            }
            for (int j = ind; j >= i; j--) {
                update2(v[j].X, v[j].Y);
                if (sz2[get2(v[j].X)] == n) {
                    l = j;
                    break;
                }
            }
            ans += (l - i + 1) * (m - ind);
            i = l + 1;
            //cout << i << endl;
        }
        cout << ans << endl;
    } else {
        int ans = 0;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                pred[j] = j;
                sz[j] = 1;
            }
            for (int j = i; j < m; j++) {
                update(v[j].X, v[j].Y);
                if (sz[get(v[j].X)] == n) {
                    ans += (m - j);
                    break;
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}
