#include <bits/stdc++.h>

using namespace std;

const int MAX = 500010;

vector <int> g[500010];

bool dp2[MAX];
bool dp[MAX];
bool ans[MAX];
bool used[MAX];
bool step[MAX];

void dfs(int v, int pr, int x) {
    used[v] = 1;
    step[v] = x;
    for (auto i : g[v]) {
        if (pr != i) {
            dfs(i, v, x ^ 1);
        }
    }
}

void rec(int v, int pr = -1) {
    if (step[v] == 0) {
        dp[v] = 1;
        for (auto u : g[v]) {
            if (u != pr) {
                rec(u, v);
                dp[v] = min(dp[v], dp[u]);
            }
        }
    } else {
        dp[v] = 0;
        for (auto u : g[v]) {
            if (u != pr) {
                rec(u, v);
                dp[v] = max(dp[v], dp[u]);
            }
        }
    }
}

void rec2(int v, int pr = -1) {
    if (step[v] == 0) {
        dp2[v] = 0;
        for (auto u : g[v]) {
            if (u != pr) {
                rec2(u, v);
                dp2[v] = max(dp2[v], dp2[u]);
            }
        }
    } else {
        dp2[v] = 1;
        for (auto u : g[v]) {
            if (u != pr) {
                rec2(u, v);
                dp2[v] = min(dp2[v], dp2[u]);
            }
        }
    }
}

void ser(int v, int pr, int st, int xa, int xb) {
    if (st == 0) {
        if (xa == 0)
            ans[v] = false;
        else
            ans[v] = dp[v];
        int k[4] = {0,0,0,0};
        int k2[4] = {0,0,0,0};
        k[xb]++;
        k2[xa]++;
        //multiset <int> k2 = {xa};
        for (auto su : g[v]) {
            if (pr != su) {
                k[(int)dp2[su]]++;
            }
        }
        for (auto su : g[v]) {
            if (pr != su) {
                k2[(int)dp[su]]++;
            }
        }
        for (auto u : g[v]) {
            if (u != pr) {
                k[(int)dp2[u]]--;
                k2[(int)dp[u]]--;
                /*/for (auto su : g[v]) {
                    if (pr != su && su != u) {
                        k = max(k, dp2[su]);
                    }
                }
                for (auto su : g[v]) {
                    if (pr != su && u != su) {
                        k2 = min(k2, dp[su]);
                    }
                }/*/
                int ansk = 0;
                if (k[1] != 0)
                    ansk = 1;
                int ansk2 = 1;
                if (k2[0] != 0)
                    ansk2 = 0;
                ser(u, v, 1, ansk, ansk2);
                k[(int)dp2[u]]++;
                k2[(int)dp[u]]++;
            }
        }
    } else {
        if (xa == 0)
            ans[v] = false;
        else
            ans[v] = dp2[v];
        int k[4] = {0, 0, 0, 0};
        int k2[4] = {0, 0, 0, 0};
        k[xa] = 1;
        k2[xb] = 1;
        for (auto su : g[v]) {
            if (pr != su) {
                k2[(int)dp[su]]++;
            }
        }
        for (auto su : g[v]) {
            if (pr != su) {
                k[dp2[su]]++;
            }
        }
        for (auto u : g[v]) {
            if (u != pr) {
                k[dp2[u]]--;
                k2[dp[u]]--;
                int ansk2 = 0;
                int ansk = 1;
                if (k2[1] != 0)
                    ansk2 = 1;
                if (k[0] != 0)
                    ansk = 0;
                ser(u, v, 0, ansk2, ansk);
                k[dp2[u]]++;
                k2[dp[u]]++;
            }
        }
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int a, b;
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        g[a - 1].emplace_back(b - 1);
        g[b - 1].emplace_back(a - 1);
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, -1, 0);
            rec(i);
            rec2(i);
            ser(i, -1, 0, 1, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    return 0;
}
