#include <bits/stdc++.h>
using namespace std;

pair<long long, long long> edges[200005];
vector<long long> g[200005];
bool visited[200005];

void dfs(long long v){
    if(visited[v])
        return;
    visited[v] = true;
    for(auto x : g[v])
        dfs(x);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    long long n, m;
    cin >> n >> m;
    for(long long i = 1; i <= m; ++i){
        cin >> edges[i].first >> edges[i].second;
    }

    long long res = 0;
    for(long long i = 1; i <= m; ++i){
        long long x = edges[i].first;
        long long y = edges[i].second;
        if(x > y)
            swap(x, y);
        for(long long j = min(x, m + 1); j <= min(y, m); ++j){
            g[edges[j].first].push_back(edges[j].second);
            g[edges[j].second].push_back(edges[j].first);
        }

        dfs(1);
        bool ok = true;
        for(long long j = 1; j <= n; ++j){
            if(!visited[j])
                ok = false;
            visited[j] = false;
            g[j].clear();
        }

        if(ok){
            res++;
        }
    }

    cout << res << "\n";
    return 0;
}
