#include <bits/stdc++.h>
using namespace std;

vector<int> graph[500005];
bool dp[500005]; ///is this winning?

void dfs1(int v, int p){
    bool canWin = true;
    for(auto x : graph[v]){
        if(x == p)
            continue;
        dfs1(x, v);
        canWin = canWin && (!dp[x]);
    }
    dp[v] = canWin;
}

int height[500005];
bool visited[500005];

void dfs(int v, int h){
    if(visited[v])
        return;
    visited[v] = true;
    height[v] = h;
    for(auto x : graph[v]){
        dfs(x, h + 1);
    }
}

int st1, st2, st3, stm;

int power(int x, int y){
    if(y == 0)
        return 1;
    if(y % 2 == 0)
        return power(x, y / 2) * power(x, y / 2);
    return power(x, y - 1) * x;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int x, y;
        cin >> x>> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    for(int i = 1; i <= n; ++i){
        if(graph[i].size() == 1)
            st1++;
        else if(graph[i].size() == 2)
            st2++;
        else if(graph[i].size() == 3)
            st3++;
        else
            stm++;
    }

    int lg = log2(n + 1);
    if(!stm && ((!st3 && st1 == 2) || (st2 == 1 && power(2, lg) == n + 1))){
        int tstart = 0;
        for(int i = 1; i <= n; ++i){
            if(graph[i].size() == 1){
                tstart = i;
                break;
            }

        }
        dfs(tstart, 1);

        for(int i = 1; i <= n; ++i){
            int l = height[i] - 1;
            int r = n - height[i];
            if(l % 2 == 1 || r % 2 == 1){
                cout << "0";
            }else{
                cout << "1";
            }
        }
    }else{
        for(int i = 1; i <= n; ++i){
            dfs1(i, 0);
            if(dp[i])
                cout << 1;
            else
                cout << 0;
        }
    }


    cout << "\n";
    return 0;
}

/*
5 4
1 2
1 3
2 5
2 4

*/
