#include <bits/stdc++.h>
using namespace std;

pair<int, int> edges[200005];
vector<int> graph[50005];
bool visited[50005];

void dfs(int v, int p){
    if(visited[v])
        return;
    visited[v] = true;

    for(auto x : graph[v]){
        if(x == p || x == v)
            continue;
        dfs(x, v);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        cin >> edges[i].first >> edges[i].second;
        edges[i].first--;
        edges[i].second--;
    }

    int res = 0;
    for(int z = 0; z < m; ++z){
        int x = edges[z].first;
        int y = edges[z].second;
        if(x > y)
            swap(x, y);
        for(int i = x; i <= min(y, m); ++i){
            int v1 = edges[i].first;
            int v2 = edges[i].second;
            graph[v1].push_back(v2);
            graph[v2].push_back(v1);
        }

        dfs(0, -1);
        bool ok = true;
        for(int i = 0; i < n; ++i){
            if(!visited[i])
                ok = false;
            visited[i] = false;
            graph[i].clear();
        }

        if(ok){
            res++;
        }
    }

    cout << res << "\n";
    return 0;
}

/*
4 5
1 2
2 3
1 4
1 3
1 2
*/
