#include <bits/stdc++.h>
using namespace std;

int p[200005];
pair<int, int> ed[200005];

int getParent(int v){
    if(p[v] == v)
        return v;
    return p[v] = getParent(p[v]);
}

int main()
{
    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= m; ++i){
        cin >> ed[i].first >> ed[i].second;
    }

    int res = 0;
    for(int k = 1; k <= m; ++k){
        for(int i = 1; i <= n; ++i){
            p[i] = i;
        }

        int x = ed[k].first;
        int y = ed[k].second;

        for(int i = x; i <= min(y, m); ++i){
            int x1 = ed[i].first;
            int y1 = ed[i].second;

            int p1 = getParent(x1);
            int p2 = getParent(y1);

            p[p1] = p2;
        }

        int ulP = getParent(1);
        bool ok = true;
        for(int i = 1; i <= n; ++i){
            if(getParent(i) != ulP)
                ok = false;
        }

        if(ok)
            res++;
    }

    cout << res << "\n";
    return 0;
}

/*
4 5
1 2
2 3
1 4
1 3
1 2
---
2

4 4
1 2
2 4
1 3
1 4
---
3
*/
