#include <bits/stdc++.h>
using namespace std;

//ako interval ne sadrzi jednu od artikulacionih grana, onda graf nije konnekted

pair<int, int> edges[200005];
bool isArti[200005];

vector<int> graph[50005];
bool visited[50005];
int dp[50005];
int height[500005];

void dfs(int v, int p, int h){
    if(visited[v])
        return;
    visited[v] = true;
    height[v] = h;

    int mn = h;
    for(auto x : graph[v]){
        if(x == p)
            continue;
        if(visited[x]){
            mn = min(mn, height[x]);
        }else{
            dfs(x, v, h + 1);
            mn = min(mn, dp[x]);
        }
    }

    dp[v] = mn;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= m; ++i){
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
        edges[i] = {x, y};
    }

    dfs(1, 0, 0);
    for(int i = 1; i <= m; ++i){
        int x = edges[i].first;
        int y = edges[i].second;
        if(height[x] > height[y])
            swap(x, y);
        if(dp[y] > height[x]){
            isArti[i] = true;
        }
    }

    vector<int> vk;
    for(int i = 1; i <= m; ++i){
        if(isArti[i])
            vk.push_back(i);
    }

    int res = 0;
    for(int i = 1; i <= m; ++i){
        if(edges[i].first <= vk[0] && edges[i].second >= vk[vk.size() - 1]){
            res++;
        }
    }
    cout << res << "\n";
    return 0;
}
