#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <stack>
#include <set>
#include <queue>
#include <vector>

#define ll long long
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ss string
#define pb push_back

const int N = int(2e3) + 5, mod = int(1e9) + 7, INF = int(1e9);

using namespace std;

ll n, m, ans;

bool used[N];

vector < pair < int, int > > g[N];

void dfs(int v, int i, int j){
    used[v] = 1;
    for(auto e : g[v]){
        if(i <= e.first && e.first <= j && !used[e.second]){
            dfs(e.second, i, j);
        }
    }
}

int main(){
    speed;
    cin >> n >> m;
    int m1 = 0;
    for(int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        g[u].pb({i, v});
        g[v].pb({i, u});
    }
    for(int i = 1; i <= m; i++){
        for(int j = i; j <= m; j++){
            for(int h = 1; h <= n; h++){
                used[h] = 0;
            }
            dfs(1, i, j);
            bool cond = 0;
            for(int h = 1; h <= n; h++){
                if(!used[h]){
                    cond = 1;
                    break;
                }
            }
            if(!cond){
                //cout << i << " " << j << endl;
                ans++;
            }
        }
    }
    cout << ans;
}
