#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <stack>
#include <set>
#include <queue>
#include <vector>

#define ll long long
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ss string
#define pb push_back

const int N = int(1e5) + 5, mod = int(1e9) + 7, INF = int(1e9);

using namespace std;

int n, m, w[N];

vector < int > g[N];

void dfs(int v, int cnt){
    w[v] = cnt;
    for(auto e : g[v]){
        if(!w[e])
            dfs(e, cnt + 1);
    }
}

int main(){
    cin >> n >> m;
    for(int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    for(int i = 1; i <= n; i++){
        if(g[i].size() == 1){
            dfs(i, 1);
            break;
        }
    }
    for(int i = 1; i <= n; i++){
//        cout << w[i] << " " << i << endl;
        if((n - w[i] + 1) % 2 == 1 && w[i] % 2 == 1){
            cout << 1;
        }
        else{
            cout << 0;
        }
  //      cout << endl;
    }
}
